
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




if ($LSC{Funktionen} && $LSC{Funktionen} eq 'show') {
	$funktionen{'Guestbook'} = \&Guestbook;
}

sub GuestbookIpGeSperrt {
	my $sth = $LSC{MySQL}->prepare("SELECT count(*) FROM lsc_guestbook WHERE IP='".remote_addr()."' 
				and (TO_DAYS(NOW()) - TO_DAYS(Timestamp)) = 0");
	$sth->execute();

	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0];

}

sub Guestbook {
	my $action = shift || "";
	my $special = shift || 0;
	$special = 0 if $special=~/[^0-9]/;
	my $check=0;

	my $sth = $LSC{MySQL}->prepare("SELECT count(*)	FROM lsc_guestbook WHERE 1");
	$sth->execute();
	my $count = $sth->fetchrow_arrayref();
	$sth->finish;

	print "<table cellspacing=0 width=100%>";
		print "<tr>";
			print "<td class=Headline>Gstebuch: ($count->[0] Eintrge)</td>";
		print "<tr>";
		print "<tr><td>";


	if ($q->param("submit")) {
		if (GuestbookIpGeSperrt()) {
			print "Du darfst Heute keinen Eintrag mehr einfgen!".br;
			$check=1;
		} elsif ($q->param("Name") && $q->param("Message")) {
			$check=1;
			my $Name = $q->param("Name");
			my $Message = $q->param("Message");
			$Name =~s/\<.*\>//gg;
			$Message =~s/\<.*\>//gg;
			
			my $Email = "";
			if ($q->param("Email")) {
				$Email = $q->param("Email");
				$Email =~s/\<.*\>//gg;
			}
			
			my $Homepage = "";
			if ($q->param("Homepage")) {
				$Homepage = $q->param("Homepage");
				$Homepage =~s/\<.*\>//gg;
				$Homepage =~s/http\:\/\///gg;
			}

			
			$Name = $LSC{MySQL}->quote($Name);
			$Message = $LSC{MySQL}->quote($Message);
			$Homepage = $LSC{MySQL}->quote($Homepage);
			$Email = $LSC{MySQL}->quote($Email);

			#speichern
			my $sth = $LSC{MySQL}->do("insert into lsc_guestbook (Name, Email, Homepage, Message, IP) 
				Values ($Name, $Email, $Homepage, $Message, '".remote_addr()."')");
		} else {
			print "Bitte Name und Nachricht ausfllen!".br;
		}
	}


	if ($special > $count->[0]) {
		$special = 0;
	}
	
	my $Start = $special || 0;
	my $Ende = 10;

	print "Seiten: " if $count->[0] > 10;
	print "<a href=\"$scriptname?Action=Guestbook&special=0\">[Start]</a> " if $count->[0] > 10;
	for (my $i=1; $i*10 < $count->[0] ; $i++) {
		print "<a href=\"$scriptname?Action=Guestbook&special=".($i*10)."\">[$i]</a> ";
	}
	print br.br  if $count->[0] > 10;
	$sth = $LSC{MySQL}->prepare("SELECT Name, Email, Homepage, Message, DATE_FORMAT(Timestamp,'%e. %M %Y (%T)') 
					FROM lsc_guestbook WHERE 1 order by Timestamp desc limit $Start,$Ende");
	$sth->execute();
	
	while (my $ref = $sth->fetchrow_arrayref()) {
		print "<table cellspacing=0 width=100%>";
		print "<tr>";
			print "<td class=Headline>$ref->[4]</td>";
		print "</tr>";
		print "<tr>";
			print "<td><b>Name:</b> <a href=\"mailto:$ref->[1]\">$ref->[0]</a></td>" if $ref->[1];
			print "<td><b>Name:</b> $ref->[0]</td>" if !$ref->[1];
		print "</tr>";
		print "<tr><td><b>Homepage:</b> <a target=\"_blank\" href=\"http://$ref->[2]\">$ref->[2]</a></td></tr>" if $ref->[2];
		print "<tr>";
			$ref->[3] =~s/\n/\<br\>/gg;
			print "<td>$ref->[3]</td>";
		print "</tr>";
		print "</table>".br.br;
	}
	$sth->finish;

	unless ($check) {
		print br.br;
		print "<br>Neuen Eintrag einfgen:</b>".br;
			print $q->start_form('post',"$scriptname?Action=Guestbook");
		
				print "Name:".br;
				print $q->textfield('Name', "", 30).br.br;
				print "Email:".br;
				print $q->textfield('Email', "", 30).br.br;
				print "Homepage:".br;
				print $q->textfield('Homepage', "", 30).br.br;
				print "Kommentar:".br;
				print br;
				print $q->textarea('Message','',5,50).br.br;
		
				print submit('submit');
				print end_form();
	}

	print "</td></tr>";
	print "</table>";

}

		
1
