
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



	
	
	########					######
	##########   Ab hier nichts verndern!!!   ###########
	########					######



#use Time::HiRes qw(gettimeofday tv_interval);
$LSC{Times}= {};
sub TimerStart {
#	if ($LSC{DebugModus}) {
#		$LSC{Times}{$_[0]} = [gettimeofday]; 
#	}
}
sub TimerStop {
#	if ($LSC{DebugModus}) {
#		unless ($LSC{Times}->{$_[0]}) {
#			$LSC{Times}{$_[0]} = "?";
#			return;
#		}
#		$LSC{Times}{$_[0]} = tv_interval([@{$LSC{Times}->{$_[0]}}]);
#	}
}
sub TimerShow {
#	if ($LSC{DebugModus}) {
#		TimerStop("Gesamt");
#		print '<table>';
#		foreach  (sort keys %{$LSC{Times}}) {
#			print '<tr><td>'.$_.'</td><td>'.$LSC{Times}{$_}.'</td></tr>'; 
#		}
#		print '</table>';
#	}
}


# module einbinden
my $Timer = "";

# Grundfunktionen:
	$LSC{show_pl} = 'show.pl' unless $LSC{show_pl}; 
	$LSC{user_pl} = 'user.pl' unless $LSC{user_pl}; 
	$LSC{user_unlock_pl} = 'user.unlock.pl' unless $LSC{user_unlock_pl}; 
	$LSC{user_new_pl} = 'user.new.pl' unless $LSC{user_new_pl}; 


# Grundpakete laden
QUERY_STRING_Einlesen();

Require("LSCConfig.pm");
if ($LSC{DebugModus}) {
	$LSC{DebugInfo} = "";
}
TimerStart("Gesamt");
TimerStart("LSCInit.pm");

Require("LSCText.pm");
Require("LSCLayout.pm");
Require("LSCsubs.pm");
Require("LSCCounter.pm");

# UpdateModus?
Require("setup.pm");

# Hilfsfunktionen
Require("LSCTemplate.pm");

Require("LSCsubs.get.pm");
Require("LSCsubs.out.pm");
Require("LSCvote.pm");
Require("LSCMessages.pm");

if ($LSC{GuestBook}) {
	$LSC{GuestBook}=2;
	Require("LSCGuestBook.pm");
}
Require("news.pm");
Require("LSCuser.pm");
Require("session.pm");

$Timer="posix";
TimerStart($Timer);
use POSIX;
TimerStop($Timer);

$Timer="Umgebungsvariablen";
TimerStart($Timer);

	
	# Umgebungsvariablen laden...
	(
	$LSC{date}, 
	$LSC{shortdate}	)	= my_get_date();

	$LSC{refererok} = checkref();

	#Session
	$LSC{username} = '';
	$LSC{userid} = $q->cookie('Userid') || '';

	$LSC{userpass} = '';
	$LSC{usersessionid} = $q->cookie('UserSessionID') || '';
	$LSC{cryptpass} = 'lsc';

	$LSC{TabFunctions} = {1,  \&_Tab_Basketball,
					2, \&_Tab_NHL,
					3, \&_Standings_Tunier,
					4, \&_Standings_PokalTunier,
					5, \&_Tab_Basketball_NBA_New,
					};

	my %Status = qw(1 open 2 closed);
	$LSC{Status} = \%Status;

	my %OpenL = qw(0 all 1 private 2 team 3 private-team);
	#private = user mssen vom admin eingetragen werden, behalten ihren loginnamen
	#T-private = user mssen vom admin eingetragen werden, mit extra teamnamen
	$LSC{OpenL} = \%OpenL;

	$LSC{TeamSeitenKeinPopUp} = $LSC{TeamSeitenImPopUp} ? 0 : 1;
TimerStop($Timer);

$Timer="MySQLConnect";
TimerStart($Timer);
	$LSC{MySQL} = MySQLConnect();
	
TimerStop($Timer);

if ($extern) {
	Require($LSCsettings, 1);
}

$Timer="InitLigaDatenLaden";
TimerStart($Timer);
	InitLigaDatenLaden();
TimerStop($Timer);

$Timer="Init Rest 2";
TimerStart($Timer);

	if ($LSC{PlayerStats}) {
		require $LSCPackagePfad."LSCPlayerStats.pm";
	}

	if ($LSC{LeagueData}{Spielplan}) {
		require $LSCPackagePfad."LSCspielplan.pm";
		$LSC{Spieltag} = SpielplanAktuellerSpieltag($LSC{League});
	}
	if ($LSC{LeagueData}{Playoff}) {
		my @unterstuetztePlayoffTuniere = (0, 
						'2Games_Draw', 
						'BestOf',	
						'PokalBestOf',		
						'DoubleElimination');

		my @unterstuetztePlayoffFunctionen = (0, 
						\&_Standings_Tunier, 
						\&_Standings_Tunier,
						\&_Standings_PokalTunier,
						\&_Standings_DoubleElimination);

		if (my $tunier=$unterstuetztePlayoffTuniere[$LSC{LeagueData}{Playoff}]) {
			$LSC{LeagueData}{PlayoffDaten} = ();
			$LSC{LeagueData}{PlayoffDaten}{$tunier}	= 1;


			$LSC{LeagueData}{PlayoffDaten}{Function} = $unterstuetztePlayoffFunctionen[$LSC{LeagueData}{Playoff}];

			require $LSCPackagePfad."LSCplayoff.pm";
		} else {
			$LSC{LeagueData}{Playoff} = 0;
		}
	}
	
	
TimerStop($Timer);
$Timer="Session";
TimerStart($Timer);
	
	$LSC{LOGIN} = 0;

	if ($LSC{'Action'} eq 'logout') {
		SessionLogout();
	} elsif (Session('IsActiv', $LSC{'Action'})) {
		SessionUserDatenLaden($LSC{userid});
	} else {
		# Guest Session einfgen
		SessionGuest($q->cookie('GuestSessionID'));
	}

TimerStop($Timer);

$Timer="Counter";
TimerStart($Timer);

	Counter_Count();

TimerStop($Timer);
	
	# vars
	
	%Select = ();
	$Select{Game}{From} 		= "lsc_games G1, lsc_games_daten D";
	$Select{Game}{JoinG2} 		= "LEFT JOIN lsc_games G2 ON (G1.Game = G2.Game and G1.ID != G2.ID)";
	$Select{Game}{JoinTeam1}	= "LEFT JOIN lsc_teams T ON T.ID=G1.Team";
	$Select{Game}{JoinTeam2}	= "LEFT JOIN lsc_teams T ON T.ID=G2.Team";
	$Select{Game}{JoinOnG2ID} 	= "LEFT JOIN lsc_games G2 ON G1.Game = G2.Game and G2.ID=";
	$Select{Game}{Where} 		= "D.League=#LEAGUE and D.No=G1.Game";
	$Select{Game}{WhereHome} 	= "D.League=#LEAGUE and D.No=G1.Game and G1.Home=1";

	$Select{SameMain_Group}{From}	= "lsc_teams_league InGrp1, lsc_teams_league InGrp2";
	$Select{SameMain_Group}{Where}	= "InGrp1.League=#LEAGUE and InGrp2.League=#LEAGUE and G1.Team=InGrp1.Team and G2.Team=InGrp2.Team and InGrp1.Main_Group=InGrp2.Main_Group";
	$Select{SameSub_Group}{From}	= "lsc_teams_league InGrp1, lsc_teams_league InGrp2";
	$Select{SameSub_Group}{Where}	= "InGrp1.League=#LEAGUE and InGrp2.League=#LEAGUE and G1.Team=InGrp1.Team and G2.Team=InGrp2.Team and InGrp1.Sub_Group=InGrp2.Sub_Group";
		

####
$LSC{Require} = {};
sub Require {
	if ($LSC{Require}{$_[0]}) {
		return;
	}
	$LSC{Require}{$_[0]} = 1;
	TimerStart($_[0]);
	if ($_[1]) {
		require $_[0];
	} else {
		require $LSCPackagePfad."$_[0]";
	}
	TimerStop($_[0]);

}
sub QUERY_STRING_Einlesen {
	%FORM=();
	my $buffer=$ENV{'QUERY_STRING'} || query_string();
	my @pairs = split(/&/, $buffer);
	foreach my $pair (@pairs) {
		my ($name, $value) = split(/=/, $pair);
		$name =~ tr/+/ /;	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$name =~ s/<!--(.|\n)*-->//g; $name =~ s/<([^>]|\n)*>//g;
		$value =~ tr/+/ /; $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/<!--(.|\n)*-->//g; $value =~ s/<([^>]|\n)*>//g;
		$FORM{$name} = $value;
	}
	
	# werte frs script
	#neu:
	$LSC{League}	= $FORM{'League'} || param('League') || "";
	#Alt:
	$LSC{layout}	= $FORM{'layout'} || 0;
	$LSC{Action}	= $FORM{'Action'} || param('Action') || "";
	$LSC{Action2}	= $FORM{'Action2'} || param('Action2') ||"";
	$LSC{Start}		= $FORM{'Start'} || param('Start') ||"";
	$LSC{special2}		= $FORM{'special2'} || param('special2') ||"";
	$LSC{special}	= defined($FORM{'special'}) ? $FORM{'special'} : (param('Special') ||"");
	$LSC{user}		= $FORM{'user'} || "";

}

sub InitLigaWerte {
	my $League=shift || return;
	
	my $select = "*";
			 
	my $from	= "lsc_leagues L";
	my $where	= "L.League=".$LSC{MySQL}->quote($League);
	my $group	= "";
	my $order	= "";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	return $ref;
}
sub InitLigaDatenLaden {
	$LSC{ligavorhanden} = 0;
	if ($_[0]) {
		#Daten fr besondere Liga Laden:
		$LSC{League} = $_[0];
	}
	unless ($LSC{League}) {
		return;
	}
	if ($LSC{League}=~/[^0-9]/) {
		$LSC{League} = '';
		return;
	}
	
	# grundwerte
	my $ref = InitLigaWerte($LSC{League});
	if ($ref) {
		#Liga vorhanden
		$LSC{LeagueData} = $ref;
		
		$LSC{LeagueData}{NameKurz} = substr($LSC{LeagueData}{Name}, 0, $LSC{LaengeKurzerTeamname});
		if ($LSC{LeagueData}{NameKurz} eq $LSC{LeagueData}{Name}) {
			$LSC{LeagueData}{NameKurz} = $LSC{LeagueData}{Name};
		} else {
			$LSC{LeagueData}{NameKurz} .= "...";
		}

		$LSC{ligavorhanden} = 1;

		$LSC{PlayerStats} = $LSC{LeagueData}{PlayerTeamStats} && $LSC{PlayerStats};
		if ($LSC{LeagueData}{Function}) {
			$LSC{LeagueData}{ExecFunction} = $LSC{TabFunctions}{$LSC{LeagueData}{Function}} ?
								$LSC{TabFunctions}{$LSC{LeagueData}{Function}}: '';

			if ($LSC{LeagueData}{Function} == 1 || $LSC{LeagueData}{Function} == 5) {
				my $s=1;
				$LSC{TabelleDefinitionSpalten} = [
					{K=>TeamNamePos, S=>$s++, Name=>"Team"}, 
					{K=>Won, S=>$s++, Name=>"W"}, 
					{K=>Lost, S=>$s++, Name=>"L"}, 
					{K=>Total, S=>$s++, Name=>"T"}, 
					{K=>PCT, S=>$s++, Name=>'%'}, 
					{K=>GB, S=>$s++, Name=>"GB"}, 
					{K=>Main_Group_Result, S=>$s++, Name=>"Conf"}, 
					{K=>Sub_Group_Result, S=>$s++, Name=>"Div"}, 
					{K=>Home, S=>$s++, Name=>"Home"}, 
					{K=>Road, S=>$s++, Name=>"Road"}, 
					{K=>L10, S=>$s++, Name=>"L10"}, 
					{K=>Streak, S=>$s++, Name=>"Streak"}
					];

				$LSC{TabelleDefinitionSortierung} = [
						{K=>Won, S=>-1},
						{K=>Lost, S=>2},
					];
				#Name,  W as Won,  L as Lost,  D as Draw, LP,  PD, Games

			}
		}		
		
		if ($_[0]) {
			return %LSC;
		}
		return 1;
	}
	#Liga nicht vorhanden
	return;
}





sub MySQLConnect {
	use DBI();
	# Connect to the database.
	$LSC{DBIhost} = "localhost" unless $LSC{DBIhost};

	my $dbh = DBI->connect("DBI:mysql:database=$LSC{DBIdatenbank};host=$LSC{DBIhost}",
                         $LSC{DBIlogin}, $LSC{DBIpassword},
                         {'RaiseError' => 1});
	if ($dbh) {
		return $dbh;
	}	else {
		print $q->header();
		print 'Es konnte keine Verbindung zur Datenbank aufgebaut werden. <br>Sollte diese Nachricht ber lngere Zeit angezeigt werden, dann schicke bitte eine Nachricht an <A HREF="mailto:'.$LSC{errorEmail}.'">'.$LSC{errorEmail}.'</A>. Danke!';
		exit(0);
	}
}
sub MySQLDisconnect {
	  $_[0]->disconnect();
}
sub Mysql_Error {
	my $sth = shift or return;
	print $LSC{TEXT}{Error}[6].br;
	my $caller = join("\n", caller);
	my $err = $sth->errstr || "?";
	my $Message = "
Fehlerbericht vom LigaScript:

*********************
Bei einer MySQL Datenbankanfrage ist ein Fehler aufgetreten:
$err

Position im Script:
$caller
*********************
Sende diese Fehlermeldung an: leaguescript.support\@scroax.net
falls dieser Fehler hufiger auftreten sollte, damit der 
Fehler behoben werden kann.
Bitte bekannte Randbedingungen, wie MySQL, Perl Version usw.
mit angeben.
Ist der Fehler Script bedingt, werde ich schnellstmglich
ein Update zur Verfgung stellen.

-- 
LigaScript/Ligaverwaltung

http://www.scroax.net

copyright 2003 by J.Nass
	";

	my $Send = SendMessage(
			{	Email=>1, Intern=>1, 
				System=>1, 
				To=>[$LSC{errorUser}], From=>0, 
				ToEmail=>$LSC{errorEmail}, FromEmail=>$LSC{notifyEmail}, 
				DeleteAfterXDays=>14, 
				Subject=>"ERROR", 
				Message=>$Message, 
				Template=>"", 
				TemplateValues=>{}
			});


}

sub checkref {
	if ($q->request_method() && $q->request_method() ne "POST") {
		return 1;
	}
	my $cref =0;
	$LSC{AllowedRefererError} = "";
	if (!$LSC{AllowedReferer} || !$LSC{AllowedReferer}->[0]) {
		return 1;
	}
	my $referer = referer();
	if ($referer) {
		$referer = "\L$referer"; 
		$referer =~s/ //gg;

		foreach my $ref (@{$LSC{AllowedReferer}}) {
			if ($q->referer()=~ /http:\/\/\L$ref\/.*/ || referer()=~ /http:\/\/\L$ref/) {
				$cref=1;
			}
		}
	} else {
		$cref=1;
	}
	unless ($cref) {
		$LSC{AllowedRefererError} .= "Referer=".$referer." / Allowed: ".join("|", @{$LSC{AllowedReferer}}) ;
	}
	return $cref;
}

# hilfsfunktionen ###############
sub my_get_date {
   	my @days = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
   	my @months = ('Januar','Februar','Maerz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember');

   	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   	if ($hour < 10)		{ $hour = "0$hour"; }
   	if ($min < 10) 		{ $min = "0$min"; }
   	if ($sec < 10) 		{ $sec = "0$sec"; }
    $year = 1900+$year;
    #$date = "$days[$wday], $mday. $months[$mon] $year um $hour\:$min\:$sec";
    my $date = "$mday. $months[$mon] $year ($hour\:$min\:$sec)";
    my $monat = $months[$mon];
	my $onlyDate = "$mday. $months[$mon] $year";
	return ($date, $onlyDate);
}


%MonatNummer = qw (
	Januar		1
	Februar		2
	Maerz		3
	April		4
	Mai		5
	Juni		6
	Juli		7
	August		8
	September	9
	Oktober		10
	November	11
	Dezember	12
);	

TimerStop("LSCInit.pm");

1
