
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




# Funktionen um eine Turnier zu erstellen
# PlayoffErstellen
# PlayoffTeamwahl

sub PlayoffErstellen {
	my $AnzahlTeams = shift;
	local *Form = sub {
		print start_form('post',"$scriptname?League=$LSC{League}&Action=CreatePlayoffs");
		print $q->hidden("AnzahlTeams");
		my @out = PlayoffTeamwahl($AnzahlTeams);
		print $out[0];
		print submit('submit'),end_form;
	};

	print "<b>Playoffs erstellen:</b>".br;
	
	my $Runden = PlayoffRunden($AnzahlTeams);
	if ($q->param('Playoffs erstellen')) {

		if ($LSC{LeagueData}{PlayoffDaten}{BestOf}) {
			# Best of werte prfen
			my $ok = 1;
			for(my $R = 1; $R <= $Runden; $R++) {
				if (!($q->param($R."-Runde") &&
				!($q->param($R."-Runde")=~/[^0-9]/))) {
					$ok = 0;
					print "Der Wert fr $R. Runde ist nicht
					korrekt!".br; 
				}
			}
			unless ($ok) {
				print "Bitte die Werte fr die oben angebenen Runden
				ndern.".br;
				return;
			}
			
			#alte werte lschen
			my $sth = $LSC{MySQL}->do("delete from lsc_playoffs_bestof where League=$LSC{League}");
			for(my $R = 1; $R <= $Runden; $R++) {
				my $sth = $LSC{MySQL}->do("insert into lsc_playoffs_bestof 
					(League, Round, Games) Values 
					($LSC{League}, $R, ".$q->param($R.'-Runde').")");
			}
		}	
		
		#alte einstellungen lschen
		unless (Liga_AnzahlSpiele($LSC{League})) {
			my $sth = $LSC{MySQL}->do("delete from lsc_playoffs where League=$LSC{League}");
			$sth = $LSC{MySQL}->do("delete from lsc_playoffs_round where League=$LSC{League}");
		}
		
		if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
			my $Round = PlayoffAktuelleRunde()+1;
			for(my $spiele=1; $spiele <=$AnzahlTeams;$spiele++) {
				if ($q->param("TeamA-$spiele") && $q->param("TeamB-$spiele")) {
					my $a = $LSC{MySQL}->quote($q->param("TeamA-$spiele"));
					my $b = $LSC{MySQL}->quote($q->param("TeamB-$spiele"));
					if ($q->param("TeamA-$spiele") > $q->param("TeamB-$spiele")) {
						my $t = $a; $a=$b; $b=$t;
					}
					my $sth = $LSC{MySQL}->do("insert into lsc_playoffs_round 
						(League, Round, Spiel, Team1, Team2) Values 
						($LSC{League}, $Round, $spiele, $a, $b)");
				}		
			}
			my @out = PlayoffTeamwahl($AnzahlTeams, 1);
		} elsif ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
			my $Runde = 1;
			my $Spiele = $AnzahlTeams;
			$AnzahlTeams = $AnzahlTeams*2;
			
			my $DATEN;
						
			#1 . Runde:
			for (my $i=1; $i<=$Spiele; $i++) {
				$DATEN{$Runde}{$i}[0] = $q->param("TeamA-$i") || -1;
				$DATEN{$Runde}{$i}[1] = $q->param("TeamB-$i") || -1;
#				print "Spiel: $i / $DATEN{$Runde}{$i}[0] : $DATEN{$Runde}{$i}[1]".br;
				my $a = $LSC{MySQL}->quote($DATEN{$Runde}{$i}[0]);
				my $b = $LSC{MySQL}->quote($DATEN{$Runde}{$i}[1]);
				my $sth = $LSC{MySQL}->do("insert into lsc_playoffs_round 
					(League, Round, Spiel, Team1, Team2) Values 
					($LSC{League}, $Runde, $i, $a, $b)");
			}
			print "1. Runde erstellt".br;
			$Runde++;
			while ($Spiele > 0) {
#				print "Runde: $Runde / Spiele: $Spiele".br;
				if ($Runde % 2) {
					#ungerade
#					print "ungerade".br;
					for (my $i=1; $i<=$Spiele; $i++) {
						my $a = 0;
						my $b = 0;
						$DATEN{$Runde}{$i}[0] = 0;
						$DATEN{$Runde}{$i}[1] = 0;
			
						#Verliererrunde
						my $letzteRunde= $Runde-1;
						my $s = $i+$Spiele;
						if ($DATEN{$letzteRunde}{$s}[0] == -1
							||	
							$DATEN{$letzteRunde}{$s}[1] == -1) {
							$DATEN{$Runde}{$i}[0] =  
								$DATEN{$letzteRunde}{$s}[0]==-1?
									$DATEN{$letzteRunde}{$s}[1]
										:
									$DATEN{$letzteRunde}{$s}[0];
							$a = $DATEN{$Runde}{$i}[0];							
						}
						
						#Neuer Gegner aus dem Winner bracket:
						if ((($Runde+1)/2) % 2) {
							#parallel
							$s = $i;
						} else {
							#gekreuzt
							$s = ($Spiele+1)-$i;
						}
						
#						print "VerliererRunde: $Runde, Spiel: $i Gegner: $s".br;
						if ($DATEN{$letzteRunde}{$s}[0] == -1
							||	
							$DATEN{$letzteRunde}{$s}[1] == -1) {
							$DATEN{$Runde}{$i}[1] =  -1;
							
							#$DATEN{$letzteRunde}{$s}[0]==-1?
							#	$DATEN{$letzteRunde}{$s}[1]
							#		:
							#	$DATEN{$letzteRunde}{$s}[0];
							$b = $DATEN{$Runde}{$i}[1];							
							
						}
#						print "insert into lsc_playoffs_round 
#							(League, Round, Spiel, Team1, Team2) Values 
#							($LSC{League}, $Runde, $i, $a, $b)".br;
						my $sth = $LSC{MySQL}->do("insert into lsc_playoffs_round 
							(League, Round, Spiel, Team1, Team2) Values 
							($LSC{League}, $Runde, $i, $a, $b)");
					}
				} else {
					#gerade
#					print "gerade".br;
					for (my $i=1; $i<=$Spiele; $i++) {
						my $a = 0;
						my $b = 0;
						$DATEN{$Runde}{$i}[0] = 0;
						$DATEN{$Runde}{$i}[1] = 0;
						if ($i <= $Spiele/2) {
							#Gewinnerrunde
							my $letzteRunde= $Runde-1==1?1:$Runde-2;
							my $s = ($i*2)-1;
							if ($DATEN{$letzteRunde}{$s}[0] == -1
								||	
								$DATEN{$letzteRunde}{$s}[1] == -1) {
								$DATEN{$Runde}{$i}[0] =  
									$DATEN{$letzteRunde}{$s}[0]==-1?
										$DATEN{$letzteRunde}{$s}[1]
											:
										$DATEN{$letzteRunde}{$s}[0];
								$a = $DATEN{$Runde}{$i}[0];
							}
							$s = $i*2;
							if ($DATEN{$letzteRunde}{$s}[0] == -1
								||	
								$DATEN{$letzteRunde}{$s}[1] == -1) {
								$DATEN{$Runde}{$i}[1] =  
									$DATEN{$letzteRunde}{$s}[0]==-1?
										$DATEN{$letzteRunde}{$s}[1]
											:
										$DATEN{$letzteRunde}{$s}[0];
								$b = $DATEN{$Runde}{$i}[1];
							}
						} else {
							#Verliererrunde
#							print "Verliererrunde: $Runde".br;
							my $letzteRunde= $Runde-1;
							my $s = ($i-$Spiele/2)*2-1;
							
							unless (defined($DATEN{$letzteRunde}{$s}[1])) { $DATEN{$letzteRunde}{$s}[1] = 0; }			
							unless (defined($DATEN{$letzteRunde}{$s}[0])) { $DATEN{$letzteRunde}{$s}[0] = 0; }
							if ( ($DATEN{$letzteRunde}{$s}[0] == -1
								&&	
								$DATEN{$letzteRunde}{$s}[1] > 0)
								||
								($DATEN{$letzteRunde}{$s}[0] > 0
								&&	
								$DATEN{$letzteRunde}{$s}[1] == -1)
								||
								($DATEN{$letzteRunde}{$s}[0] == -1
								&&	
								$DATEN{$letzteRunde}{$s}[1] == -1)
								) {
								$a = -1;

								$DATEN{$Runde}{$i}[0] = -1;
								
							}
							$s = ($i-$Spiele/2)*2;
							if ( ($DATEN{$letzteRunde}{$s}[0] == -1
								&&	
								$DATEN{$letzteRunde}{$s}[1] > 0)
								||
								($DATEN{$letzteRunde}{$s}[0] > 0
								&&	
								$DATEN{$letzteRunde}{$s}[1] == -1)
								||
								($DATEN{$letzteRunde}{$s}[0] == -1
								&&	
								$DATEN{$letzteRunde}{$s}[1] == -1)
								) {
								$b = -1;

								$DATEN{$Runde}{$i}[1] = -1;
							}
						}
					
						my $sth = $LSC{MySQL}->do("insert into lsc_playoffs_round 
							(League, Round, Spiel, Team1, Team2) Values 
							($LSC{League}, $Runde, $i, $a, $b)");
					}
					$Spiele = $Spiele > 1? $Spiele/2:0;
				}
				print "$Runde. Runde erstellt".br;
				$Runde++;
			}
			
		} elsif ($LSC{LeagueData}{PlayoffDaten}) {
			$LSC{PlayoffNoMenu} = 1;
			my ($baum, $Teams) = Playoffbaum($AnzahlTeams, 1);

			my $Grenze = "9" x ($Runden -1);
	
			my %Used = ();
			my %Teams;			
			foreach my $t (sort {$b <=> $a} keys %{$Teams}) {
				if ($t > $Grenze) {
					if ($q->param("Team-$t")) {
						my $pos = $LSC{MySQL}->quote($t);
						my $team = $LSC{MySQL}->quote("".$q->param("Team-$t"));
						$Teams{$t} = $team;
						$Used{$t} = 1;
						my $sth = $LSC{MySQL}->do("insert into lsc_playoffs 
							(League, Pos, Team) Values 
							($LSC{League}, $pos, $team)");
					}
				} elsif (!($Used{$t.'1'} && $Used{$t.'2'}) && $Used{$t.'1'}<2 && $Used{$t.'2'}<2 ) {
					my $pos = $LSC{MySQL}->quote($t);
					my $team;

					if ($Used{$t.'1'}) {
						$team = $Teams{$t."1"};
						$Teams{$t} = $team;
						my $sth = $LSC{MySQL}->do("insert into lsc_playoffs 
							(League, Pos, Team) Values 
							($LSC{League}, $pos, $team)");
						$Used{$t} = 1;
					} elsif ($Used{$t.'2'}){	
						$team = $Teams{$t."2"};
						$Teams{$t} = $team;
						my $sth = $LSC{MySQL}->do("insert into lsc_playoffs 
							(League, Pos, Team) Values 
							($LSC{League}, $pos, $team)");
						$Used{$t} = 1;
					} else {
						$team = 0;
						my $sth = $LSC{MySQL}->do("insert into lsc_playoffs 
							(League, Pos, Team) Values 
							($LSC{League}, $pos, $team)");
						$Used{$t} =0;
					}
				} else {
					$Used{$t} = 2;
				}
			}
			
			PlayoffbaumAnzeigen();
		}
		print "Turnier wurde erstellt.".br.br;
	} elsif ($q->param('submit')) {
		my ($Baum, $DTeams) = PlayoffTeamwahl($AnzahlTeams, 1);
		if ($DTeams) {
			print hr.$Baum.hr;
			print "<b>Ein Team darf nicht mehrfach ausgewhlt werden.</b>".br;
			Form();
		} else {
			print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=CreatePlayoffs");
			print $q->hidden("AnzahlTeams");
			print hr.$Baum.hr;
			if ($LSC{LeagueData}{PlayoffDaten}{BestOf}) {
				print "Bitte Rundenlnge whlen, wobei:".br;
				print "- die hchste Rundennummer die Finalrunde ist.".br;
				print "- die Rundenlnge im 'Best of' Modus angegeben werden muss.".br;
				print "Bitte beachte, das nur ungerade BestOf Werte Sinn machen!".br;
				print br;
				for(my $R = 1; $R <= $Runden; $R++) {
					print "$R. Runde: ".$q->textfield($R."-Runde", "1", 3).br;
				}
			}	
			print  br;
			print submit('Playoffs erstellen'),end_form;
		}
	} else {
		Form();
	}

}

sub PlayoffTeamwahl {
	my $Anzahl = shift;
	my $x = shift || 0;
		
	my %Members = Members();
	# freilos einfgen
	$Members{0} = '- empty -';

	my %UsedTeams = ();
	my $DoppelteTeams = 0;
	
	my $baum;
	if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'} 
		||
		$LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
		$baum = '<table><tr><td class=Headline>#</td><td class=Headline>Team 1</td><td class=Headline>Team 2</td></tr>';
		for(my $spiele=1; $spiele <=$Anzahl;$spiele++) {
			$baum .= "<tr><td>$spiele</td><td>";
				if ($x == 0) {
					$baum .= $q->popup_menu(-name=>"TeamA-$spiele", -values=>[sort {"\L$Members{$a}" cmp
					"\L$Members{$b}" } keys %Members], -Labels=>\%Members).		
					"</td><td>".
					$q->popup_menu(-name=>"TeamB-$spiele", -values=>[sort {"\L$Members{$a}" cmp
					"\L$Members{$b}" } keys %Members], -Labels=>\%Members).		
					"</td></tr>";
				} elsif ($x == 1) {
					($a, undef) = TeamnameAndUserFromTeamIDAndLeague($q->param("TeamA-$spiele"), $LSC{League});
					($b, undef) = TeamnameAndUserFromTeamIDAndLeague($q->param("TeamB-$spiele"), $LSC{League});
					if ($a) {$a =~s/ /&nbsp;/gg;} else {$a = 'freilos'};
					if ($b) {$b =~s/ /&nbsp;/gg;} else {$b = 'freilos'};

					if ($q->param("TeamA-$spiele") && $UsedTeams{$q->param("TeamA-$spiele")}) {
							$a = "<b><u>$a</u></b>";
							$DoppelteTeams++;
					}
					$UsedTeams{$q->param("TeamA-$spiele")}=1;
					if ($q->param("TeamB-$spiele") && $UsedTeams{$q->param("TeamB-$spiele")}) {
							$b = "<b><u>$b</u></b>";
							$DoppelteTeams++;
					}
					$baum .= $a.$q->hidden("TeamA-$spiele")."</td><td>".$b.$q->hidden("TeamB-$spiele")."</td></tr>";
					$UsedTeams{$q->param("TeamB-$spiele")}=1;
					
				}
		}
		$baum .= "</table>";
	} elsif ($LSC{LeagueData}{PlayoffDaten}) {
		my $Teams;
		$LSC{PlayoffNoMenu} = 1;
		($baum, $Teams) = Playoffbaum($Anzahl, 1);

		my $Runden = PlayoffRunden($Anzahl);
		my $Grenze = "9" x ($Runden -1);
	
	
		foreach (keys %{$Teams}) {
			if ($_ > $Grenze) {
				my $insert = '';
				if ($x == 0) {
					# Auswahl
					$insert = $q->popup_menu(-name=>"Team-$_", -values=>[sort {"\L$Members{$a}" cmp
					"\L$Members{$b}" } keys %Members], -Labels=>\%Members);
				} elsif ($x == 1) {
					# Anzeigen
					if ($q->param("Team-$_")) {
						($insert, undef) = TeamnameAndUserFromTeamIDAndLeague($q->param("Team-$_"), $LSC{League});
						$insert =~s/ /&nbsp;/gg;
						if ($UsedTeams{$q->param("Team-$_")}) {
							$insert = "<b><u>$insert</u></b>";
							$DoppelteTeams++;
						}
						$insert .= $q->hidden("Team-$_");
						$UsedTeams{$q->param("Team-$_")} = 1;
					} else {
						$insert = "-&nbsp;empty&nbsp;-".$q->hidden("Team-$_");
					}
				}
				$baum =~s/\#$_\#/$insert/;
			}
		}
		$baum =~s/\#[0-9]*\#/&nbsp;/gg;
	}
	return ($baum, $DoppelteTeams);
}
sub PlayoffRundeLoeschen {
	my $runde = shift;
	unless ($runde) {
		print "nicht mglich";
		return;
	}

	my $sth = $LSC{MySQL}->prepare("SELECT GameID FROM lsc_playoffs_round WHERE League=$LSC{League} and Round=$runde");
	$sth->execute();
	while (my $ref = $sth->fetchrow_arrayref()) {
		AdminSpielLoeschen($ref->[0]) if $ref->[0];
	}
	$sth->finish;

	$sth = $LSC{MySQL}->prepare("delete FROM lsc_playoffs_round WHERE League=$LSC{League} and Round=$runde");
	if ($sth->execute()) {
		print "Runde ".$runde." wurde gelscht".br;
	} else {
		print "Es ist ein Fehler beim lschen der Runde $runde aufgetreten.".br;
	}
	$sth->finish;


}
1
