
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




## Liga Stand anzeigen

# jeweils die bentigten Pakete laden
# und entsprechenede Funktionen aufrufen

sub Standings {
	my ($Action2, $Special) = @_;

	if ($Special) {
		##
		# Tabelle
		# Infotabelle ausgeben
		##
		my $atit = $LSC{anzahlteamsintabelle};
		$LSC{anzahlteamsintabelle} = 10;

		Require("LSCTabelle2.pm");
		Tabelle2Simpel($LSC{League}, $Action2, 0, 1);

		$LSC{anzahlteamsintabelle} = $atit;

	} elsif ($LSC{LeagueData}{Playoff}) {
			print ShowFullScreenLink({Name => "FullScreen Standings", Script => $LSC{show_pl}, Action => "StandingsB"}, 1) if ($LSC{LeagueData}{Playoff} != 3);
			#if ($LSC{LeagueData}{Playoff} > 2) {
				$LSC{LeagueData}{PlayoffDaten}{Function}->();
			#}
	} elsif ($LSC{LeagueData}{ExecFunction}) {
		$LSC{LeagueData}{ExecFunction}->();
	} else {
		
		Require("LSCTabelle2.pm");
		Tabelle2Simpel($LSC{League}, $Action2);
	}
	return 1;
}

sub StandingsB {
	my ($Action2, $Special) = @_;

	$LSC{Fullscreen} = 1;
	if ($LSC{LeagueData}{PlayoffDaten}{Function}) {
		$LSC{NoLinks} = 1;
		$LSC{LeagueData}{PlayoffDaten}{Function}->(1);
	} else {
		print br."<div>Fr diese Tabelle wurde keine Funktion definiert. Bitte wende dich an den Admin.</div>".br;
		return;
	}
	return 1;
}

###
## TableFunctions (Special)
# _Standings_Tunier - KO-System
# _Standings_PokalTunier - Pokalmodus
# _Tab_Basketball - Basketball (NBA Regeln)

	sub _Standings_Tunier {
		print "<div align=center>";
		PlayoffbaumAnzeigen(@_);
		print "</div>";
	}
	sub _Standings_DoubleElimination {
		print "<div align=center>";
		PlayoffbaumAnzeigen(@_);
		print "</div>";
	}

	sub _Standings_PokalTunier {
		print "<div align=center>";
		print "Fr dieses Turnier steht keine bersicht zur Verfgung!";
		print "</div>";
	}

	sub _Tab_Basketball {
		Require("LSCTabelle2.pm");

		# eastern und western conference platzierungen speichern
		$LSC{TabelleDefinitionNBAConferenceRules} = 1;
		
			$LSC{TabelleDefinitionMainGroup} = 5;
			Tabelle2Simpel($LSC{League}, 0, 1);

			$LSC{TabelleDefinitionMainGroup} = 6;
			Tabelle2Simpel($LSC{League}, 0, 1);
		
			$LSC{TabelleDefinitionMainGroup} = 0;

		$LSC{TabelleDefinitionNBAConferenceRules} = 0;

		
		print '<font SIZE="4"><b>Eastern Conference</b></font>';
		# Divisionen ausgeben:
		#'Atlantic';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Atlantic"; 
		$LSC{TabelleDefinitionSubGroup} = 1;
		Tabelle2Simpel($LSC{League}, 0);
			
		#'Central';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Central"; 
		$LSC{TabelleDefinitionSubGroup} = 2;
		Tabelle2Simpel($LSC{League}, 0);

		print br.br;
	
		print '<font SIZE="4"><b>Western Conference</b></font>';
		# Divisionen ausgeben:
		#'Midwest';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Midwest"; 
		$LSC{TabelleDefinitionSubGroup} = 3;
		Tabelle2Simpel($LSC{League}, 0);
		
		#'Pacific';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Pacific"; 
		$LSC{TabelleDefinitionSubGroup} = 4;
		Tabelle2Simpel($LSC{League}, 0);

		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Name"; 
		$LSC{TabelleDefinitionSubGroup} = 0;
	}
	sub _Tab_Basketball_NBA_New {
		Require("LSCTabelle2.pm");

		# eastern und western conference platzierungen speichern
		$LSC{TabelleDefinitionNBAConferenceRules2} = 1;
		
			$LSC{TabelleDefinitionMainGroup} = 5;
			Tabelle2Simpel($LSC{League}, 0, 1);

			$LSC{TabelleDefinitionMainGroup} = 6;
			Tabelle2Simpel($LSC{League}, 0, 1);
		
			$LSC{TabelleDefinitionMainGroup} = 0;

		$LSC{TabelleDefinitionNBAConferenceRules2} = 0;

		print '<font style="font-size: 14px"><b>Eastern Conference</b></font>';
		print '<table cellspacing=0 cellpadding=0 width="100%" Style="border-style:solid; border-width:1px; border-color:#8596B0"><tr><td>';
		# Divisionen ausgeben:
		#'Atlantic';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Atlantic"; 
		$LSC{TabelleDefinitionSubGroup} = 1;
		Tabelle2Simpel($LSC{League}, 0);
			
		#'Central';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Central"; 
		$LSC{TabelleDefinitionSubGroup} = 2;
		Tabelle2Simpel($LSC{League}, 0);

		#'Southeast';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Southeast"; 
		$LSC{TabelleDefinitionSubGroup} = 8;
		Tabelle2Simpel($LSC{League}, 0);
		print '</td></tr></table>';
		print '<br><font style="font-size: 14px"><b>Western Conference</b></font>';
		print '<table cellspacing=0 cellpadding=0 width="100%" Style="border-style:solid; border-width:1px; border-color:#8596B0"><tr><td>';
		# Divisionen ausgeben:
		#'Southwest';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Southwest"; 
		$LSC{TabelleDefinitionSubGroup} = 10;
		Tabelle2Simpel($LSC{League}, 0);
		
		#'Northwest';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Northwest"; 
		$LSC{TabelleDefinitionSubGroup} = 9;
		Tabelle2Simpel($LSC{League}, 0);

		#'Northwest';
		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Pacific"; 
		$LSC{TabelleDefinitionSubGroup} = 4;
		Tabelle2Simpel($LSC{League}, 0);
		print '</td></tr></table>';

		$LSC{TabelleDefinitionSpalten}[0]{Name} = "Name"; 
		$LSC{TabelleDefinitionSubGroup} = 0;
	}
#EASTERN CONFERENCE
#Atlantic Division
#Central Division
#Southeast Division

#WESTERN CONFERENCE
#Southwest Division
#Northwest Divsion
#Pacific Division

 #1  Atlantic Division
 #2  Central Division
 #3  Midwest Division     
 #4  Pacific Division     
 #5  Eastern Conference     
 #6  Western Conference     
 #7  Northeast Division     
 #8  Southeast Division     
 #9  Northwest Division
	sub _Tab_NHL {
		require $LSCPackagePfad."LSCtabelle.pm";
		my $func = 'Eishockey' || $LSC{LeagueData}{TableFunc};
		my @Teams;
		
		print '<font SIZE="4"><b>Eastern Conference</b></font>'.br;
		$Tabelle{$func}{GroupID} = 5;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print br;
		print '<font SIZE="2"><b>Atlantic Division</b></font>'.br;
		$Tabelle{$func}{GroupID} = 1;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print '<font SIZE="2"><b>Northeast Division</b></font>'.br;
		$Tabelle{$func}{GroupID} = 7;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print '<font SIZE="2"><b>Southeast Division</b></font>'.br;
		$Tabelle{$func}{GroupID} = 8;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print br.br;

		print '<font SIZE="4"><b>Western Conference</b></font>'.br;
		$Tabelle{$func}{GroupID} = 6;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print br;
		print '<font SIZE="2"><b>Central Division</b></font>'.br;
		$Tabelle{$func}{GroupID} = 2;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print '<font SIZE="2"><b>Northwest Division</b></font>'.br;
		$Tabelle{$func}{GroupID} = 9;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
		print '<font SIZE="2"><b>Pacific Division</b></font>'.br;
		$Tabelle{$func}{GroupID} = 4;
		@Teams = _TabelleLaden('Eishockey', $LSC{League});
		_TabelleAnzeigen('Eishockey', $LSC{League}, \@Teams);
	}
1
