
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




########## email
sub email{
	if ($LSC{Lan_Modus}) {
		print "Achtung: Das LeagueScript luft im Lan-Modus, deshalb werden Nachrichten nicht per Email weitergeleitet!<br>";
		return;
	}

 my ($from, $to, $subject, $aufruf, @text)=@_;
 my $flag=' -t -oi';
 my $zeile;
my $sendmail = $LSC{Sendmail} || '/usr/sbin/sendmail';
if ($aufruf == -1) { $aufruf=$LSC{Email};}
# -oi nicht beenden, wenn eine zeile mit nur einem punkt gelesen wird
# -t Nachrichten Header lesen
# -odq emails in warteschlange (bei vielen email)

 if ($aufruf eq "1") {
  open (SENDMAIL, "| $sendmail $flag -f \"".$LSC{notifyEmail}."\"") || die "Sendmail nicht bereit $! \nBitte wende dich an den Admin";
 } elsif ($aufruf eq "2") {
  open (SENDMAIL, ">>".$LSCPackagePfad."sendmail.txt");# or print "$!";
 } else {
	 #keine emails verschicken
	 return;
 }
 print SENDMAIL <<"ENDHEADER";
From: $from
To: $to
Subject: $subject

ENDHEADER
 foreach $zeile ( @text ) {
  print SENDMAIL "$zeile\n";
 }
 if ($LSC{TEXT}{Email}[0]) {
  print SENDMAIL "\n".$LSC{TEXT}{Email}[0];
 }
 close SENDMAIL;
}

### Link's ###
	sub LinkZurueck {
		# Name, Class
		my $class = $_[1] || 'standard';
		return '<A class='.$class.' HREF=\'JavaScript:history.back(1)\'>'.$_[0].'</A>';
	}

	sub TeamLink {
		# Name, ID, Class, Vote_TeamIndikator, Liga
		my @Link = ();
		if ($_[0] && ref($_[0]) eq "HASH") {
			my $d = shift;
			@Link = (
					$d->{Name} || "",
					$d->{ID}	|| 0,
					$d->{Class} || "",
					$d->{HideVote} || "1",
					$d->{League} || "",
				);
		} else {
			@Link = @_;
		}

		unless ($Link[0] || $Link[1]) {
			return "";
		}

		return "$Link[0]" if $LSC{NoLinks};

		my $w = TeamVerwarnt($Link[1], $Link[4]);
		if ($w) { 
			$w='V';
		} else {
			$w='';
		}
		my $g = TeamStatus($Link[1]);
		if ($g==1) { 
			$g='G';
		} else {
			$g='';
		}

		my $class = $Link[2] || 'Team';
		
		
		my $Link = "";
		my $liga = $Link[4] || $LSC{League} || 0;

		my $Name = $Link[0];
		if ($liga && !$g && TeamLigaStatus($Link[1], $liga)==1) {
			#inaktiv
			$Name="($Name)";
		}


		if ($LSC{TeamSeitenKeinPopUp}) {
			$Link = "$LSC{show_pl}?League=$liga&Action=TeamStatistics&special=".$Link[1]; 
		
		} else {
			$Link = 'JavaScript:openPopWin("TeamStatistic","'.$liga.'","'.$Link[1].'")';
		}
		return ($g ?'(':'').'<A class='.$class.'
			HREF=\''.$Link.'\'>'.$Name.'</A>'.
			($g ?')':'').
			'<font color=#FF0000><b>'.$w.$g.'</b></font>'.
			($Link[3] || $g? '': ($LSC{Vote}{S} ? Vote_TeamIndikator($Link[1]) : ""));
	}
	sub TeamLink2 {
		# Name, ID, Class
		my $class = $_[2] || 'Team';
		$class = 'class='.$class;
		my $ligacgilink="$LSC{show_pl}?League=$LSC{League}&Action=TeamStatistics&special=";
		return '<A '.$class.' HREF="'.$ligacgilink.$_[1].'">'.$_[0].'</A>';
	}
	sub UserLink {
		# Name, ID, Class
		return "$_[0]" if $LSC{NoLinks};

		my ($w, $g) = UserVerwarnt($_[1]);
		if ($w) { 
			$w='V';
		} else {
			$w='';
		}
		if ($g) { 
			$w='G';
		} 
		my $class = $_[2] || 'User';
		if ($LSC{UserSeitenImPopUp}) {
			return '<A class='.$class.'	HREF=\'JavaScript:openPopWin("User","'.($LSC{League} || '').'","'.$_[1].'")\'>'.$_[0].'</A>'.
				'<font color=#FF0000><b>'.$w.'</b></font>';
		}
		my $ligacgilink="$LSC{show_pl}?League=$LSC{League}&Action=User&special=";
		return '<A class='.$class.' HREF="'.$ligacgilink.($_[1] || -1).'">'.$_[0].'</A>';

	}
	sub PlayerLink {
		# Name, ID, Class, $league
		unless ($LSC{PlayerStats}) {
		 return $_[0] || "";
		}
		my $class = $_[2] || 'Team';
		my $Link = "$LSC{show_pl}?League=".($_[3] || $LSC{League} || 0)."&Action=PlayerStats&special=".$_[1]; 
		
		return '<A class='.$class.'
			HREF=\''.$Link.'\'>'.$_[0].'</A>';
	}
	sub UserLink2 {
		# Name, ID, Class
		my $class = $_[2] || 'Team';
		$class = 'class='.$class;
		my $ligacgilink="/$LSC{user_pl}?League=$LSC{League}&Action=UserOverview&special=";
		return '<A '.$class.' HREF="'.$ligacgilink.$_[1].'">'.$_[0].'</A>';
	}
	sub ShowLink {
		my $Link = shift;
		my $keepLeague = shift || 0;
		unless ($Link->{Name}) {
			return 'NO LINK';
		}
		return "$Link->{Name}" if $LSC{NoLinks};

		my $Class = $Link->{Class} || 'standard';
		my $param = "League=".($Link->{League} || ($keepLeague ? $LSC{League}."" : '')).
					"&Action=".($Link->{Action} || '').
					"&Action2=".($Link->{Action2} || '').
					"&special=".(defined($Link->{Special}) ? $Link->{Special} : '');
		return '<A HREF="'.($Link->{Script} || $scriptname).'?'.$param.'" class="'.$Class.'" style="'.($Link->{Style} || "").'">'.$Link->{Name}.'</A>';
	}
	sub MessageLink {
		my $Link = shift;
		unless ($Link->{To} || $LSC{LOGIN}) {
			return '';
		}
		my $param = "League=".$LSC{League}.
					"&Action=MSG".
					"&Action2=New".
					"&special=".$Link->{To};
		return '<A HREF="'.$LSC{user_pl}.'?'.$param.'" ><IMG SRC="'.$LSC{imagepfad}.'/message.gif" Border="0" ALT="Send Message"></A>';
	}
	sub ShowFullScreenLink {
		my $Link = shift;
		my $keepLeague = shift || 0;
		unless ($Link->{Name}) {
			return 'NO LINK';
		}
		my $Class = $Link->{Class} || 'standard';
		my $param = "League=".($Link->{League} || ($keepLeague ? $LSC{League}."" : '')).
					"&Action=".($Link->{Action} || '').
					"&Action2=".($Link->{Action2} || '').
					"&special=".(defined($Link->{Special}) ? $Link->{Special} : '');
		#return '<A HREF="'.($Link->{Script} || $scriptname).'?'.$param.'" class='.$Class.'>'.$Link->{Name}.'</A>';

		return $Link->{Name}.": ".
				'<A class='.$Class.' HREF=\'JavaScript:openPopFullScreenWin("'.($Link->{Script} || $scriptname).'","'.$param.'","620","400")\'>[640*480]</A>'.
				' <A class='.$Class.' HREF=\'JavaScript:openPopFullScreenWin("'.($Link->{Script} || $scriptname).'","'.$param.'","780","500")\'>[800*600]</A>'.
				' <A class='.$Class.' HREF=\'JavaScript:openPopFullScreenWin("'.($Link->{Script} || $scriptname).'","'.$param.'","1000","700")\'>[1024*768]</A>'.
				' <A class='.$Class.' HREF=\'JavaScript:openPopFullScreenWin("'.($Link->{Script} || $scriptname).'","'.$param.'","1260","900")\'>[1280*1024]</A>';

	}	
	sub UploadLink {
		unless ($LSC{uploads}) {
			return "";
		}
		my $Link = shift;
		my $keepLeague = shift || 0;

		my $Class = $Link->{Class} || 'standard';
		my $param = "League=".($Link->{League} || ($keepLeague ? $LSC{League}."" : '')).
					"&Action=".($Link->{Action} || '').
					"&Action2=".($Link->{Action2} || '').
					"&special=".(defined($Link->{Special}) ? $Link->{Special} : '');

		return '<A class='.$Class.' HREF=\'JavaScript:openPopFullScreenWin("upload.pl","'.$param.'","500","300")\'>'.($Link->{Name} || "Upload").'</A>';

	}	
	
	sub RecapLink {
		# League, Game, Name, class
		my $class = $_[3] || 'Tabelle';
		my $adminlink = "";
		if ($LSC{Admin}) {
			$adminlink = '<A HREF="admin.pl?League='.$_[0].'&Action=ChangeGame&Action2=show&special='.$_[1].'"><font color="#FF0000">A</font></A>';
		}
		if ($LSC{ErgebnisseImPopUp}) {
			return $adminlink.'<A class='.$class.' HREF=\'JavaScript:openPopWin("Recap","'.$_[0].'","'.$_[1].'")\'>'.$_[2].'</A>';
		} 
		my $Link = "$LSC{show_pl}?League=$_[0]&Action=ShowResult&special=".$_[1]; 
		return $adminlink.'<A class='.$class.' HREF=\''.$Link.'\'>'.$_[2].'</A>';

	}
### /Link's ###

		########### User Funktionen
sub IsAnAdminForThisLeague {
	my $userId = shift;
	my $league = shift || $LSC{League};
	unless ($league) { return ;};
	my ($select,$from,$where,$group,$order);
	$select	= "User";
	$from	= "lsc_leagues_admins";
	$where	= "League=$league and User=$userId";
	$group	= "";
	$order	= "";
#print "SELECT $select FROM $from WHERE $where $group $order".br;

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	if ($ref && $ref->[0] eq $userId) {
		return 1;
	}
	return;
}
sub AdminsForThisLeague {
	my $league = shift || $LSC{League};
	unless ($league) { return ;};
	$league = $LSC{MySQL}->quote($league);
	my ($select,$from,$where,$group,$order);
	$select	= "User";
	$from	= "lsc_leagues_admins";
	$where	= "League=$league";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where order by User");
	$sth->execute();
	my @admins;
	while (my $ref = $sth->fetchrow_arrayref()) {
		push(@admins, $ref->[0]);
	}
	$sth->finish;
	return @admins
}
sub LigenInDenenUserAdminIst {
	my $user = shift || return ();
	$user = $LSC{MySQL}->quote($user);
	my $sth = $LSC{MySQL}->prepare("SELECT League FROM lsc_leagues_admins WHERE User=$user order by League");
	$sth->execute();
	my @leagues;
	while (my $ref = $sth->fetchrow_arrayref()) {
		push(@leagues, $ref->[0]);
	}
	$sth->finish;
	return @leagues
}


sub UserIdundStatusVonName {
	my $user = $LSC{MySQL}->quote($_[0]);
	my ($select,$from,$where,$group,$order);
	$select	= "UserID, Status";
	$from	= "lsc_user";
	$where	= "Login=$user";
	$group	= "";
	$order	= "";
 
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return $ref->{'UserID'}, $ref->{'Status'};
}
sub UserNameUndStatusVonID {
	my $user = $LSC{MySQL}->quote($_[0]);
	my ($select,$from,$where,$group,$order);
	$select	= "Status, Login";
	$from	= "lsc_user";
	$where	= "UserID=$user";
	$group	= "";
	$order	= "";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	unless ($ref) {
		return;
	}
	return ($ref->[1], $ref->[0]);
}

sub AlleLigenInDenenUserSpielt {
	#user, [aktivleagues]
	my ($select,$from,$where,$group,$order);

	$select	= "L.Name, L.League";
	$from	= "lsc_teams T, lsc_teams_league TL, lsc_leagues L";
	$where	= "T.User=$_[0] and TL.Team=T.ID and TL.League=L.League";
	$where .= " and L.Status=1" if $_[1];
	$group	= "";
	$order	= "Order by T.ID";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %L;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$L{$ref->[0]} = $ref->[1];
	}
	$sth->finish;
	return %L;
}
sub AlleLigenInDenenUserSpieltID {
	#user, [aktivleagues]
	my ($select,$from,$where,$group,$order);

	$select	= "L.Name, L.League";
	$from	= "lsc_teams T, lsc_teams_league TL, lsc_leagues L";
	$where	= "T.User=$_[0] and TL.Team=T.ID and TL.League=L.League";
	$where .= " and L.Status=1" if $_[1];
	$group	= "";
	$order	= "Order by T.ID";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %L;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$L{$ref->[1]} = $ref->[0];
	}
	$sth->finish;
	return \%L;
}
sub AlleLigenInDenenTeamSpielt {
	# team / mit status
	my ($select,$from,$where,$group,$order);
	$select	= "L.Name, L.League, L.Status, TL.Rank, TL.LP, TL.Won, TL.Lost, TL.Draw, TL.CurrentStreak";
	$from	= "lsc_teams T, lsc_teams_league TL, lsc_leagues L";
	$where	= "T.ID=$_[0] and TL.Team=T.ID and TL.League=L.League";
	$group	= "";
	$order	= "Order by T.ID";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %L;
	if ($_[1]) {
		while (my $ref = $sth->fetchrow_arrayref()) {
			$L{$ref->[1]} = {Name=>$ref->[0], Status=>$ref->[2], Rank=>$ref->[3], LP=>$ref->[4], Won=>$ref->[5], Lost=>$ref->[6], Draw=>$ref->[7], CurrentStreak=>$ref->[8]};
		}
	} else {
		while (my $ref = $sth->fetchrow_arrayref()) {
			$L{$ref->[0]} = $ref->[1];
		}
	}
	$sth->finish;
	return %L;
}
sub AlleTeamsInDenenUserMemberIst {
	my ($select,$from,$where,$group,$order);

	$select	= "T.Name, T.ID";
	$from	= "lsc_teams T, lsc_teams_members M";
	$where	= "M.Member=$_[0] and M.Team=T.ID";
	$group	= "";
	$order	= "Order by T.ID";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %L;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$L{$ref->[1]} = $ref->[0];
	}
	$sth->finish;

	$select	= "Name, ID";
	$from	= "lsc_teams";
	$where	= "User=$_[0]";
	$group	= "";
	$order	= "";

	my $sth2 = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth2->execute();
	while (my $ref = $sth2->fetchrow_arrayref()) {
		$L{$ref->[1]} = $ref->[0];
	}
	$sth2->finish;

	return %L;

}

		##### Team funktionen ###########
sub FirstUserTeamID {
	my ($select,$from,$where,$group,$order);

	$select	= "T.ID";
	$from	= "lsc_teams T";
	$where	= "T.User=$_[0] and T.First=1";
#print "SELECT $select FROM $from WHERE $where $group $order".br;	
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my @teams;
	my $ref = $sth->fetchrow_arrayref();
	if ($ref) {
		return $ref->[0];
	}
	return 0;
}


sub AllTeamsFromUser {
	my ($select,$from,$where,$group,$order);

	$select	= "T.ID";
	$from	= "lsc_teams T, lsc_teams_league TL, lsc_leagues L";
	$where	= "T.User=$_[0] and T.ID=TL.Team and TL.League=L.League and L.MJoin in ('0','2')";
	$group	= "";
	$order	= "Order by T.ID";
#print "SELECT $select FROM $from WHERE $where $group $order".br;	
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my @teams;
	while (my $ref = $sth->fetchrow_arrayref()) {
		push(@teams, $ref->[0]);
	}
	$sth->finish;
	return @teams;
}

sub TeamIDForUserIDFromLeague {
	my ($select,$from,$where,$group,$order);

	$select	= "L.Team, T.Name";
	$from	= "lsc_teams T, lsc_teams_league L";
	$where	= "L.League=$_[1] and L.Team=T.ID and T.User=$_[0]";
	$group	= "";
	$order	= "";
#print $q->header().caller(0);
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");

	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
#Debug("U: $_[0], L:$_[1] / $ref->[0], $ref->[1]".br."SELECT $select FROM $from WHERE $where $group $order");
	$sth->finish;
	return ($ref->[0], $ref->[1]);
}
sub UserTeamIDTeamnameErmitteln {
	unless ($LSC{League}) {
		return '', 0;
	}
	return TeamIDForUserIDFromLeague($_[0], $LSC{League});
}

#######################  kleine hilfsprogs

#### fr Rankingligen:
sub RankingRangName {	
	return $LSC{RankingRangNamen}[RankingGet_rang($_[0])];
}
sub RankingRangNamen_Basketball {	
#	return "$_[0]";
	return $LSC{RankingRangNamen}[$_[0]];
}
sub RankingGet_rang {
	my $punkte = $_[0];
	my $rang = 0;
	while ($punkte > $LSC{RankingRang}[$rang] && $rang < 9) {
		$rang++;
	}
	return $rang;
}


			###### ligen
sub AnzahlTeamsUndNamenID {
		#alle teams, die dem user gehren oder in denen er leader ist
		my $user = shift;
		my $id= FirstUserTeamID($user);
		$user = $LSC{MySQL}->quote($user);
		my @LeaderTeams = TeamsInDenenUserLeaderIst($user);
		my $do = "Select ID, Name, PrivateTeam from lsc_teams where User=$user ".
				(@LeaderTeams ? " or ID in (".join(', ', @LeaderTeams).")" : "")." order by ID";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		my $c = 0;
		my @namen;
		while (my @ref = $sth->fetchrow_array()) {
			$c++;
			if ($ref[0] eq $id) {
				$ref[1].='(*)';
			}
			push(@namen, \@ref);
		}
		$sth->finish;
		return $c, \@namen;
}
sub AnzahlTeams {
		my $user = shift;
		my $id= FirstUserTeamID($user);
		$user = $LSC{MySQL}->quote($user);

		my $do = "Select ID, Name from lsc_teams where User=$user order by ID";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		my $c = 0;
		my @namen;
		while (my $ref = $sth->fetchrow_arrayref()) {
			if ($ref->[0] eq $id) {
				#$ref->[1].='(*)';
			} else {
				$c++;
				push(@namen, $ref->[1]);
			}
		}
		$sth->finish;
		return $c, \@namen;
}	
sub AnzahlTeamsID {
		my $user = shift;
		my $id= FirstUserTeamID($user);
		$user = $LSC{MySQL}->quote($user);

		my $do = "Select ID, Name from lsc_teams where User=$user order by ID";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		my $c = 0;
		my @namen;
		while (my $ref = $sth->fetchrow_arrayref()) {
			if ($ref->[0] eq $id) {
				#$ref->[1].='(*)';
			} else {
				$c++;
				push(@namen, $ref->[0]);
			}
		}
		$sth->finish;
		return $c, \@namen;
}
sub Liga_AnzahlSpiele {
	my $League = shift || return 0;
	my ($select,$from,$where,$group,$order);

	## alle ligen laden
	
	$select	= "Count(League)";
	$from	= "lsc_games_daten";
	$where	= "League=".$LSC{MySQL}->quote($League);
	$group	= "";
	$order	= "Group by League";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] || 0;
}			
sub Liga_AnzahlAktiverUser {
	my $League = shift;
	my ($select,$from,$where,$group,$order);

	## alle ligen laden
	
	$select	= "G.Team";
	$from	= "lsc_games G, lsc_games_daten D";
	$where	= "G.Game=D.No and D.League=$League";
	$group	= "Group by G.Team";
	$order	= "";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	
	my $counter = 0;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$counter++;
	}
	$sth->finish;
	return $counter;
}			
sub Liga_AnzahlteilnehmenderUser {
	my $League = shift;
	my ($select,$from,$where,$group,$order);

	## alle ligen laden
	
	$select	= "Count(*)";
	$from	= "lsc_teams_league";
	$where	= "League=$League";
	$group	= "";
	$order	= "";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0];
}			

			####### suchen ##########
sub NewMembers {
	my ($select,$from,$where,$group,$order);
	$select	= "Login, UserID";
	$from	= "lsc_user";
	$where	= '1';
	$group	= "";
	$order	= "order by Registered desc, UserID desc limit 5";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my @Namen;
	while (my @ref = $sth->fetchrow_array()) {
		push (@Namen, \@ref);
	}
	$sth->finish;
	return @Namen;
}
sub SucheUsernamenTeamnamen {
	my $name = shift;
	unless ($name) {
		return;
	}
	if ($name=~/[^A-Z,a-z,0-9 ]/) {	
		print "Dieser Suchstring ist nicht erlaubt!".br;
		return;
	}
	if (!$LSC{UserStatus} == 9 && length($name) < 3) {
		print "Mindestlnge des Suchstrings betrgt 3 Zeichen!".br;
		return;
	}
 	my $findall = shift || 0;
	
	my ($select,$from,$where,$group,$order);

	if ($findall == 1) {
		$select	= "T.ID, T.Name";
		$where	= 'T.Name LIKE "%'.$name.'%"';
		$from	= "lsc_teams T";
		$order	= "order by T.Name ";
	} elsif ($findall == 2) {
		$select	= "U.UserID, U.Login";
		$where	= 'U.Login LIKE "%'.$name.'%"';
		$from	= "lsc_user U";
		$order	= "order by U.Login ";
	} elsif ($findall == 3) {
		$select	= "T.ID, T.Name";
		$where	= 'T.Name LIKE "%'.$name.'%"';
		$from	= "lsc_teams T";
		$order	= "order by T.Name ";
	} else {
		$select	= "T.ID, T.Name";
		$from	= "lsc_teams T, lsc_teams_league L";
		$where	= 'L.Team=T.ID and L.League='.$LSC{League}.' and T.Name LIKE "%'.$name.'%"';
		$order	= "order by T.Name ";
	}
	$group	= "";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my %Namen;
	while (my $ref = $sth->fetchrow_arrayref()) {
		if ($findall == 3) {
			my $sth2 = $LSC{MySQL}->prepare("SELECT ID FROM lsc_teams WHERE ID=$ref->[0] and First=1");
			$sth2->execute();
			my $f = $sth2->fetchrow_arrayref();
			$sth2->finish;
			if ($f->[0]) {
			} else {
				$Namen{$ref->[0]} = $ref->[1];
			}
	
		} else {
			$Namen{$ref->[0]} = $ref->[1];
		}
	}
	$sth->finish;
	return %Namen;
}

			##### tools #######
#####
	#### Formulare
#####
sub TeamSuchen {
	my $Script = shift;
	my $Action = shift;
	my $SpecialA = shift || 1;
	local *_Formular_Team = sub {
		print "<table>";
		print "<tr><td>";
		if ($SpecialA == 1) {
			print "<b>Clan/Team suchen:</b>";
		} elsif ($SpecialA == 2) {
			print "<b>User suchen:</b>";
		} elsif ($SpecialA == 3) {
			print "<b>Clan/Team suchen:</b>";
		} else {
			print "<b>Gegner suchen:</b>";
		}
		print "</td></tr>";
		print "<tr><td>";
		print start_form('post',"$Script?League=$LSC{League}&Action=$Action");
		
		print $q->textfield('Name','',30)." ".$q->hidden('search', 1).$q->hidden('kindofsearch', ($SpecialA || 0)).submit('search').end_form;
		print "</td><td valign=top>";

		print start_form('post',"$Script?League=$LSC{League}&Action=$Action");
		
		print "<B>ID: </B>".$q->textfield('Opponent','',10)." ".$q->hidden('kindofsearch', ($SpecialA || 0)).$q->hidden('Opponent-ID', 1);
		
		print submit('submit'),end_form;
		print "</td></tr>";
		print "</table>";
	};		
	if ($q->param('search')) {
		#nach dem Loginnamen bzw. Team-/Clannamen suchen
		my %Namen = SucheUsernamenTeamnamen($q->param('Name'),$SpecialA);
		
		if (%Namen) {
			print start_form('post',"$Script?League=$LSC{League}&Action=$Action");
			
			print "Whle ";
			if ($SpecialA == 1) {
				print "ein Clan/Team:".br;
			} elsif ($SpecialA == 2) {
				print "einen User:".br;
			} else {
				print "einen Gegner:".br;
			}
		
			print popup_menu(-name=>'Opponent', -values=>[sort {"\L$Namen{$a}" cmp
			"\L$Namen{$b}" } keys %Namen], -Labels=>\%Namen),' ', 
				$q->hidden('Opponent-ID', 1),submit('submit'),$q->hidden('kindofsearch'),end_form;
		} else {
			print "Nichts gefunden!";
		
		}
		print hr;
		print "New Search:".br;
		
		_Formular_Team();
	} elsif ($q->param('Opponent-ID') || $_[0]) {
		
		if ($SpecialA == 2) {
			unless (NameFromUserID($q->param('Opponent'))) {
				print "Unbekannte User-ID!".br;
				print hr;
				print "New Search:".br;
				_Formular_Team();
				return;
			}
			
		} else {
			unless (Teamvorhanden($q->param('Opponent'))) {
				print "Unbekannte Team-ID!".br;
				print hr;
				print "New Search:".br;
				_Formular_Team();
				return;
			}
		}

		return $q->param('Opponent');
	} else {
#		print "Search for Team/User or enter Team/User-ID:".br;
		
		_Formular_Team();
	}		
	return;
}

sub Round {
	my $Zahl = shift;
	my $digits = shift || 0;
	my $vorzeichen = 1;
	
	if ($digits) {
		$digits = 10**$digits;
		$Zahl = $Zahl * $digits;
	}
	if ($Zahl < 0) { $vorzeichen = -1; }
	$Zahl *= $vorzeichen;
	my $d = 0;
	
	$d=$Zahl-int($Zahl);
	if($d<0.5){
		$Zahl=int($Zahl)
	}else{
		$Zahl=int($Zahl)+1
	}
	$Zahl *= $vorzeichen;
	if ($digits) {
		return $Zahl / $digits;
	}
	return $Zahl;
}

sub RemoveHtmlFromText {
	my $text = shift or return;
	my $i=0;

	#html entfernen
	$text =~s/\</&lt/gg;
	$text =~s/\>/&gt/gg;

	#url umwandlung
	$text =~s/(\[url\])?http:\/\/(\S+)(\[\/url\])?/\[url\]$2\[\/url\]/gg;
	$i = 0; #sicherung
	while ($text =~ /\[url]\S+\[\/url\]/i && $i++ < 25) {
		$text =~ s/\[URL\](\<.+\>)?(http:\/\/)*(\S+)(\<.+\>)?\[\/URL\]/\<a href\=\"http:\/\/$3\" target\=_blank\>$3\<\/a\>/i;
	}
	$i = 0; #sicherung
	while ($text =~ /\[url\=\S+\][\S ]+\[\/url\]/i && $i++ < 25) {
		$text =~ s/\[url=(http:\/\/)?(\S+)\]([\S ]+)\[\/url\]/\<a href\=\"http:\/\/$2\" target\=_blank\>$3\<\/a\>/;
	}

	#layout
	$text =~ s/\[B\]([^[]+)\[\/B\]/\<B\>$1\<\/B\>/isgg;
	$text =~ s/\[U\]([^[]+)\[\/U\]/\<U\>$1\<\/U\>/isgg;
	$text =~ s/\[I\]([^[]+)\[\/I\]/\<I\>$1\<\/I\>/isgg;

	#email
	$text =~ s/\[email\](.+)\[\/email\]/\<a class=MessageLink href\=\"mailto:$1\"\>$1\<\/a\>/isgg;

	#quote
	$i=0; #sicherung
	while ($text =~/(.*)\[quote\](.*)\[\/quote\](.*)/is && $i++ <25) {
		$text = $1.'<table width=90% align=center><tr><td class=MessageQuote>'.$2.'</td></tr></table>'.$3;
	}

	#zeilenumbrche
	$text =~s/\n/<br>/gg;

	return $text;
}
sub RemoveMyTagsFromText {
	my $text = shift or return;
	my $keinezeilenumbrueche = shift || 0;
	my $i=0;



	#layout
	$text =~ s/\[B\]([^[]+)\[\/B\]/\<B\>$1\<\/B\>/isgg;
	$text =~ s/\[U\]([^[]+)\[\/U\]/\<U\>$1\<\/U\>/isgg;
	$text =~ s/\[I\]([^[]+)\[\/I\]/\<I\>$1\<\/I\>/isgg;

	#email
	$text =~ s/\[email\](.+)\[\/email\]/\<a class=MessageLink href\=\"mailto:$1\"\>$1\<\/a\>/isgg;

	#quote
	$i=0; #sicherung
	while ($text =~/(.*)\[quote\](.*)\[\/quote\](.*)/is && $i++ <25) {
		$text = $1.'<table width=90% align=center><tr><td class=MessageQuote>'.$2.'</td></tr></table>'.$3;
	}

	#zeilenumbrche
	unless ($keinezeilenumbrueche) {
		$text =~s/\n/<br>/gg;
	}

	return $text;
}			

########## counter ###########

###### tools ########
sub randomcode {
 my $anzahl = $_[0] || 12;
 my $code='';
 my $data='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
 for (my $i=0; $i<$anzahl ; $i++) {
	$code .= substr($data, rand(52), 1);
 }
 return $code;
}



###### layout #####
################ einfuegen #########

sub AddICQOnlineStatus {
	my $uin = $_[0];
#	my $icqadd = '<a href="http://wwp.icq.com/scripts/search.dll?to='.$uin.'" target="_blank"><img src="/images/icqadd.gif" alt="'.$uin.'" border="0"></a>';
	my $icqadd = '<a href="http://wwp.icq.com/scripts/search.dll?to='.$uin.'" target="_blank">add</a>';
	my $icqonline ='<img src="http://wwp.icq.com/scripts/online.dll?icq='.$uin.'&img=5" alt="'.$uin.'" border="0"></a>';
	return $icqonline.$icqadd;
}
1;
