
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




#newssystem
$LSC{lsc_news_table} = $LSC{lsc_news_table} || 'lsc_news';
$LSC{lsc_news_comments_table} = $LSC{lsc_news_comments_table} ||'lsc_news_comments';

# news ids:
# id > 0 league
# id = 0 global
# id = -1 faq
sub NewsLaden {
	unless ($LSC{News}) { return; }
	my $NewsID = shift || 0;
	my $anzahl = shift || 0;
	my $Direktladen = shift || 0;	
	my $League = shift || 0;	

	my ($select,$from,$where,$group,$order);
		$select	= "ID, NewsID, Headline, Text, Author,DATE_FORMAT(Date,'%e. %M %Y'), DATE_FORMAT(Date,'%T'), SmallText, Views, Public";
		$from	= "$LSC{lsc_news_table}";
		if ($Direktladen) {
			#spezielle news laden
			$where  = "ID=".$LSC{MySQL}->quote($NewsID);
			if ($League) {
				$where  .= "and NewsID=".$LSC{MySQL}->quote($League);
			}
		} else {
			$where	= "NewsID=".$LSC{MySQL}->quote($NewsID);
		}
		$group	= "";
		$order	= "Order by Date desc";
		if ($anzahl) {
			$order	.= " Limit $anzahl";
		}
	
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my @news;
	while (my @ref = $sth->fetchrow_array()) {
		push(@news, \@ref);
	}
	$sth->finish;
	$sth = $LSC{MySQL}->do("update $LSC{lsc_news_table} set Views=Views+1 where $where") if $Direktladen;


	return \@news;
}	
sub NewsLadenAll {
	unless ($LSC{News}) { return; }
	my $anzahl = shift || 0;

	my ($select,$from,$where,$group,$order);
		$select	= "ID, NewsID, Headline, Text, Author,DATE_FORMAT(Date,'%e. %M %Y'), DATE_FORMAT(Date,'%T'), SmallText, Views, Public";
		$from	= "$LSC{lsc_news_table}";
		$where	= "1";
		$group	= "";
		$order	= "Order by Date desc";
		if ($anzahl) {
			$order	.= " Limit $anzahl";
		}
	
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my @news;
	while (my @ref = $sth->fetchrow_array()) {
		push(@news, \@ref);
	}
	$sth->finish;

	return \@news;
}	
sub NewsPublicPost {
	my $NewsID = shift || return undef;
	my $sth = $LSC{MySQL}->prepare("SELECT Public FROM $LSC{lsc_news_table} WHERE ID=".$LSC{MySQL}->quote($NewsID));
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref ? $ref->[0] : 0;
}
sub NewsAnzeigen {
	unless ($LSC{News}) { return; }
	my $NewsID = shift;
	my $anzahl = shift || 0;

	unless (defined($NewsID)) { return; }
	my $DeleteNewsConfirm = 0;
	if ($LSC{NewsAction}) {
		my $naction = $LSC{Action};
		if ($naction && $naction eq 'NewsComment') {
			$naction = "";
		}
		my $NewsButton = "<table><tr><td>".$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$naction&Action2=$LSC{Action2}&special=$LSC{special}").
				$q->submit(-name=>"News-Uebersicht", -class=>'NewsButton').$q->end_form()."</td><td>".
				$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$naction&Action2=$LSC{Action2}&special=$LSC{special}").
				$q->hidden('NewsAction', 1).
				$q->hidden('NewsHistorie', 1).
				$q->submit(-name=>"ltere News", -class=>'NewsButton').$q->end_form()."</td></tr></table>";

		if ($q->param('NewsAction')) {
			if ($q->param('AddNews') && $LSC{NewsAdmin}) {
				NewsSpeichern($NewsID, $q->param('NewsHeadline'), $q->param('NewsShortText'), $q->param('NewsText'), 0, $q->param('Public'));

			} elsif ($q->param('DeleteNews') && $LSC{NewsAdmin}) {
				if ($q->param('DeleteNewsConfirm')) {
					NewsLoeschen($q->param('DeleteNewsID'));
				} else {
					$DeleteNewsConfirm = $q->param('DeleteNewsID');
				}

			} elsif ($q->param('EditNews')  && $LSC{NewsAdmin}) {
				print $NewsButton;
				if ($q->param('EditNewsSave')) {
					NewsSpeichern($NewsID, $q->param('NewsHeadline'), $q->param('NewsShortText'), $q->param('NewsText'), $q->param('EditNewsID'));
					NewsCommentAnzeigen($q->param('EditNewsID'));
					return;
				}

				print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
						$q->hidden('NewsAction', 1).
						$q->hidden('EditNews', 1).
						$q->hidden('EditNewsSave', 1).
						$q->hidden('EditNewsID').
						"Headline: ".$q->textfield('NewsHeadline', "", 40).br.br.
						"Kurz News:".br.br.$q->textarea('NewsShortText',"",10,40).br.
						"Vollstndige News:".br.br.$q->textarea('NewsText',"",10,40).
						$q->image_button(-name=>"News aendern", -src=>$LSC{imagepfad}."/lsc_button_edit.gif", align=>"middle").
						$q->end_form();

				return;

			} elsif ($q->param('NewsAddComment') && ($LSC{LOGIN} || NewsPublicPost($q->param('ForNews')))) {
				print $NewsButton;	
				my $delete = 0;
				if ($q->param('NewsComment')) {
					if ($LSC{LOGIN}) {
						$delete = NewsAddComment($q->param('ForNews'), $q->param('NewsComment'));
					} else {
						if ($q->param('Name')) {
							$delete = NewsAddComment($q->param('ForNews'), $q->param('NewsComment'), $q->param('Name'), $q->param('Email'));
						} else {
							print "<B>Bitte einen Namen angeben!</B>".br.br;
						}
					}
				}
				if ($delete) {
					$q->delete('NewsComment');
				}

				if (NewsCommentAnzeigen($q->param('ForNews'), $delete)) {
					return;
				}

			} elsif ($q->param('NewsDeleteComment') && $LSC{NewsAdmin}) {
				print $NewsButton;	
				NewsCommentLoeschen($q->param('CommentID'));
				if (NewsCommentAnzeigen($q->param('ForNews'))) {
					return;
				}

			} 
			if ($q->param('ShowNewsComment') ) {
				print $NewsButton;	
				if (NewsCommentAnzeigen($q->param('ForNews'))) {
					return;
				}

			} elsif ($q->param('NewsHistorie') ) {
				print $NewsButton;	
				NewsHistorie($NewsID);
				return;

			} else {
				print "".br;
			} 
		}

	}
	my $news = NewsLaden($NewsID, $anzahl);
	
		if ($news && $news->[0]) {
			
			my %Namen = ();
		
			foreach my $f (@{$news}) {
				my $values = "News-".$f->[0];
				$values->{"LSC-AnzahlKommentare"} = NewsCommentCount($f->[0]) || 0;
				$values->{"LSC-PostedBy"} = $Namen{$f->[4]} || NameFromUserID($f->[4]);
				$Namen{$f->[4]} = $values->{"LSC-PostedBy"};
				if ($values->{"LSC-PostedBy"}) {
					$values->{"LSC-PostedByLink"} = UserLink($values->{"LSC-PostedBy"}, $f->[4], "NewsLink");
				} else {
					$values->{"LSC-PostedByLink"} = "Unknown User";
				}
				$values->{"LSC-Headline"} = RemoveHtmlFromText($f->[2]);
				$values->{"LSC-PostDate"} = $f->[5];
				$values->{"LSC-PostTime"} = $f->[6];
#				$values->{"LSC-SmallNews"} = RemoveHtmlFromText(($f->[3] && $f->[7] ? $f->[7].'...' : $f->[7]) || $f->[3]);
				$values->{"LSC-SmallNews"} = ($f->[3] && $f->[7] ? $f->[7] : $f->[7]) || $f->[3];
				#.'...'
				$values->{"LSC-SmallNews"} = RemoveMyTagsFromText($values->{"LSC-SmallNews"});
#				$values->{"LSC-SmallNews"} =~s/\n/<br>/gg;
				$values->{"LSC-Views"} = $f->[8];

				$values->{"LSC-FullNewsButton"} = "";
				if ($f->[7]) {
					$values->{"LSC-FullNewsButton"} = $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
								$q->hidden('NewsAction', 1).
								$q->hidden('ShowNewsComment', 1).
								$q->hidden('ForNews', $f->[0]).
								$q->image_button(-name=>"Kommentare", -src=>$LSC{imagepfad}."/lsc_button_more.gif", align=>"middle").
								$q->end_form();
				}
				$values->{"LSC-FullNewsButton"} .= "smallnews";

#				$values->{"LSC-News"} = RemoveHtmlFromText($f->[3]);
#				$values->{"LSC-News"} = $f->[3];
#				$values->{"LSC-News"} =~s/\n/<br>/gg;
				$values->{"LSC-News"} = RemoveMyTagsFromText($f->[3]);

				$q->delete('ForNews');
				$values->{"LSC-KommentarButton"} = $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
								$q->hidden('NewsAction', 1).
								$q->hidden('ShowNewsComment', 1).
								$q->hidden('ForNews', $f->[0]).				
								$q->image_button(-name=>"Kommentare", -src=>$LSC{imagepfad}."/lsc_button_more.gif", align=>"middle");
				$values->{"LSC-KommentarLink"} = "";
				if ($LSC{"News.pl"}) {
					$values->{"LSC-KommentarLink"} = ShowLink({Name=>$values->{"LSC-AnzahlKommentare"}." Kommentare", Script=>"$scriptname", Action=>"NewsComment", Action2=>"", Special=>$f->[0], Class=>"NewsLink"}, 1);
				}
				if ($values->{"LSC-AnzahlKommentare"}) {
					$values->{"LSC-KommentarButton"} .= $q->image_button(-name=>"Kommentare", -src=>$LSC{imagepfad}."/lsc_button_kommentare.gif", align=>"middle");
				}
				$values->{"LSC-KommentarButton"} .= $q->end_form();
				
				if ($DeleteNewsConfirm && $DeleteNewsConfirm==$f->[0]) {
					$q->delete('DeleteNewsID');
					$values->{"LSC-AdminButton"} = ($LSC{NewsAdmin} ?
							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
							$q->hidden('NewsAction', 1).
							$q->hidden('DeleteNews', 1).
							$q->hidden('DeleteNewsConfirm', 1).
							$q->hidden('DeleteNewsID', $f->[0]).'Wirklich loeschen? '.
							$q->image_button(-name=>"News loeschen", -src=>$LSC{imagepfad}."/lsc_button_admin.gif", align=>"middle").
							$q->end_form() : "");
				} else {
					$q->delete('DeleteNewsID');
					$values->{"LSC-AdminButton"} = ($LSC{NewsAdmin} ?
							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
							$q->hidden('NewsAction', 1).
							$q->hidden('DeleteNews', 1).
							$q->hidden('DeleteNewsID', $f->[0]).
							$q->image_button(-name=>"News loeschen", -src=>$LSC{imagepfad}."/lsc_button_admin.gif", align=>"middle").
							$q->end_form() : "");
				}
				print TemplateShow($LSC{Templates}{'News'}, $values);
			}
			print "<table><tr><td>".
				$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
				$q->hidden('NewsAction', 1).
				$q->hidden('NewsHistorie', 1).
				$q->submit(-name=>"ltere News", -class=>'NewsButton').$q->end_form()."</td></tr></table>";
		}
		
	# neue News:
	if ($LSC{NewsAdmin}) {
		print br.br.hr;
		$q->delete('NewsHeadline');
		$q->delete('NewsText');
		
		print "<b>[ADMIN] Neue News posten:</b>".br.br;
		print start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		print "Headline: ", $q->textfield('NewsHeadline', '', 40),br.br;
		print "Kurz News:", br,br, $q->textarea('NewsShortText',"",10,40),br.br;
		print "Vollstndige News:", br,br, $q->textarea('NewsText',"",10,40).br.br;
		print $q->hidden('NewsAction', 1);
		print $q->hidden('AddNews', 1);
		print "Kommentare drfen von allen oder nur von registrierten Besuchern geschrieben werden:".br;
		print $q->popup_menu(-name=>'Public', -values=>[0, 1], -Labels=>{0=>"registrierten", 1=>"alle"}, -default=>"0");
		print br.br.submit('speichern'),end_form;
		print '[quote] Zitat [quote]<br>[email]<A HREF="email@blabla.xyz">email@blabla.xyz</A>[/email]<br>[b]<b>fett</b>[/b]<br>[u]<u>unterstrichen</u>[/u]<br>[i]<i>kursiv</i>[/i]';
	}
}
sub NewsCommentAnzeigen {
	unless ($LSC{News}) { return; }
	my $ForNews = shift;
	my $hideform = shift || 0;

	my $news = NewsLaden($ForNews, 1, 1);
	
	unless ($news && $news->[0]) {
		print "News wurde nicht gefunden.".br;
		return;
	}
	
	my $f = $news->[0];
	my $Template = TemplateLoad1($LSC{Templates}{'NewsFull'});

	unless ($Template) {
		print "Konnte Template fr News nicht laden! ($!)".br;
		return;
	}
	
	my %Namen = ();
	# news ausgeben
				my $values = {};
				$values->{"LSC-AnzahlKommentare"} = NewsCommentCount($f->[0]) || 0;
				$values->{"LSC-PostedBy"} = $Namen{$f->[4]} || NameFromUserID($f->[4]);
				$Namen{$f->[4]} = $values->{"LSC-PostedBy"};
				if ($values->{"LSC-PostedBy"}) {
					$values->{"LSC-PostedByLink"} = UserLink($values->{"LSC-PostedBy"}, $f->[4], "NewsLink");
				} else {
					$values->{"LSC-PostedByLink"} = "Unknown User";
				}
				$values->{"LSC-Headline"} = RemoveHtmlFromText($f->[2]);
				$values->{"LSC-PostDate"} = $f->[5];
				$values->{"LSC-PostTime"} = $f->[6];
#				$values->{"LSC-SmallNews"} = RemoveHtmlFromText($f->[7] || $f->[3]);
				$values->{"LSC-SmallNews"} = $f->[7] || $f->[3];
				$values->{"LSC-SmallNews"} =~s/\n/<br>/gg;
				$values->{"LSC-Views"} = $f->[8];

#				$values->{"LSC-News"} = RemoveHtmlFromText($f->[7]."\n".$f->[3]);
				$values->{"LSC-News"} = $f->[7]."\n".$f->[3];
				$values->{"LSC-News"} =~s/\n/<br>/gg;

#				$values->{"LSC-AdminButton"} = ($LSC{NewsAdmin} ?
#							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
#							$q->hidden('NewsAction', 1).
#							$q->hidden('DeleteNews', 1).
#							$q->hidden('ShowNewsComment').
#							$q->hidden('DeleteNewsID', $f->[0]).
#							$q->image_button(-name=>"News loeschen", -src=>$LSC{imagepfad}."/lsc_button_admin.gif", align=>"middle").
#							$q->end_form() : "");
				if ($q->param('DeleteNewsID')==$f->[0]) {
					$q->delete('DeleteNewsID');
					$values->{"LSC-AdminButton"} = ($LSC{NewsAdmin} ?
							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
							$q->hidden('NewsAction', 1).
							$q->hidden('DeleteNews', 1).
							$q->hidden('ForNews').
							$q->hidden('ShowNewsComment').
							$q->hidden('DeleteNewsConfirm', 1).
							$q->hidden('DeleteNewsID', $f->[0]).'Wirklich loeschen? '.
							$q->image_button(-name=>"News loeschen", -src=>$LSC{imagepfad}."/lsc_button_admin.gif", align=>"middle").
							$q->end_form() : "");
				} else {
					$q->delete('DeleteNewsID');
					$values->{"LSC-AdminButton"} = ($LSC{NewsAdmin} ?
							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
							$q->hidden('NewsAction', 1).
							$q->hidden('ForNews').
							$q->hidden('ShowNewsComment').
							$q->hidden('DeleteNews', 1).
							$q->hidden('DeleteNewsID', $f->[0]).
							$q->image_button(-name=>"News loeschen", -src=>$LSC{imagepfad}."/lsc_button_admin.gif", align=>"middle").
							$q->end_form() : "");
				}

				$values->{"LSC-Edit"} = ($LSC{NewsAdmin} ?
							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
							$q->hidden('NewsAction', 1).
							$q->hidden('EditNews', 1).
							$q->hidden('EditNewsID', $f->[0]).
							$q->hidden('NewsHeadline', $f->[2]).
							$q->hidden('NewsShortText', $f->[7]).
							$q->hidden('NewsText', $f->[3]).
							$q->image_button(-name=>"News aendern", -src=>$LSC{imagepfad}."/lsc_button_edit.gif", align=>"middle").
							$q->end_form() : "");

				print TemplateMaker($Template->{'News'}, $values);

		if ($values->{"LSC-AnzahlKommentare"}) {
			print TemplateMaker($Template->{'KommentareHeadline'}, {});
			#Kommentare einfgen
			my ($select,$from,$where,$group,$order);
				$select	= "ID, ForNews, Kommentar, Author,DATE_FORMAT(Time,'%e. %M %Y'),DATE_FORMAT(Time,'%T'), Name, Email";
				$from	= "$LSC{lsc_news_comments_table}";
				$where	= "ForNews=".$LSC{MySQL}->quote($ForNews);
				$group	= "";
				$order	= "Order by Time asc";
	
			my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
			$sth->execute();
			$q->delete('CommentID');
			
			while (my @f = $sth->fetchrow_array()) {
				my $values = {};

				$values->{"LSC-PostedBy"} = $Namen{$f[3]} || NameFromUserID($f[3]);
				$Namen{$f[3]} = $values->{"LSC-PostedBy"};
				$values->{"LSC-PostedByLink"} = "Unknown User";
				if ($values->{"LSC-PostedBy"}) {
					$values->{"LSC-PostedByLink"} = UserLink($values->{"LSC-PostedBy"}, $f[3], "NewsLink");
				} else {
					if ($f[6]) {
						$values->{"LSC-PostedBy"} = $f[6];
						$values->{"LSC-PostedByLink"} = $f[6];
						if ($f[7]) {
							$values->{"LSC-PostedByLink"} = '<A class="NewsLink" HREF="mailto:'.$f[7].'">'.$values->{"LSC-PostedBy"}.'</A>';
						}
					} else {
						$values->{"LSC-PostedBy"} = "Unknown User";
						$values->{"LSC-PostedByLink"} = "Unknown User";
					}
				}
				$values->{"LSC-Kommentar"} = RemoveHtmlFromText($f[2]);
				$values->{"LSC-PostDate"} = $f[4];
				$values->{"LSC-PostTime"} = $f[5];
				
				$values->{"LSC-AdminButton"} = ($LSC{NewsAdmin} ?
							$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
							$q->hidden('NewsAction', 1).
							$q->hidden('NewsDeleteComment', 1).
							$q->hidden('CommentID', $f[0]).
							$q->hidden('ForNews', $f[1]).
							$q->image_button(-name=>"News loeschen", -src=>$LSC{imagepfad}."/lsc_button_admin2.gif", align=>"middle").
							$q->end_form() : "");
				print TemplateMaker($Template->{'Kommentare'}, $values);
			}
			$sth->finish;
		}	
		$q->delete('ForNews');
		#$q->delete('NewsComment');
	
		if ($hideform) {
			print br.br.br;
			return 1;
		}

		if ($LSC{LOGIN}) {
				print br.br.hr;
				print start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
				print "<b>Kommentar hinzufgen:</b>", br;
				print br.$q->textarea('NewsComment',"",6,30).br."HTML Code ist nicht erlaubt!";
				print $q->hidden('NewsAction', 1);
				print $q->hidden('NewsAddComment', 1);
				print $q->hidden('ForNews', $ForNews);
				print br.br.submit('speichern'),end_form;

				print '[quote] Zitat [quote]<br>[email]<A HREF="email@blabla.xyz">email@blabla.xyz</A>[/email]<br>[b]<b>fett</b>[/b]<br>[u]<u>unterstrichen</u>[/u]<br>[i]<i>kursiv</i>[/i]';
		} elsif ($f->[9]) {
				print br.br.hr;
				print start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
				print "<b>Kommentar hinzufgen:</b>", br;
				print "Name:".br;
				print $q->textfield('Name','',30).br;
				print "Email:".br;
				print $q->textfield('Email','',30).br;
				print br.$q->textarea('NewsComment',"",6,30).br."HTML Code ist nicht erlaubt!";
				print $q->hidden('NewsAction', 1);
				print $q->hidden('NewsAddComment', 1);
				print $q->hidden('ForNews', $ForNews);
				print br.br.submit('speichern'),end_form;

				print '[quote] Zitat [quote]<br>[email]<A HREF="email@blabla.xyz">email@blabla.xyz</A>[/email]<br>[b]<b>fett</b>[/b]<br>[u]<u>unterstrichen</u>[/u]<br>[i]<i>kursiv</i>[/i]';
		} else {
			print "Bitte einloggen, um einen Kommentar zu schreiben.".br;
		}
		print br.br.br;
	return 1;
					
}
sub NewsNeuePopup {
			print start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
			print "<b>Kommentar hinzufgen:</b>", br;
			print br.$q->textarea('NewsComment',"",6,30).br."HTML Code ist nicht erlaubt!";
			print $q->hidden('NewsAction', 1);
			print $q->hidden('NewsAddComment', 1);
			print $q->hidden('ForNews', $ForNews);
			print br.br.submit('speichern'),end_form;

}
sub NewsCommentCount {
	my $ForNews = shift;
	unless ($ForNews) { return 0; }
	my $sth = $LSC{MySQL}->prepare("SELECT count(*) FROM $LSC{lsc_news_comments_table} WHERE ForNews=".$LSC{MySQL}->quote($ForNews));
	$sth->execute();
	my @ref = $sth->fetchrow_array();
	$sth->finish;
	return $ref[0] || 0;
}
sub NewsSpeichern {
	my $NewsID		= shift;
	my $Headline	= shift;
	my $ShortText	= shift;
	my $Text		= shift;
	my $UpdateID	= shift || 0; 
	my $Public		= shift || 0; 

	my $Author = $LSC{userid};
	
	if (!defined($NewsID) || !$Headline || (!$Text && !$ShortText) || !$Author) {
		print "News konnte nicht gespeichert werden!".br;
		return;
	}
	if ($UpdateID) {
		my $sth = $LSC{MySQL}->do("update $LSC{lsc_news_table} set ".
			"Headline=".$LSC{MySQL}->quote($Headline).", ".
			"SmallText=".$LSC{MySQL}->quote($ShortText).", ".
			"Text=".$LSC{MySQL}->quote($Text).", ".
			"Author=".$LSC{MySQL}->quote($Author)." where ID=$UpdateID and NewsID=$NewsID");
	} else {
		my $sth = $LSC{MySQL}->do("insert into $LSC{lsc_news_table} (NewsID, Headline, SmallText, Text, Public, Author, Date) Values
			(".$LSC{MySQL}->quote($NewsID).", ".
			$LSC{MySQL}->quote($Headline).", ".
			$LSC{MySQL}->quote($ShortText).", ".
			$LSC{MySQL}->quote($Text).", ".
			$LSC{MySQL}->quote($Public).", ".
			$LSC{MySQL}->quote($Author).", Now())");
	}
}
sub NewsLoeschen {
	my $ID = shift || 0;
	unless ($ID) { return; }
	
	my $sth = $LSC{MySQL}->do("delete from $LSC{lsc_news_table} where ID=".$LSC{MySQL}->quote($ID));
	$sth = $LSC{MySQL}->do("delete from $LSC{lsc_news_comments_table} where ForNews=".$LSC{MySQL}->quote($ID));
}
sub NewsAddComment {
	my $ForNews = shift;
	my $Text = shift;
	my $Name = shift || "";
	my $Email = shift || "";
	my $Author = $LSC{LOGIN} ? $LSC{userid} : 0;
	
	if (!$ForNews || !$Text || (!$Author && !$Name)) {
		print "<B>Kommentar konnte nicht gespeichert werden!</B>".br.br;
		return;
	}
	$Name =~s/\</&lt/gg;
	$Name =~s/\>/&gt/gg;
	$Email =~s/\</&lt/gg;
	$Email =~s/\>/&gt/gg;

	my $sth = $LSC{MySQL}->do("insert into $LSC{lsc_news_comments_table} (ForNews, Kommentar, Author, Name, Email) Values
			(".$LSC{MySQL}->quote($ForNews).", ".
			$LSC{MySQL}->quote($Text).", ".
			$LSC{MySQL}->quote($Author).", ".
			$LSC{MySQL}->quote($Name).", ".
			$LSC{MySQL}->quote($Email).
				")");
	
	print "<B>Kommentar gespeichert.</B>".br.br;
	return 1;
}
sub NewsCommentLoeschen {
	my $CommentID = shift || return;
	my $sth = $LSC{MySQL}->do("delete from $LSC{lsc_news_comments_table} where id=".$LSC{MySQL}->quote($CommentID));
	print "Kommentar geloescht.".br.br;
}	
sub NewsHistorieShow {
	NewsHistorie(-3);
}
sub NewsHistorie {
	unless ($LSC{News}) { return; }
	my $NewsID = shift || 0;
	my ($select,$from,$where,$group,$order);
		$select	= "ID, NewsID, Headline, DATE_FORMAT(Date,'%e. %M %Y %T')";
		$from	= "$LSC{lsc_news_table}";
			$where	= "NewsID=".$LSC{MySQL}->quote($NewsID);
		$group	= "";
		$order	= "Order by Date desc";
	
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my @news;
	print "<table>";
	while (my @ref = $sth->fetchrow_array()) {
		print '<tr><td class="NewsText">'.
				$ref[2]." ($ref[3])</td><td class=\"NewsText\">".$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
				$q->hidden('NewsAction', 1).
				$q->hidden('ShowNewsComment', 1).
				$q->hidden('ForNews', $ref[0]).
				$q->image_button(-name=>"Zeige", -src=>$LSC{imagepfad}."/lsc_button_more.gif", align=>"middle").
				"</td></tr>".$q->end_form();
	}
	print "</table>";
	$sth->finish;
}

1
