#!/usr/bin/perl -w


###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw(%LSC %Select $LSCPackagePfad $q $scriptname);

require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 1;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();


require $LSCPackagePfad."LSCInit.pm";
# Main #
&LayoutEins;
if ($q->cgi_error) {
	print $LSC{TEXT}{ERROR}[10].br;
} else {
	print <<"ende";
<table width=100%>
<tr>
<td class=Headline><b>LigaScript  - unlock account:</b>
</td>
</tr>
</table>
ende
	if ($q->param('User') && $q->param('Key')) {
		if ($q->param('User')=~/[^0-9]/) {
			print "Unbekannte User-ID".br;
		} elsif (!UserKeyOK($q->param('User'), $q->param('Key'))) {
			print "Dieser Key ist nicht mehr aktuell!".br;
		} else {
			my $user = UserKontaktDatenFromUserID($q->param('User'));
			if ($user) {
				Require("LSCuser.create.pm");
				UserAcountFreischalten($user->{Login}, $q->param('User'));
				print "Dein Account ist nun freigeschaltet. Du kanst Dich nun einloggen.".br;
			} else {
				print "Es konnten nicht alle bentigten Daten gefunden werden. Bitte wende dich an eine Admin.".br;
			}
		}
	} else {
		print "Es wurden nicht alle Informationen bermittelt. Bitte wende dich an einen Admin.".br;
	}
}
&LayoutZwei;

MySQLDisconnect($LSC{MySQL}); #in Init initialisiert

# /Main #
sub UserKeyOK {
	my $user = shift;
	my $key = $LSC{MySQL}->quote(shift);
	
	my ($select,$from,$where,$group,$order);
	$select	= "count(*)";
	$from	= "lsc_user_key";
	$where	= "UserID='$user' and AKey=$key";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;	
	
	return $ref->[0] > 0 ? 1 : 0;
}

