
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



sub ErgebnisseNeuForderung {
	if ($q->param("Forderung")) {
		ErgebnisseNeu(@_);
		return;
	} 
	$q->param("Forderung", $_[1]);
	ErgebnisseNeu($_[0]);
}

sub ErgebnisseNeu {
	my ($action, $actionid) = @_;
	if ($LSC{ErgebnisAdminMod}) {
		print "<div align=center>Adminmodus aktiviert!!!</div>";
	}
		print "<TABLE cellspacing=1 align=center width=500>";
		
		my @Forderungen = ();
		my %AllowedTeams = ();
		if (!$q->param("check") && !$q->param("save")) {
			%AllowedTeams = TeamsInDenenUserLeaderOderChiefIst($LSC{userid});
			@Forderungen = _MSGForderungenVonTeamsInAllenLigen(keys %AllowedTeams);
		}
	# forderungen/ergebnisse anzeigen
	if ($Forderungen[0] && !$action) {
			print "
				<TR>
					<TD class=Std1>$LSC{TEXT}{Ergebnisse}[26]: ($LSC{shortdate})</TD>
				</TR>
				<TR>
				<TD class=Std2>";
				
				print "<TABLE cellspacing=0>
					<!-- <TR>
						<TD class=Std1>ID</TD> <TD class=Std1>Date</TD> <TD class=Std1>Teams</TD>
					</TR> -->";
				my $LastLeague = 0;
				foreach (@Forderungen) {
					my $F = ForderungLaden($_);
# ID  League  Date  Special  F_Team1  F_Team2  F_Date  F_Map1  F_Map2  F_Msg1  F_Msg2  F_Confirm1  F_Confirm2  F_Change1  F_Change2  LastChange  
#		TeamLink({Name=>$F->{F_Teamname1}, ID=>$F->{F_Team1}, HideVote=>1, League=>$F->{League}}).
					if ($F) {
						if ($F && $LastLeague != $F->{League}) {
							if ($LastLeague != 0) {
								print "<TR>
									<TD class=Std2></TD> <TD class=Std2></TD> 
								</TR>";
							}
							print "<TR>
								<TD class=Std1></TD> <TD class=Std1>$F->{Liganame}:</TD> 
							</TR>";
							$LastLeague = $F->{League};	
						}
						my $Datum = ($F->{Date} ? $F->{Date} : $F->{F_Date});
						$Datum =~ s/ /&nbsp;/gg;
						print "
						<TR>
							<TD class=Std2><!-- $F->{ID} --></TD> 
							<TD class=Std2Small>&nbsp;&nbsp;".(
									ShowLink({Name=>"$F->{F_Teamname1} vs. $F->{F_Teamname2}", Script=>$scriptname, Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}})
										)."</TD>
							<TD class=Std2Small2>&nbsp;(".$Datum.")&nbsp;</TD>
									<TD class=Std2Small>";
						if ($F->{F_Confirm1} && $F->{F_Confirm2}) {
							# Beide besttigt
							$F->{Status} = $LSC{TEXT}{Forderung}[21]; #besttigt
							if ($F->{Date}) {
								#Ergebnis eingetragen
								if (($AllowedTeams{$F->{F_Team1}} && $F->{Confirm}{$F->{F_Team1}}) || ($AllowedTeams{$F->{F_Team2}} && 	$F->{Confirm}{$F->{F_Team2}})) {
									print $LSC{TEXT}{Ergebnisse}[27]; # Ergebnis unbesttigt
								} elsif (($AllowedTeams{$F->{F_Team1}} && !$F->{Confirm}{$F->{F_Team1}}) || ($AllowedTeams{$F->{F_Team2}} && 	!$F->{Confirm}{$F->{F_Team2}})) {
									print ShowLink({Name=>$LSC{TEXT}{Ergebnisse}[18], Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}); #besttigen
								} elsif ($LSC{ErgebnisAdminMod}) {
									#ok
								} else {
									print "?";
								}
							} else {
								print ShowLink({Name=>$LSC{TEXT}{Ergebnisse}[55], Script=>"$LSC{user_pl}", Action=>"NewGameF", Action2=>"", Special=>$F->{ID}, League=>$F->{League}}); #ergebnis eintragen
							}
						} else {
							if (($F->{F_Confirm1} && $AllowedTeams{$F->{F_Team1}}) || ($F->{F_Confirm2} && $AllowedTeams{$F->{F_Team2}})) {
								print $LSC{TEXT}{Forderung}[22]; # warte auf Gegner
							} else {
								print ShowLink({Name=>$LSC{TEXT}{Forderung}[31], Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}); #unbesttigt

							}

						}
							
						print "</TD></TR>";
					}
				}
				print "</TABLE><br><br>";	

			print	"</TD></TR>";
	} elsif ($action) {
			print "<TR>
			<TD class=Std2>";

		if ($action eq "Details") {
				my $F = ForderungLaden($actionid);
				if ($F) {
					if ($LSC{League} && $F->{League} == $LSC{League}) {
						ForderungZeigen($F);
					} else {
						print $LSC{TEXT}{Ergebnisse}[28].br;
						print ShowLink({Name=>"$F->{F_Teamname1} vs. $F->{F_Teamname2}", Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}); 
					}
				} else {
					print $LSC{TEXT}{Ergebnisse}[29].br; #Diese Forderung existiert nicht!
				}
		} elsif ($action eq "ReMove") {
				print "<div align=center class=Headline>$LSC{TEXT}{Forderung}[47]</div>";
				my $F = ForderungLaden($actionid);
				if ($F) {
					print ShowLink({Name=>"$F->{F_Teamname1} vs. $F->{F_Teamname2}", Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}).br.br; 
					if ($LSC{League} && $F->{League} == $LSC{League}) {
						if ($F->{Date} || $LSC{LeagueData}{Forderungen_ReMoveHours} == -1) {
							print $LSC{TEXT}{Forderung}[48].br;  #abbrechen nicht mglich
						} else {
							my $sth = $LSC{MySQL}->prepare("SELECT DATE_SUB('$F->{F_Date_Ori}', INTERVAL $LSC{LeagueData}{Forderungen_ReMoveHours} hour)> now()");
							my $ref = 0;
							if ($sth->execute()) {
								$ref = $sth->fetchrow_arrayref();
								$sth->finish;
							} else {
								Mysql_Error($sth);
							}

							if ($LSC{LeagueData}{Forderungen_ReMoveHours} == 0 || ($ref && $ref->[0])) {
								#lschen mglich, da innerhalb des zeitraumes
								if ($q->param("confirm")) {
									my $sth = $LSC{MySQL}->do("delete from lsc_games_waiting where WaitingID=$F->{ID}");
									$sth = $LSC{MySQL}->do("delete from lsc_games_waiting_daten where ID=$F->{ID}");
									print $LSC{TEXT}{Forderung}[50].br;
									
									my $ChiefTeam = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || 0;
									my $Team = 0;
									$Team = 1 if ($ChiefTeam eq $F->{F_Team1});
									$Team = 2 if ($ChiefTeam eq $F->{F_Team2});
									my $Team2 = $Team==1 ? 2 : 1;
									my $Name = "unknown";
									my @user = ();
									if ($Team == 1) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team2});
										$Name = $F->{F_Teamname1};
									} elsif ($Team == 2) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team1});
										$Name = $F->{F_Teamname2};
									}		
									my $Send = SendMessage(
										{	Email=>1, Intern=>1, 
											System=>1, 
											To=>[@user], From=>0, 
											ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
											DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
											Subject=>$LSC{TEXT}{Email}[5], 
											Message=>"", 
											Template=>$LSC{TEXT}{Email}[6], 
											TemplateValues=>{GEGNERNAME=>$Name, DATE=>$F->{F_Date}, TEAM1=>$F->{T_Teamname1}, TEAM2=>$F->{T_Teamname2}}
										});
									if ($Send) {
										print $Send.br.$LSC{TEXT}{Forderung}[38].br;
									}
								} else {
									print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame&Action2=ReMove&special=$F->{ID}");
									print $q->hidden('confirm', 1);
									print $q->submit($LSC{TEXT}{Forderung}[49]);
									print $q->endform();
								}
							} else {
								#nicht erlaubt
								print $LSC{TEXT}{Forderung}[48].br;
							}
						}
					} else {
						print $LSC{TEXT}{Ergebnisse}[28].br;
						print ShowLink({Name=>"$F->{F_Teamname1} vs. $F->{F_Teamname2}", Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}); 
					}
				} else {
					print $LSC{TEXT}{Ergebnisse}[29].br; #Diese Forderung existiert nicht!
				}
		} elsif ($action eq "Move") {
				print "<div align=center class=Headline>$LSC{TEXT}{Forderung}[33]</div>";
				my $F = ForderungLaden($actionid);
				if ($F) {
					print ShowLink({Name=>"$F->{F_Teamname1} vs. $F->{F_Teamname2}", Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}).br.br; 
					if ($LSC{League} && $F->{League} == $LSC{League}) {
						if ($F->{Date}) {
							print $LSC{TEXT}{Forderung}[34].br;  #verschieben nicht mglich
						} else {
							my $show = 1;

							my $ChiefTeam = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || 0;
							my $Team = 0;
							$Team = 1 if ($ChiefTeam eq $F->{F_Team1});
							$Team = 2 if ($ChiefTeam eq $F->{F_Team2});
							my $Team2 = $Team==1 ? 2 : 1;
							if ($q->param("DateTime")) {
								my $Date = _ForderungenDateTimeVerschiebungPruefen($F->{F_Date_Ori}, $q->param("DateTime"), 1);
								if ($Date) {

									my $sth = $LSC{MySQL}->do("update lsc_games_waiting_daten set F_ChangeDate='$Date', F_Change$Team=1, F_Change$Team2=0, F_ChangeMsg$Team=".$LSC{MySQL}->quote($q->param("comment") || "")." where ID=$F->{ID}");

									print $LSC{TEXT}{Forderung}[37].br;
									$show = 0;
								
									my $Name = "unknown";
									my @user = ();
									if ($Team == 1) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team2});
										$Name = $F->{F_Teamname1};
									} elsif ($Team == 2) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team1});
										$Name = $F->{F_Teamname2};
									}

		
									my $Send = SendMessage(
										{	Email=>1, Intern=>1, 
											System=>1, 
											To=>[@user], From=>0, 
											ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
											DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
											Subject=>$LSC{TEXT}{Email}[5], 
											Message=>"", 
											Template=>$LSC{TEXT}{Email}[6], 
											TemplateValues=>{GEGNERNAME=>$Name, NEWDATE=>$q->param("DateTime"), MESSAGE=>$q->param("comment") || $LSC{TEXT}{default}[8],
															LINK=>$LSC{ScriptURL}."$LSC{user_pl}?League=$LSC{League}&Action=NewGame&Action2=Move&special=".$F->{ID}}
										});
									if ($Send) {
										print $Send.br.$LSC{TEXT}{Forderung}[38].br;
									}
								} else {
									print $LSC{TempOut}.br;
								}
							# annehmen
							} elsif ($q->param($LSC{TEXT}{Forderung}[40]) && $F->{F_ChangeDateShow} && $F->{"F_Change".$Team} == 0) {
									my $sth = $LSC{MySQL}->do("update lsc_games_waiting_daten set F_Date=F_ChangeDate, F_Change1=0, F_Change2=0 where ID=$F->{ID}");

									print $LSC{TEXT}{Forderung}[44].br;
									$show = 0;
								
									my $Name = "unknown";
									my @user = ();
									if ($Team == 1) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team2});
										$Name = $F->{F_Teamname1};
									} elsif ($Team == 2) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team1});
										$Name = $F->{F_Teamname2};
									}

		
									my $Send = SendMessage(
										{	Email=>1, Intern=>1, 
											System=>1, 
											To=>[@user], From=>0, 
											ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
											DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
											Subject=>$LSC{TEXT}{Email}[5], 
											Message=>"", 
											Template=>$LSC{TEXT}{Email}[7], 
											TemplateValues=>{GEGNERNAME=>$Name, 
															NEWDATE=>$F->{F_ChangeDateShow}, 
															MESSAGE=>($q->param("comment") || $LSC{TEXT}{default}[8]),
															LINK=>$LSC{ScriptURL}."$LSC{user_pl}?League=$LSC{League}&Action=NewGame&Action2=Move&special=".$F->{ID}}
										});
									if ($Send) {
										print $Send.br.$LSC{TEXT}{Forderung}[38].br;
									}
							# ablehnen
							} elsif ($q->param($LSC{TEXT}{Forderung}[41]) && $F->{F_ChangeDateShow} && $F->{"F_Change".$Team} == 0) {
									my $sth = $LSC{MySQL}->do("update lsc_games_waiting_daten set F_ChangeDate='', F_Change1=0, F_Change2=0 where ID=$F->{ID}");

									print $LSC{TEXT}{Forderung}[45].br;
									$show = 0;
								
									my $Name = "unknown";
									my @user = ();
									if ($Team == 1) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team2});
										$Name = $F->{F_Teamname1};
									} elsif ($Team == 2) {
										@user = ChiefsUndLeaderEinesTeams($F->{F_Team1});
										$Name = $F->{F_Teamname2};
									}

		
									my $Send = SendMessage(
										{	Email=>1, Intern=>1, 
											System=>1, 
											To=>[@user, 1], From=>0, 
											ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
											DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
											Subject=>$LSC{TEXT}{Email}[5], 
											Message=>"", 
											Template=>$LSC{TEXT}{Email}[8], 
											TemplateValues=>{GEGNERNAME=>$Name, NEWDATE=>$F->{F_ChangeDateShow}, MESSAGE=>($q->param("comment") || $LSC{TEXT}{default}[8]),
															LINK=>$LSC{ScriptURL}."$LSC{user_pl}?League=$LSC{League}&Action=NewGame&Action2=Move&special=".$F->{ID}}
										});
									if ($Send) {
										print $Send.br.$LSC{TEXT}{Forderung}[38].br;
									}
							}

							if ($show) {
								if ($F->{F_ChangeDateShow} && $F->{"F_Change".$Team} == 0 && $F->{"F_Change".$Team2} == 1) {
									print $LSC{TEXT}{Forderung}[39]." ".$F->{F_ChangeDateShow}.br.br.br;
									print "<div class=Headline>".$F->{"F_Teamname".$Team2}."</div>".br;
									print "".(RemoveHtmlFromText($F->{"F_ChangeMsg".$Team2}) || "no comment").br.br;

									print "<div class=Headline>".$F->{"F_Teamname".$Team}."</div>".br;
									print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame&Action2=Move&special=$F->{ID}");
									print $LSC{TEXT}{Forderung}[10].br;
									print $q->textarea('comment',$F->{"F_ChangeMsg".$Team},5,35).br.br;
									print $q->hidden('Forderung');
									print $q->submit($LSC{TEXT}{Forderung}[40]);
									print $q->submit($LSC{TEXT}{Forderung}[41]).$q->endform();
									print br.$LSC{TEXT}{Forderung}[42].br;
								} elsif ($F->{F_ChangeDateShow} && $F->{"F_Change".$Team} == 1 && $F->{"F_Change".$Team2} == 0) {
									print $LSC{TEXT}{Forderung}[43]." ".$F->{F_ChangeDateShow}.br;
									print br.$LSC{TEXT}{Forderung}[42].br;
								} else {
									print $LSC{TEXT}{Forderung}[36].br;
								}
								print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame&Action2=Move&special=$actionid");
								print $q->hidden('Forderung');
								print $q->textfield('DateTime', $F->{F_Date}, 16);
								print $q->submit("change").br.br;
								print $LSC{TEXT}{Forderung}[10].br;
								print $q->textarea('comment',$F->{"F_ChangeMsg".$Team},5,35);
								print $q->endform();
								print $LSC{TEXT}{Forderung}[35]." -$LSC{LeagueData}{Forderungen_Change_Min}d / +$LSC{LeagueData}{Forderungen_Change_Max}".br;		
							}
						}
					} else {
						print $LSC{TEXT}{Ergebnisse}[28].br;
						print ShowLink({Name=>"$F->{F_Teamname1} vs. $F->{F_Teamname2}", Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$F->{ID}, League=>$F->{League}}); 
					}
				} else {
					print $LSC{TEXT}{Ergebnisse}[29].br; #Diese Forderung existiert nicht!
				}
		} else {
			print $LSC{TEXT}{Ergebnisse}[30].br; #unbekannte funktion
		}

		print "</TD></TR></table>";
		return;

	} elsif ($q->param("check") || $q->param("save")) {
		#nix anzeigen
	} else {
		print "<TR>
			<TD class=Std1>$LSC{TEXT}{Ergebnisse}[31]</TD>
			</TR>";		
		print "<TR>
			<TD class=Std2>&nbsp;</TD>
			</TR>";		
	}

		


	my $allowed = 1;
	# Prfen ob Ergebnisse eingetragen werden drfen
#$LSC{ErgebnisAdminMod} =1;
#$q->param("Forderung", 9);

	if (!$LSC{League}) {
		print "
			<TR>
				<TD class=Standard>";
		ErgebnisseNeuMoeglichIn();
		
		print "</TD></TR></table>";
		return;
	} 
	
	# Liga offen?
	elsif ($LSC{LeagueData}{Status} == 2) {
		print "
			<TR>
				<TD class=Standard>";
		print $LSC{TEXT}{Ergebnisse}[3].br; #geschlossen
		ErgebnisseNeuMoeglichIn();
		
		print "</TD></TR></table>";
		return;
	} 
	print "
		<TR>
			<TD class=Headline>Enter Result ($LSC{LeagueData}{Name})</TD>
		</TR>
		<TR>
			<TD class=Standard>
		";
	
	# teamzugewiesen?
	
	my $Team = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League});

	if (!$Team) {
		if (!$LSC{ErgebnisAdminMod}) {
			print $LSC{TEXT}{Ergebnisse}[4].br; #nicht erlaubt
			$allowed = 0;
		}
	} 
	
	elsif (TeamStatus($Team) != 0 || TeamLigaStatus($Team, $LSC{League}) != 0) {
			print $LSC{TEXT}{Ergebnisse}[4].br; #nicht erlaubt
			$allowed = 0;
	}

	unless ($allowed) {
		ErgebnisseNeuMoeglichIn();
		print "</TD>
			</TR>
			</TABLE>
			";
		return;
	}

	# Playoff Modus
	if ($LSC{userid} == 1) {
		print "Hi Hoax:".br;
		print "$LSC{LeagueData}{PlayoffDaten} && !$LSC{ErgebnisAdminMod}".br;
	}
		if ($LSC{LeagueData}{PlayoffDaten} && !$LSC{ErgebnisAdminMod}) {
			unless (PlayoffTeamAktiv($LSC{userteamid})) {
				print br."<div>Du kannst keine Spiele eintragen, da Du bereits aus dem
				Turnier ausgeschieden bist oder dein nchster Gegner noch nicht
				feststeht.</div>".br;
				print "</TD>
					</TR>
					</TABLE>
					";
				return;
			}
		}
	# /Playoff Modus
	# Liga verwendet einen Spielplan
		if ($LSC{LeagueData}{Spielplan}) {
			# 2 -> strenger Spielplan genau dran halten
			
			if ($LSC{LeagueData}{Spielplan}==2 && !$LSC{ErgebnisAdminMod}) {
				my ($o, undef) = SpielplanNeuesErgebnisMoeglich();
				unless ($o) {
					if ($LSC{Spieltag}) {
						#print "Es konnte kein Gegner fr diesen Spieltag ermittelt werden.";
					} else {
						print "Es wurde kein Spieltag festgelegt, deshalb knnen keine Ergebnisse eingetragen werdeb!".br;
					}
					print "</TD>
						</TR>
						</TABLE>
						";
					return;
				}
			}
		}
	# /Liga verwendet einen Spielplan


	# Test abgeschlossen, neues Ergebnis Mglich

	$q->param("Team1", $Team) unless $LSC{ErgebnisAdminMod};
	$q->param("Entered by", $Team) unless $LSC{ErgebnisAdminMod};
	
	$LSC{LeagueData}{Forderung} = ForderungLaden($q->param("Forderung")) if $q->param("Forderung");

	if ($q->param("Forderung") && $LSC{LeagueData}{Forderungen} == 0 && !$LSC{LeagueData}{Forderung}) {
		print $LSC{TEXT}{Forderung}[5].br;
		print "</TD>
			</TR>
			</TABLE>
			";
		return;

	} elsif ($q->param("Forderung")) {
			unless ($LSC{LeagueData}{Forderung}) {
				print $LSC{TEXT}{Ergebnisse}[32].br; #forderung konnte nicht geladen werden
				print "</TD>
					</TR>
					</TABLE>
					";
				return;
			}
			# schon ergebnisse eingtragen?
				my $sth = $LSC{MySQL}->prepare("SELECT Count(*) from lsc_games_waiting where WaitingID=$LSC{LeagueData}{Forderung}{ID}");
				if ($sth->execute()) {
					my $ref = $sth->fetchrow_arrayref();
					$sth->finish;
					if ($ref && defined $ref->[0] && $ref->[0] > 0) {
						print br.br.br.$LSC{TEXT}{Ergebnisse}[33].br.br.br;
					}


				} else {
					print br.br.br.$LSC{TEXT}{Ergebnisse}[34].br.br.br;
					print "</TD>
						</TR>
						</TABLE>
						";				
					return undef;
				}
 
			if ($LSC{LeagueData}{Forderung}{F_Confirm1} && $LSC{LeagueData}{Forderung}{F_Confirm2}) {
print "<!-- YYYY Werte aus Forderung bernehmen -->\n";
				$q->param("Team1", $LSC{LeagueData}{Forderung}{F_Team1});
				$q->param("Team2", $LSC{LeagueData}{Forderung}{F_Team2});
				$q->param("Map1", $LSC{LeagueData}{Forderung}{F_Map1});
				$q->param("Map2", $LSC{LeagueData}{Forderung}{F_Map2});
				if ($LSC{LeagueData}{Forderung}{GameDaten} &&
						!$q->param("Punkte1") && !$q->param("Punkte2") && !$q->param("Punkte21") && !$q->param("Punkte22")) {
					$q->param("Punkte1",  $LSC{LeagueData}{Forderung}{GameDaten}{$LSC{LeagueData}{Forderung}{F_Team1}}{PPoints1} || 0);
					$q->param("Punkte2",  $LSC{LeagueData}{Forderung}{GameDaten}{$LSC{LeagueData}{Forderung}{F_Team2}}{PPoints1} || 0);
					$q->param("Punkte21", $LSC{LeagueData}{Forderung}{GameDaten}{$LSC{LeagueData}{Forderung}{F_Team1}}{PPoints2} || 0);
					$q->param("Punkte22", $LSC{LeagueData}{Forderung}{GameDaten}{$LSC{LeagueData}{Forderung}{F_Team2}}{PPoints2} || 0);
				}

			} else {
				print $LSC{TEXT}{Ergebnisse}[35].br.br.br; #Forderung wurde noch nicht besttigt
				print "</TD>
					</TR>
					</TABLE>
					";
				return;
			}

	}

	# prfen ob Forderungsid existiert und noch keine ergbnisse eingetragen
	if ($q->param("Team1") && $q->param("Team2") && !$q->param("Forderung")) {
		if (_ErgebnisseZwischenTeamATeamBinWarteliste($q->param("Team1"), $q->param("Team2"))) {
			print $LSC{TEXT}{Ergebnisse}[36].br.br.br; #Es ist bereits ein offenes Match zwischen diesen Teams vorhanden!
			print "</TD>
				</TR>
				</TABLE>
				";				
			return;
		}
	}

	if ($q->param("save")) {
		ErgebnisNeuSpeichern();
	} elsif ($q->param("check")) {
		$LSC{ErgebnisNeuCheckOk} = 1;
		if (my $Game = ErgebnisNeuCheck()) {
			print "check ok!".br;
			if ($LSC{ForceDraws} && $LSC{LeagueData}{NewGamePoints}{ForceDraws}) {
				# Spezialmodus, es wird ein Sieger erwartet, da aber ein unentschieden
				# eingegeben wurde, wird so lange ein neues Formular ausgegeben, bis ein
				# Sieger feststeht
				
				ErgebnisNeuFormular();
			} else {
				print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame");
	
				print $q->hidden('Team1');
				print $q->hidden('Team2');

				print $q->hidden('Teamname1');
				print $q->hidden('Teamname2');

				print $q->hidden('Map1');
				print $q->hidden('Map2');

				print $q->hidden('Punkte1');
				print $q->hidden('Punkte2');

				print $q->hidden('Punkte21');
				print $q->hidden('Punkte22');

				print $q->hidden('won');
				print $q->hidden('won1');
				print $q->hidden('won2');

				print $q->hidden('where');
				print $q->hidden('POG-Name');
				print $q->hidden('overtime');
				print $q->hidden('vote');
		
				print $q->hidden('Forderung');
				print $q->hidden('save', 1);

				print $q->hidden("AdminSpieltag");

				if ($LSC{LeagueData}{NewGamePoints}{ForceDraws} && $q->param("FD-Counter") && $q->param("FD-Counter") > 0) {
					_NeuesSpiel_ForceDraw_sichern();
				} else {
					_Ergebnisse_Formular(1);
				}
				print $LSC{TEXT}{Ergebnisse}[37].br.br; #Ergebnis speichern:
				print $q->image_button(-name=>"submit", -src=>$LSC{imagepfad}."/lsc_newgame.gif", align=>"middle");
				print $q->endform();
			}
		} else {
			$LSC{ErgebnisNeuCheckOk} = 0;
			ErgebnisNeuFormular();
		}
	} else {
		ErgebnisNeuFormular();
		ErgebnisseNeuMoeglichIn();

	}

	print "</TD>
		</TR>
		</TABLE>
		";

}

sub ErgebnisNeuCheck {
	unless (_Ergebnisse_PunkteDefinition_Laden()) {
		print $LSC{TEXT}{Ergebnisse}[38].br;
		return undef;
	}
	
	# bergebene Werte Prfen

	# Werte festlegen, die nicht null sein drfen:
	my @NotNull = qw(Team1 Team2);
	# Werte festlegen, die >= 0 sein mssen:
	my @Defined = qw(Teamname1 Teamname2 vote);
	# Werte festlegen, die eine Zahl sein mssen:
	my @Number = qw(Team1 Team2);
	
	if ($LSC{LeagueData}{AnzahlMaps} == 1) {
		push (@defined, qw(Map1));
		push (@NotNull, qw(Map1)) if $LSC{LeagueData}{Mapliste} > 0;
	}
	elsif ($LSC{LeagueData}{AnzahlMaps} == 2) {
		push (@defined, qw(Map1 Map2));
		push (@NotNull, qw(Map1 Map2)) if $LSC{LeagueData}{Mapliste} > 0;
		
	}
	unless (_Ergebnisse_Formularwahl_Laden()) {
		print $LSC{TEXT}{Ergebnisse}[39].br;
		return undef;
	}


	if ($LSC{LeagueData}{NewGameForm}{'Team-Punkte'}) {
		push (@Defined, qw(Punkte1 Punkte2));
		push (@Number, qw(Punkte1 Punkte2));

	} elsif ($LSC{LeagueData}{NewGameForm}{'Team-Punkte-Map'}) {
		push (@Defined, qw(Punkte1 Punkte2 Punkte21 Punkte22));
		push (@Number, qw(Punkte1 Punkte2 Punkte21 Punkte22));

	} elsif ($LSC{LeagueData}{NewGameForm}{'Team-Sieg-Unentschieden-Map'}) {
		push (@NotNull, qw(won1 won2));
		push (@Number, qw(won1 won2));

	} elsif ($LSC{LeagueData}{NewGameForm}{'Team-Sieg'}) {
		push (@NotNull, qw(won1 won2));
		push (@Number, qw(won1 won2));

	} elsif ($LSC{LeagueData}{NewGameForm}{'Team-Sieg-Unentschieden'}) {
		push (@NotNull, qw(won));
		push (@Number, qw(won));

	}


	foreach my $value (@Defined) {
		if (!(defined $q->param("$value")) || $q->param("$value") eq "") {
			print $LSC{TEXT}{Ergebnisse}[13]."($value = ?)".br;
			return undef;
		}
	}
	foreach my $value (@Number) {
		if ($q->param("$value") =~/[^0-9]/) {
			print $LSC{TEXT}{Ergebnisse}[14]."($value = ".$q->param("$value").")".br;
			return undef;
		}
	}
	foreach my $value (@NotNull) {
		if (!(defined $q->param("$value")) || $q->param("$value") eq "" || $q->param("$value") == 0) {
			print $LSC{TEXT}{Ergebnisse}[13]."($value > 0)".br;
			return undef;
		}
	}

	my @Names	= qw(Team	Teamname	Map		Punkte1		Punkte2);
	my @Values1 = qw(Team1	Teamname1	Map1	Punkte1		Punkte21);
	my @Values2 = qw(Team2	Teamname2	Map2	Punkte2		Punkte22);

	my $Game = 1;
	my $Team1 = 2;
	my $Team2 = 3;
	for (my $i=0; $i <= 4; $i++) {
		$Team1->{$Names[$i]} = $q->param($Values1[$i]) || ($i > 2 ? 0 : "");
		$Team2->{$Names[$i]} = $q->param($Values2[$i]) || ($i > 2 ? 0 : "");
	}

	$Team1->{Gesamtpunkte} = ($Team1->{Punkte1} || 0) + ($Team1->{Punkte2} || 0);
	$Team2->{Gesamtpunkte} = ($Team2->{Punkte1} || 0) + ($Team2->{Punkte2} || 0);

	$Team1->{Map}  = $q->param("Map1") || "";
	$Team2->{Map}  = $q->param("Map2") || "";

	$Team1->{Vote} = $q->param("vote") || 3;
	$Team2->{Vote} = 0;

	$Team1->{Won}  = 0;
	$Team1->{Lost} = 0;
	$Team1->{Draw} = 0;

	$Team2->{Won}  = 0;
	$Team2->{Lost} = 0;
	$Team2->{Draw} = 0;

	# Punkte1 und Punkte2 auf Null setzen oder umsetzen
	# Weitere Vernderungen, wenn ClanLigen aktiviert
	if ($LSC{LeagueData}{AnzahlMaps} <= 1) {
		$Team1->{Punkte1} = 0;
		$Team1->{Punkte2} = 0;
		$Team2->{Punkte1} = 0;
		$Team2->{Punkte2} = 0;
	}
	if ($LSC{LeagueData}{NewGameForm}{'Team-Punkte'} 
			|| $LSC{LeagueData}{NewGameForm}{'Team-Punkte-Map'}
		) {
		if ($Team1->{Gesamtpunkte} > $Team2->{Gesamtpunkte}) {
			$Team1->{Won}  = 1;
			$Team1->{Lost} = 0;
			$Team1->{Draw} = 0;

			$Team2->{Won}  = 0;
			$Team2->{Lost} = 1;
			$Team2->{Draw} = 0;

		} elsif ($Team1->{Gesamtpunkte} < $Team2->{Gesamtpunkte}) {
			$Team1->{Won}  = 0;
			$Team1->{Lost} = 1;
			$Team1->{Draw} = 0;

			$Team2->{Won}  = 1;
			$Team2->{Lost} = 0;
			$Team2->{Draw} = 0;

		} elsif ($LSC{LeagueData}{NewGamePoints}{Draws} || $LSC{LeagueData}{NewGamePoints}{ForceDraws}) {
			$Team1->{Won}  = 0;
			$Team1->{Lost} = 0;
			$Team1->{Draw} = 1;

			$Team2->{Won}  = 0;
			$Team2->{Lost} = 0;
			$Team2->{Draw} = 1;

			$LSC{ForceDraws} = 1 if $LSC{LeagueData}{NewGamePoints}{ForceDraws};

		} else {
			print $LSC{TEXT}{Ergebnisse}[40].br; #Unentschieden nicht erlaubt
			return undef;
		}

	} elsif ($LSC{LeagueData}{NewGameForm}{'Team-Sieg-Unentschieden-Map'}
		|| $LSC{LeagueData}{NewGameForm}{'Team-Sieg'}
		|| $LSC{LeagueData}{NewGameForm}{'Team-Sieg-Unentschieden'}
		) {
		my $T1 = 0;
		my $T2 = 0;
		if ($q->param("won1")) {
			if ($q->param("won1") == 1) {
				$T1++;
			} elsif ($q->param("won1") == 2) {
				$T2++;
			} 
			if ($q->param("won2") == 1) {
				$T1++;
			} elsif ($q->param("won2") == 2) {
				$T2++;
			} 
		} else {
			if ($q->param("won") == 1) {
				$T1++;
			} elsif ($q->param("won") == 2) {
				$T2++;
			} 
		}

		if ($T1 > $T2) {
			$Team1->{Won}  = 1;
			$Team1->{Lost} = 0;
			$Team1->{Draw} = 0;

			$Team2->{Won}  = 0;
			$Team2->{Lost} = 1;
			$Team2->{Draw} = 0;

		} elsif ($T1 < $T2) {
			$Team1->{Won}  = 0;
			$Team1->{Lost} = 1;
			$Team1->{Draw} = 0;

			$Team2->{Won}  = 1;
			$Team2->{Lost} = 0;
			$Team2->{Draw} = 0;

		} elsif ($LSC{LeagueData}{NewGamePoints}{Draws} || $LSC{LeagueData}{NewGamePoints}{ForceDraws}) {
			$Team1->{Won}  = 0;
			$Team1->{Lost} = 0;
			$Team1->{Draw} = 1;

			$Team2->{Won}  = 0;
			$Team2->{Lost} = 0;
			$Team2->{Draw} = 1;

			$LSC{ForceDraws} = 1 if $LSC{LeagueData}{NewGamePoints}{ForceDraws};
		} else {
			print $LSC{TEXT}{Ergebnisse}[40].br; #Unentschieden nicht erlaubt
			return undef;
		}
	} 

	if ($q->param("where") && $q->param("where") eq "road") {
		my $x = $Team1;
		$Team1 = $Team2;
		$Team2 = $x;
	}

	$Game->{Team1} = $Team1;
	$Game->{Team2} = $Team2;
	$Game->{Forderung} = $q->param("Forderung") || 0;
	$Game->{overtime} = $q->param("overtime") || 0;
	$Game->{PogName} = $q->param("POG-Name") || "";

	return $Game;
}
sub ErgebnisNeuSpeichern {
	my $Game = ErgebnisNeuCheck();
	unless ($Game) {
		return undef;
	}

	$Game = _Ergebnisse_LigaPunkteBerechnen($Game);

	if ($LSC{LeagueData}{NewGamePoints}{ForceDraws} && $q->param("FD-Counter") && $q->param("FD-Counter") > 0) {
		my $temp = "<b>Ergebnisse im Ueberblick:</b>".br.br;
		for(my $i=1; $i <= $q->param("FD-Counter"); $i++) {
			$temp .= $q->param('Uebersicht#'.$i);
		}
		$Game->{Info} .= "\n\n".$temp;
	}
	my $InfoOut = $Game->{Info};
	$InfoOut =~s/\n/\<br\>/gg;
	print $InfoOut.br;

	my $ForderungsID = $q->param("Forderung") || 0;
	unless ($ForderungsID) {
		#ForderungsID erzeugen
		my $sth = $LSC{MySQL}->prepare("insert into lsc_games_waiting_daten (League) Values ($LSC{League})");
		$sth->execute();
		$ForderungsID = $sth->{mysql_insertid};
		$sth->finish;

		unless ($ForderungsID) {
			print $LSC{TEXT}{Ergebnisse}[41].br;
			return undef;
		}
	}

	# prfen ob Forderungsid existiert und noch keine ergbnisse eingetragen
	my $sth = $LSC{MySQL}->prepare("SELECT ID, League from lsc_games_waiting_daten where ID=$ForderungsID");
	if ($sth->execute()) {
			my $ref = $sth->fetchrow_arrayref();
			$sth->finish;

			if ($ref && $ref->[1] && $ref->[1] == $LSC{League}) {
				my $sth = $LSC{MySQL}->prepare("SELECT Count(*) from lsc_games_waiting where WaitingID=$ForderungsID");
				if ($sth->execute()) {
					my $ref = $sth->fetchrow_arrayref();
					$sth->finish;
					if ($ref && defined $ref->[0] && $ref->[0] > 0) {
						print br.br.br.$LSC{TEXT}{Ergebnisse}[42].br; #altes ergebnis wird berschrieben
#return undef;
					}

				} else {
					print br.br.br.$LSC{TEXT}{Ergebnisse}[34].br; #nicht emitteln ob ergebnis eingetragen
					return undef;
				}


			} else {
				print br.br.br.$LSC{TEXT}{Ergebnisse}[43].br;
				return undef;
			}
	} else {
		print br.br.br.$LSC{TEXT}{Ergebnisse}[44].br; #konnte daten nicht ermitteln
		return undef;
	}
	# Daten Speichern:
	$sth = $LSC{MySQL}->do("update lsc_games_waiting_daten set Date=now(), Special=".$LSC{MySQL}->quote($Game->{overtime} || 0).", F_Team1=$Game->{Team1}{Team}, F_Team2=$Game->{Team2}{Team}, F_Map1='$Game->{Team1}{Map}', F_Map2='$Game->{Team2}{Map}', F_Confirm1=1, F_Confirm2=1 , 	Info=".$LSC{MySQL}->quote($Game->{Info} || "").", PogName=".$LSC{MySQL}->quote($Game->{PogName} || "")." where ID=$ForderungsID");
	
	#mgliche alte ergebnisse lschen
	$sth = $LSC{MySQL}->do("delete from lsc_games_waiting where WaitingID=$ForderungsID");

	# (neues) Ergebnis speichern

	$sth = $LSC{MySQL}->do("insert lsc_games_waiting 
			(WaitingID, Team, Points, PPoints1, PPoints2, LP, Map, Won, Lost, Draw, Home, Vote, Confirm)
				Values
			($ForderungsID, $Game->{Team1}{Team}, 
					$Game->{Team1}{Gesamtpunkte}, $Game->{Team1}{Punkte1}, $Game->{Team1}{Punkte2},
					$Game->{Team1}{LigaPunkte}, ".$LSC{MySQL}->quote($Game->{Team1}{Map}).",
					$Game->{Team1}{Won}, $Game->{Team1}{Lost}, $Game->{Team1}{Draw},
					1, '$Game->{Team1}{Vote}', 0)"
			);
	$sth = $LSC{MySQL}->do("insert lsc_games_waiting 
			(WaitingID, Team, Points, PPoints1, PPoints2, LP, Map, Won, Lost, Draw, Home, Vote, Confirm)
				Values
			($ForderungsID, $Game->{Team2}{Team}, 
					$Game->{Team2}{Gesamtpunkte}, $Game->{Team2}{Punkte1}, $Game->{Team2}{Punkte2},
					$Game->{Team2}{LigaPunkte}, ".$LSC{MySQL}->quote($Game->{Team2}{Map}).",
					$Game->{Team2}{Won}, $Game->{Team2}{Lost}, $Game->{Team2}{Draw},
					0, '$Game->{Team2}{Vote}', 0)"
			);	

	if ($q->param("Entered by")) {
		$sth = $LSC{MySQL}->do("update lsc_games_waiting set Confirm=1 where WaitingID=$ForderungsID and Team=".$LSC{MySQL}->quote($q->param("Entered by")));
	}

	if ($LSC{ErgebnisAdminMod}) {
		print "Admin-Info: Ergebnis wurde gespeichert, um es nun fr die Liga freizuschalten hier klicken:".br;
		print	$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=Details&special=$ForderungsID").
					$q->hidden("Forderung",  $F->{ID}).$q->hidden("ConfirmAdminGame",  1).$q->submit("Admin-".$LSC{TEXT}{Ergebnisse}[18]).$q->end_form().br;

	} else {
		my $Name = "unknown";
		my @user = ();
		if ($q->param("Entered by")) {
			if ($q->param("Entered by") == $Game->{Team1}{Team}) {
					@user = ChiefsUndLeaderEinesTeams($Game->{Team2}{Team});
					$Name = $Game->{Team1}{Teamname};
			} elsif ($q->param("Entered by") == $Game->{Team2}{Team}) {
					@user = ChiefsUndLeaderEinesTeams($Game->{Team1}{Team});
					$Name = $Game->{Team2}{Teamname};
			}
		}

		
		my $Send = SendMessage(
			{	Email=>1, Intern=>1, 
				System=>1, 
				To=>[@user], From=>0, 
				ToEmail=>"", FromEmail=>$LSC{newgameEmail}, 
				DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
				Subject=>$LSC{TEXT}{Email}[2], 
				Message=>"", 
				Template=>$LSC{TEXT}{Email}[1], 
				TemplateValues=>{GEGNERNAME=>$Name, 
								LINK=>$LSC{ScriptURL}."$LSC{user_pl}?League=$LSC{League}&Action=NewGame&Action2=Details&special=".$ForderungsID}
			});
		if ($Send) {
			print $Send.br;
			print $LSC{TEXT}{Ergebnisse}[11].br;
		} else {
			print $LSC{TEXT}{Ergebnisse}[10].br; #banachrichtigung verschickt;
		}
	}
}
sub ErgebnisNeuFormular {

	# 1. Gegner ermitteln

#	if (!($q->param("Team2") && $LSC{ErgebnisAdminMod})) {
		# nicht durchlaufen, wenn Adminmodusaktiviert und Gegner bereits gewhlt

		# Gegner durch Spielplan festgelegt
				if ($LSC{LeagueData}{Spielplan}==1 && $q->param("Team2")) { #einfacher spielplan
					my ($Team2, $heimspiel) = SpielplanNeuesErgebnisMoeglichEinfach($q->param("Team1"), $q->param("Team2"));
					if ($Team2) {
						$q->param("Team2", $Team2);
						unless ($heimspiel) {
							$q->param(-name=>"where", -value=>'road');
						}
					} else {
						print $LSC{TEXT}{Ergebnisse}[45].br; #Spielplan, keinen Gegner gefunden
						$q->delete("Team2");
						$q->delete("where");
					}
				}
				
				elsif ($LSC{LeagueData}{Spielplan}==2) {
					if ($LSC{ErgebnisAdminMod} && $q->param("AdminSpieltag")) {
						if ($q->param("AdminSpieltag") !~ /[^0-9]/) {
							$LSC{Spieltag} = $q->param("AdminSpieltag");
						}
					}
					print "$LSC{Spieltag} Spieltag".br;					
					
					my ($Team2, $heimspiel) = SpielplanNeuesErgebnisMoeglich($q->param("Team1"));
					if ($Team2) {
						$q->param("Team2", $Team2);
						unless ($heimspiel) {
							$q->param(-name=>"where", -value=>'road');
						}
					} else {
						print $LSC{TEXT}{Ergebnisse}[45].br; #Spielplan, keinen Gegner gefunden
						$q->delete("Team2");
						$q->delete("where");
					}
				}

		# Playoff Modus
			elsif ($LSC{LeagueData}{PlayoffDaten}) {
				my ($Name, $Team2) = PlayoffTeamRundenGegner($q->param("Team1"));
				if ($Team2) {
					$q->param("Team2", $Team2);
				} else {
					print $LSC{TEXT}{Ergebnisse}[45].br; #Spielplan, keinen Gegner gefunden
					$q->delete("Team2");
					$q->delete("where");
				}
			}
		# /Playoff Modus

		# Wenn Forderungen erlaubt und Forderung gewhlt berprfen, ob Forderung vorhanden
		elsif ($LSC{LeagueData}{Forderungen} > 0 && $q->param("Team2") && $q->param("Forderung")) {
			if (_MSGForderungenZwischenTeamATeamB($q->param("Team1"), $q->param("Team2")) == $q->param("Forderung")) {
				# alles ok
			} else {
				print $LSC{TEXT}{Ergebnisse}[32].br; #keine forderung gefunden
				$q->delete("Team2");
			}
		}

		# Prfen ob Team in Liga und aktiv
		elsif ($q->param("Team2")) {
			if (TeamStatus($q->param("Team1")) != 0 || TeamLigaStatus($q->param("Team1"), $LSC{League}) != 0) {
				print $LSC{TEXT}{Ergebnisse}[46]." (1)".br; #keine Ergebnisse gegen dieses Team erlaubt
				if ($LSC{ErgebnisAdminMod}) {
					print "Admin-Info: Achtung: Team 1 ist gesperrt oder inaktiv!".br;
				} else {
					$q->delete("Team1");
				}
			}
			if (TeamStatus($q->param("Team2")) != 0 || TeamLigaStatus($q->param("Team2"), $LSC{League}) != 0) {
				print $LSC{TEXT}{Ergebnisse}[46]." (2)".br;
				if ($LSC{ErgebnisAdminMod}) {
					print "Admin-Info: Achtung: Team 2 ist gesperrt oder inaktiv!".br;
				} else {
					$q->delete("Team2");
				}
			}
		}
		
#	}
	if (!$q->param("Team1") && !$LSC{ErgebnisAdminMod}) {
		print $LSC{TEXT}{Ergebnisse}[47].br; #Fr die gewhlten Teams kannst Du keine Ergebnisse eintragen!
		return;

	}
	if ($q->param("Team1") && $q->param("Team2") && ($q->param("Team1") eq $q->param("Team2"))) {
		print $LSC{TEXT}{Ergebnisse}[48].br; #nicht gege sich selbst
		$q->delete("Team2");
	}

	unless ($q->param("Team2")) {
		# Keinen Gegner ermittelt
		print "<!-- YYYY Keinen Gegner ermittelt -->\n";

		# Suchfunktion ausgeben, wenn Liga 
		#	keinen strengen Spielplan benutz,
		#	kein Turniermodus gewhlt ist und
		#	Forderungen nicht zwingend gewnscht sind ($LSC{LeagueData}{Forderungen} <= 1)
##TEST##
#$LSC{LeagueData}{Spielplan} != 2
#				&&

		if ((!$LSC{LeagueData}{PlayoffDaten}
				&& $LSC{LeagueData}{Forderungen} <= 1) || $LSC{ErgebnisAdminMod}) {

			if ($q->param('search')) {
				#nach dem Loginnamen bzw. Team-/Clannamen suchen
				my %Namen = SucheUsernamenTeamnamen($q->param('Name'));
		
				if (%Namen) {
					print start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame");

					print $LSC{TEXT}{Ergebnisse}[49].br; #gegner whlen
		
					print popup_menu(-name=>'Team2', -values=>[sort {"\L$Namen{$a}" cmp
						"\L$Namen{$b}" } keys %Namen], -Labels=>\%Namen),' ', 
						$q->hidden('Opponent-ID', 1),submit('submit'),end_form;
				} else {
					print $LSC{TEXT}{Ergebnisse}[50].br; #no result
				}
		
			}
			print hr;
			Ergebnisse_Formular_SearchOpponent();
		} elsif ($LSC{LeagueData}{Forderungen} >= 2) {
			print "Gegner muss zunchst gefordert werden, um ein Ergebnis eintragen zu knnen!".br;
		} else {
			print "Das entragen von Ergebnissen ist hier nicht mglich.".br;
		}
		return;
	}

	my ($Teamname, $Opponent) = TeamnameAndUserFromTeamIDAndLeague($q->param("Team1"), $LSC{League});
	unless ($Teamname) {
		print $LSC{TEXT}{Ergebnisse}[51]." (1)".br; #kein teamname
		return;
	}
	$q->param("Teamname1", $Teamname);
	($Teamname, $Opponent) = TeamnameAndUserFromTeamIDAndLeague($q->param("Team2"), $LSC{League});
	unless ($Teamname) {
		print $LSC{TEXT}{Ergebnisse}[51]." (2)".br;
		return;
	}
	$q->param("Teamname2", $Teamname);

	# Formular
	print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame");

	# Fehler aufgetreten?

	_Ergebnisse_Formular();
	print br.br.br;
	print $q->hidden('Team1');
	print $q->hidden('Team2');
	print $q->hidden('Teamname1');
	print $q->hidden('Teamname2');
	print $q->hidden('where');
	print $q->hidden('Forderung');
	print $q->hidden("AdminSpieltag");
	print $q->hidden('check', 1);
	print $q->image_button(-name=>"submit", -src=>$LSC{imagepfad}."/lsc_newgame.gif", align=>"middle");
	print $q->endform();
}
sub _ErgebnisseZwischenTeamATeamBinWarteliste {
	$Team1 = $LSC{MySQL}->quote(shift || 0);
	$Team2 = $LSC{MySQL}->quote(shift || 0);

	my $sth = $LSC{MySQL}->prepare("select Count(*) from lsc_games_waiting_daten D, lsc_games_waiting A, lsc_games_waiting B 
				where D.League=$LSC{League} and
					D.ID=A.WaitingID and D.ID=A.WaitingID and
						(A.Team=$Team1 and B.Team=$Team2)");
	if ($sth->execute()) {
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish();
		if ($ref && $ref->[0] > 0) {
			return $ref->[0];
		}
	}
	return 0;
}
sub _NeuesSpiel_ForceDraw_sichern {
			print "<b>Bisher eingetragene Ergebnisse:</b>".br.br;
			my @fieldlist = qw(won won1 won2 Punkte1 Punkte2 Punkte21 Punkte22 overtime POG-Name Map1 Map2 where);

			if ($q->param("FD-Counter") && $q->param("FD-Counter") > 0) {
				for(my $i=1; $i <= $q->param("FD-Counter"); $i++) {
					foreach my $f (@fieldlist, "Uebersicht") {
						print $q->hidden($f.'#'.$i);
					}
					#Anzeigen:
					print "#$i".br;
					print $q->param('Uebersicht#'.$i).br;
				}
				
			}
			if ($LSC{ErgebnisNeuCheckOk}) {
				my $FD_Counter = $q->param("FD-Counter") || 0; 
				$FD_Counter++;
				$q->param("FD-Counter", $FD_Counter);
				
				foreach my $f (@fieldlist) {
					print $q->hidden($f.'#'.$FD_Counter, $q->param("$f"));
				}

				my $Game = _Ergebnisse_Formular(2);
				print $q->hidden('Uebersicht#'.$FD_Counter, $Game);
				print "#$FD_Counter".br;
				print $Game;
			}
			print $q->hidden("FD-Counter");

}

sub _Ergebnisse_Formular_Definition {
	my $show = shift || 0;

	my $out = 1;
		$out->{Result}		= "";
		$out->{Extra}  		= "";
		$out->{HomeRoad}	= "";
		$out->{PlayerStats} = "";
		

		my $map1 = "";
		my $map2 = "";
		if ($show) {
			if ($LSC{LeagueData}{AnzahlMaps} > 0) {
				$map1 = $q->param("Map1");
				$map2 = $q->param("Map2");
			
				if ($LSC{LeagueData}{Mapliste} > 0) {
					my %maps = MapListe();
					$maps{0} = "choose";

					$map1 = $maps{$q->param("Map1")} || "unknown";
					$map2 = $maps{$q->param("Map2")} || "unknown";
				} 
			}
			$map1 = "(".($map1 || "-").")";
			$map2 = "(".($map2 || "-").")";
			$map1 =~ s/ /&nbsp;/gg;
			$map2 =~ s/ /&nbsp;/gg;
		} else {
			if ($LSC{LeagueData}{AnzahlMaps} > 0) {
				$map1 = $q->textfield('Map1', $LSC{LeagueData}{MapName}, 30);
				$map2 = $q->textfield('Map2', $LSC{LeagueData}{MapName}, 30);
				if ($LSC{LeagueData}{Mapliste} > 0) {
					my %maps = MapListe();
					$maps{""} = "choose";

					if ($LSC{LeagueData}{Forderung}) {
						$map1 = $q->hidden('Map1').($maps{$q->param("Map1")} || "unknown");
						$map2 = $q->hidden('Map2').($maps{$q->param("Map2")} || "unknown");
					} else {
						my @maps = sort {($maps{$a}||"") cmp ($maps{$b}||"")}(keys %maps);
						$map1 = $q->popup_menu(-name=>'Map1', -values=>[@maps], -Labels=>\%maps, -default=>"");
						$map2 = $q->popup_menu(-name=>'Map2', -values=>[@maps], -Labels=>\%maps, -default=>"");
					}
				} else {
					if ($LSC{LeagueData}{Forderung}) {
						$map1 = $q->hidden('Map1').($q->param("Map1") || "unknown");
						$map2 = $q->hidden('Map2').($q->param("Map2") || "unknown");
					}
				}
			}
		}
		if ($LSC{LeagueData}{AnzahlMaps} == 1) {
			$map2 = $LSC{TEXT}{Ergebnisse}[12];
		}
		
		my $punkte1_1 = $show ? $q->param("Punkte1") : $q->textfield('Punkte1', 0, 5);
		my $punkte1_2 = $show ? $q->param("Punkte2") : $q->textfield('Punkte2', 0, 5);

		my $punkte2_1 = $show ? $q->param("Punkte21") : $q->textfield('Punkte21', 0, 5);
		my $punkte2_2 = $show ? $q->param("Punkte22") : $q->textfield('Punkte22', 0, 5);

		$out->{Result} .= "<tr><td width=150 class=Headline>Result:</td></tr>";
		$out->{Result} .= "<tr><td>&nbsp;</td></tr>";
		my $alignpunkte = " width=50 align=right ";
		foreach my $Form (keys %{$LSC{LeagueData}{NewGameForm}}) {
			if (!$LSC{LeagueData}{NewGameForm}{$Form}) {
				# dummy
			} elsif ($Form eq 'Team-Punkte') {
				$out->{Result} .= "<tr><td class=Std2>".$q->param("Teamname1")."</td><td >".$map1."</td><td$alignpunkte>".$punkte1_1."</td></tr>";
				$out->{Result} .= "<tr><td class=Std2>".$q->param("Teamname2")."</td><td>".$map2."</td><td$alignpunkte>".$punkte1_2."</td></tr>";

			} elsif ($Form eq 'Team-Punkte-Map') {
				$out->{Result} .= "<tr><td class=Std1>$LSC{LeagueData}{MapName} 1:</td><td class=Std1>".$map1."</td></tr>";
				$out->{Result} .= "<tr><td class=Std2>".$q->param("Teamname1")."</td><td$alignpunkte>".$punkte1_1."</td></tr>";
				$out->{Result} .= "<tr><td class=Std2>".$q->param("Teamname2")."</td><td$alignpunkte>".$punkte1_2."</td></tr>";
				$out->{Result} .= "<tr><td>&nbsp;</td></tr>";
				$out->{Result} .= "<tr><td class=Std1>$LSC{LeagueData}{MapName} 2:</td><td class=Std1>".$map2."</td></tr>";
				$out->{Result} .= "<tr><td class=Std2>".$q->param("Teamname1")."</td><td$alignpunkte>".$punkte2_1."</td></tr>";
				$out->{Result} .= "<tr><td class=Std2>".$q->param("Teamname2")."</td><td$alignpunkte>".$punkte2_2."</td></tr>";

			} elsif ($Form eq 'Team-Sieg-Unentschieden-Map') {
				$out->{Result} .= "<tr><td class=Std1>$LSC{LeagueData}{MapName} 1:</td><td class=Std1>".$map1."</td></tr>";
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname1").'</td><td$alignpunkte>'.($show ? ($q->param("won1")==1 ? "won" : "") : '<input type="radio" name="won1" value="1" checked="checked">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname2").'</td><td$alignpunkte>'.($show ? ($q->param("won1")==2 ? "won" : "") : '<input type="radio" name="won1" value="2">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>unentschieden</td><td>'.($show ? ($q->param("won1")==3 ? "draw" : "") : '<input type="radio" name="won1" value="3"">').'</td></tr>';
				$out->{Result} .= "<tr><td>&nbsp;</td></tr>";
				$out->{Result} .= "<tr><td class=Std1>$LSC{LeagueData}{MapName} 2:</td><td class=Std1>".$map2."</td></tr>";
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname1").'</td><td$alignpunkte>'.($show ? ($q->param("won2")==1 ? "won" : "") : '<input type="radio" name="won2" value="1" checked="checked">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname2").'</td><td$alignpunkte>'.($show ? ($q->param("won2")==2 ? "won" : "") : '<input type="radio" name="won2" value="2">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>unentschieden</td><td>'.($show ? ($q->param("won2")==3 ? "draw" : "") : '<input type="radio" name="won2" value="3"">').'</td></tr>';

			} elsif ($Form eq 'Team-Sieg') {
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname1").'</td><td$alignpunkte>'.($show ? ($q->param("won")==1 ? "won" : "") : '<input type="radio" name="won" value="1" checked="checked">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname2").'</td><td$alignpunkte>'.($show ? ($q->param("won")==2 ? "won" : "") : '<input type="radio" name="won" value="2">').'</td></tr>';

			} elsif ($Form eq 'Team-Sieg-Unentschieden') {
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname1").'</td><td$alignpunkte>'.($show ? ($q->param("won")==1 ? "won" : "") : '<input type="radio" name="won" value="1" checked="checked">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>'.$q->param("Teamname2").'</td><td$alignpunkte>'.($show ? ($q->param("won")==2 ? "won" : "") : '<input type="radio" name="won" value="2">').'</td></tr>';
				$out->{Result} .= '<tr><td class=Std2>unentschieden</td><td>'.($show ? ($q->param("won")==3 ? "draw" : "") : '<input type="radio" name="wo2" value="3"">').'</td></tr>';

			} elsif ($Form eq 'OverTime') {
				$out->{Extra}  	= $show ? 
								($q->param("overtime") ? "<tr><td class=Std1>OverTime/Verlngerung:</td><td $alignpunkte>yes</td></tr>" : "") : "<tr><td class=Std1>OverTime/Verlngerung:</td><td $alignpunkte>".$q->checkbox_group(-name=>'overtime',
                		                -values=>['OverTime'])."</td></tr>";
			
			} elsif ($Form eq 'Location' && $LSC{LeagueData}{Spielplan} == 0 && (!$LSC{LeagueData}{PlayoffDaten} || $LSC{LeagueData}{Playoff}==2)) {
				$out->{HomeRoad}	= "<tr><td class=Std1>Home/Road:</td><td $alignpunkte>".($show ? $q->param("where")||"-" : $q->radio_group(-name=>'where', -values=>['home','road'], -default=>'home', -rows=>1))."</td></tr>";
			} elsif ($Form eq 'POG') {
				$out->{PlayerStats} = $show ? ($q->param("POG-Name") ? "<tr><td class=Std1>Player of the Game:</td><td $alignpunkte> ".$q->param("POG-Name")."</td></tr>" :"") : "<tr><td class=Std1>Player of the Game (optional):</td><td $alignpunkte>".$q->textfield('POG-Name','',25)."</td></tr>";
			} elsif ($Form eq '') {
			} else {
			}
		}
		if ($LSC{ErgebnisAdminMod}) {
				$out->{vote} = $q->hidden("vote",  0);
		} else {
				$out->{vote}	= "Vote: ".($show ? "voted" : $LSC{TEXT}{Votes}[7][0]." ".$q->radio_group(-name=>'vote',
																						-values=>[5,4,3,2,1], 
																						-default=>3,
																						-labels=>{1=>"", 2=>"", 3=>"", 4=>"", 5=>""})." ".$LSC{TEXT}{Votes}[7][1]);
		}
	return $out;
}
sub _Ergebnisse_Formular {

	unless (_Ergebnisse_Formularwahl_Laden()) {
		print $LSC{TEXT}{Ergebnisse}[39].br;
		return undef;
	}

	my $Formular = _Ergebnisse_Formular_Definition($_[0]);

		
	my $out = "<table cellspacing=0>	$Formular->{Result} 
			<tr>	<td>&nbsp;</td>	</tr>			
			$Formular->{Extra}
			".($Formular->{Extra} ? "<tr>	<td>&nbsp;</td>	</tr>" : "")."
			$Formular->{HomeRoad}
			".($Formular->{HomeRoad} ? "<tr>	<td>&nbsp;</td>	</tr>" : "")."
			$Formular->{PlayerStats}
			</table><br>";
	# Formular zurckgeben?
	if ($_[0] && $_[0] == 2) {
		$out =~ s /\n//gg;
		return $out;
	}
	$out .= br.$Formular->{vote}.br;

	# Normal ausgeben:
	print $out;
		if ($LSC{ForceDraws} || ($LSC{LeagueData}{NewGamePoints}{ForceDraws} && $q->param("FD-Counter") && $q->param("FD-Counter") > 0)) {
			print br.br;
			_NeuesSpiel_ForceDraw_sichern();
		}
		

}
sub _Ergebnisse_Formularwahl_Laden {
		if ($LSC{LeagueData}{NewGameForm}) {
			return 1;
		}

		my $sth = $LSC{MySQL}->prepare("SELECT * from lsc_leagues_newgame where League=$LSC{League}");
		if ($sth->execute()) {
			my $ref = $sth->fetchrow_hashref();
			$sth->finish;

			if ($ref) {
				$LSC{LeagueData}{NewGameForm} = $ref;
				return 1;
			}

		} 
		return undef;
}


sub _Ergebnisse_LigaPunkteBerechnen {
	my $Game = shift;
	unless (_Ergebnisse_PunkteDefinition_Laden()) {
		return undef;
	}

	Require("LSCPoints.pm");
	my $TeamPunkte1 = Points_PunkteLaden($Game->{Team1}{Team}, $LSC{Leagues});
	my $TeamPunkte2 = Points_PunkteLaden($Game->{Team2}{Team}, $LSC{Leagues});

	
	###

	my @P; #ligapunkte
	my $Special		= $Game->{overtime} ? 1 : 0;
	my @TeamsNamen	= ($Game->{Team1}{Teamname}, $Game->{Team2}{Teamname});
	my @Rang		= (RankingGet_rang($TeamPunkte1->{LP}), RankingGet_rang($TeamPunkte2->{LP}));

	my @info = ();
	if ($LSC{LeagueData}{NewGamePoints}{EloFunction}==0 && $LSC{LeagueData}{NewGamePoints}{Elo1} && $LSC{LeagueData}{NewGamePoints}{Elo2}) {
		local *ELO = sub {
			my $c1 = $LSC{LeagueData}{NewGamePoints}{Elo1};
			my $c2 = $LSC{LeagueData}{NewGamePoints}{Elo2};
			my ($P1, $P2, $map1_1, $map1_2, $map2_1, $map2_2) = @_;
			
			my @gesamt = ($map1_1+$map2_1,$map1_2+$map2_2);
			
			my $m1 = $map1_1 ? (100/$gesamt[0]*$map1_1) : 0;
			my $m2 = $map1_2 ? (100/$gesamt[1]*$map1_2) : 0;
			my $prozent1 = 100/200*($m1+ $m2);
			$m1 = $map2_1 ? (100/$gesamt[0]*$map2_1) : 0;
			$m2 = $map2_2 ? (100/$gesamt[1]*$map2_2) : 0;
			my $prozent2 = 100/200*($m1+$m2);
			
			# nur eine map gespielt
			if ($map1_2==0 && $map2_2==0) {
				$prozent1 = 2*$prozent1;
				$prozent2 = 2*$prozent2;
			}
			my $cTeam;
			local *Erwartet = sub {
				my $x = 1/(1+10**(-($_[0]-$_[1])/$c2));
				return $x
			};	
			local *Rating = sub {
				my $r = $c1*($_[1]/100 - Erwartet($_[0], $_[2]));
				$r = Round($r);	
				return $r;
			};
			push(@info, "ELO-PunkteSystem:");
			my @E = (Round(Erwartet($P1, $P2)*100), Round(Erwartet($P2, $P1)*100));
			push(@info, "Gewinnwahrscheinlichkeit fr $Game->{Team1}{Teamname}: $E[0]\%");
			push(@info, "Gewinnwahrscheinlichkeit fr $Game->{Team2}{Teamname}: $E[1]\%");
			push(@info, "Ergebnis: ".Round($prozent1)."\% zu ".Round($prozent2)."\%");
			return Rating($P1, $prozent1, $P2), Rating($P2, $prozent2, $P1)
		};
		
		
		my $LP1 = $TeamPunkte1->{LP};
		my $LP2 = $TeamPunkte2->{LP};

		my @x = ();
		if ($LSC{LeagueData}{AnzahlMaps} <= 1) {
			@x = ELO($LP1, $LP2, $Game->{Team1}{Gesamtpunkte}, 0,$Game->{Team2}{Gesamtpunkte}, 0);
		} else {
			@x = ELO($LP1, $LP2, $Game->{Team1}{Punkte1}, $Game->{Team1}{Punkte2},$Game->{Team2}{Punkte1}, $Game->{Team2}{Punkte2});
		}
		push(@info, " ", "Daraus ergeben sich folgende Punkte:");
		push(@info, "$Game->{Team1}{Teamname}: $x[0] Punkte");
		push(@info, "$Game->{Team2}{Teamname}: $x[1] Punkte");

		$Game->{Team1}{LigaPunkte} = $x[0];
		$Game->{Team2}{LigaPunkte} = $x[1];
		$Game->{Info} = join ("\n", @info);

		return $Game;
	}
	
	#elo2 testfunktion
	if ($LSC{LeagueData}{NewGamePoints}{EloFunction}==1 && $LSC{LeagueData}{NewGamePoints}{Elo1} && $LSC{LeagueData}{NewGamePoints}{Elo2}) {
		local *ELO = sub {
			my $c1 = $LSC{LeagueData}{NewGamePoints}{Elo1};
			my $c2 = $LSC{LeagueData}{NewGamePoints}{Elo2};
			my ($P1, $P2, $map1_1, $map1_2, $map2_1, $map2_2) = @_;
			
			my @gesamt = ($map1_1+$map2_1,$map1_2+$map2_2);
			
			my $m1 = $map1_1 ? (100/$gesamt[0]*$map1_1) : 0;
			my $m2 = $map1_2 ? (100/$gesamt[1]*$map1_2) : 0;
			my $prozent1 = 100/200*($m1+ $m2);
			$m1 = $map2_1 ? (100/$gesamt[0]*$map2_1) : 0;
			$m2 = $map2_2 ? (100/$gesamt[1]*$map2_2) : 0;
			my $prozent2 = 100/200*($m1+$m2);
			
			# nur eine map gespielt
			if ($map1_2==0 && $map2_2==0) {
				$prozent1 = 2*$prozent1;
				$prozent2 = 2*$prozent2;
			}
			my $cTeam;
			local *Erwartet = sub {
				my $x = 1/(1+10**(-($_[0]-$_[1])/$c2));
				return $x
			};	
			local *Rating = sub {
				my $r = $c1*($_[1]/100 - Erwartet($_[0], $_[2]));
				$r = Round($r);	
				return $r;
			};
			push(@info, "ELO-PunkteSystem (special!):");
			my @E = (Round(Erwartet($P1, $P2)*100), Round(Erwartet($P2, $P1)*100));
			push(@info, "Gewinnwahrscheinlichkeit fr $Game->{Team1}{Teamname}: $E[0]\%");
			push(@info, "Gewinnwahrscheinlichkeit fr $Game->{Team2}{Teamname}: $E[1]\%");
			push(@info, "Ergebnis: ".Round($prozent1)."\% zu ".Round($prozent2)."\%");
			return Rating($P1, $prozent1, $P2), Rating($P2, $prozent2, $P1)
		};
		
		
		my $LP1 = $TeamPunkte1->{LP};
		my $LP2 = $TeamPunkte2->{LP};
			print "LP: $LP1/$LP2".br;
		my @x = ();
		if ($LSC{LeagueData}{AnzahlMaps} <= 1) {
			@x = ELO($LP1, $LP2, $Game->{Team1}{Gesamtpunkte}, 0,$Game->{Team2}{Gesamtpunkte}, 0);
		} else {
			@x = ELO($LP1, $LP2, $Game->{Team1}{Punkte1}, $Game->{Team1}{Punkte2},$Game->{Team2}{Punkte1}, $Game->{Team2}{Punkte2});
		}
		$x[0] += $LSC{LeagueData}{NewGamePoints}{Elo1};
		$x[1] += $LSC{LeagueData}{NewGamePoints}{Elo1};
		push(@info, " ", "Daraus ergeben sich folgende Punkte:");
		push(@info, "$Game->{Team1}{Teamname}: $x[0] Punkte");
		push(@info, "$Game->{Team2}{Teamname}: $x[1] Punkte");
	#	print join ("<br>", @info).br;

		$Game->{Team1}{LigaPunkte} = $x[0];
		$Game->{Team2}{LigaPunkte} = $x[1];
		$Game->{Info} = join ("\n", @info);

		return $Game;
	}

	my @TabRank = ($TeamPunkte1->{Rank}, $TeamPunkte2->{Rank});
	if ($LSC{LeagueData}{NewGamePoints}{Won}) {
		#ein team gewonnen?
		if ($Game->{Team1}{Won} || $Game->{Team2}{Won}) {
			local *Bonus = sub {
				unless ($LSC{LeagueData}{NewGamePoints}{Bonus} 
					|| $LSC{LeagueData}{NewGamePoints}{Bonus}{Won}) { return; }
				my $Team = shift;
				my $Gegner = $Team ? 0 : 1;
				if ($LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{+PunkteDiff}) {
					my $diff = abs($Game->{Team1}{Gesamtpunkte}-$Game->{Team2}{Gesamtpunkte});
					foreach my $P (@{$LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{+PunkteDiff}}) {
						if ($P && $diff >= $P) {
							$P[$Team] ++;
							push(@info, "$TeamsNamen[$Team]: scoring difference +1");
						}
					}
				}
				if ($LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{Top}) {
					my ($pos, $x) = @{$LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{Top}};
					if ($TabRank[$Gegner] <= $pos
						&& $TabRank[$Team] > $pos) {
							$P[$Team] += $x;
							push(@info, "$TeamsNamen[$Team]: top $pos bonus +$x");
					}
				}
				if ($LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{+Rang}) {
					if ($Rang[$Team] < $Rang[$Gegner]) {
						my $diff = $Rang[$Gegner] - $Rang[$Team];
						$diff = $diff * $LSC{LeagueData}{NewGamePoints}{Bonus}{Won}{+Rang}[0];
						$P[$Team] += $diff;
						push(@info, "$TeamsNamen[$Team]: rank bonus +$diff");
					}
				}
			};
			if ($Game->{Team1}{Won}) {
				$P[0] += $LSC{LeagueData}{NewGamePoints}{Won}[$Special];
				push(@info, "$TeamsNamen[0]: Won +".$LSC{LeagueData}{NewGamePoints}{Won}[$Special]) if $LSC{LeagueData}{NewGamePoints}{Won}[$Special];
				Bonus(0);
			} else {
				$P[1] += $LSC{LeagueData}{NewGamePoints}{Won}[$Special];
				push(@info, "$TeamsNamen[1]: Won +".$LSC{LeagueData}{NewGamePoints}{Won}[$Special]) if $LSC{LeagueData}{NewGamePoints}{Won}[$Special];
				Bonus(1);
			}			
		}
	}
	if ($LSC{LeagueData}{NewGamePoints}{Lost}) {
		#ein team verloren?
		if ($Game->{Team1}{Lost} || $Game->{Team2}{Lost}) {
			local *Bonus = sub {
				unless ($LSC{LeagueData}{NewGamePoints}{Bonus} 
					|| $LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}) { return; }
				my $Team = shift;
				my $Gegner = $Team ? 0 : 1;
				if ($LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}{-PunkteDiff}) {
					my $diff = abs($Game->{Team1}{Gesamtpunkte}-$Game->{Team2}{Gesamtpunkte});
					foreach my $P (@{$LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}{-PunkteDiff}}) {
						if ($diff <= $P) {
							$P[$Team] ++;
							push(@info, "$TeamsNamen[$Team]: scoring difference +1");
						}
					}
				}
				if ($LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}{-Rang}) {
					if ($Rang[$Team] > $Rang[$Gegner]) {
						my $diff = $Rang[$Gegner] - $Rang[$Team];
						$diff = $diff * $LSC{LeagueData}{NewGamePoints}{Bonus}{Lost}{-Rang}[0];
						$P[$Team] += $diff;
						push(@info, "$TeamsNamen[$Team]: rank penalty $diff");
					}
				}
			};
			if ($Game->{Team1}{Lost}) {
				$P[0] += $LSC{LeagueData}{NewGamePoints}{Lost}[$Special];
				push(@info, "$TeamsNamen[0]: Lost +".$LSC{LeagueData}{NewGamePoints}{Lost}[$Special]) if $LSC{LeagueData}{NewGamePoints}{Lost}[$Special];
				Bonus(0);
			} else {
				$P[1] += $LSC{LeagueData}{NewGamePoints}{Lost}[$Special];
				push(@info, "$TeamsNamen[1]: Lost +".$LSC{LeagueData}{NewGamePoints}{Lost}[$Special]) if $LSC{LeagueData}{NewGamePoints}{Lost}[$Special];
				Bonus(1);
			}			
		}
	}
	if ($LSC{LeagueData}{NewGamePoints}{Draw}) {
		#unentschieden?
		if ($Game->{Team1}{Draw} && $Game->{Team2}{Draw}) {
			$P[0] += $LSC{LeagueData}{NewGamePoints}{Draw}[$Special];
			$P[1] += $LSC{LeagueData}{NewGamePoints}{Draw}[$Special];
			push(@info, "$TeamsNamen[0]: Draw +".$LSC{LeagueData}{NewGamePoints}{Draw}[$Special]) if $LSC{LeagueData}{NewGamePoints}{Draw}[$Special];
			push(@info, "$TeamsNamen[1]: Draw +".$LSC{LeagueData}{NewGamePoints}{Draw}[$Special]) if $LSC{LeagueData}{NewGamePoints}{Draw}[$Special];
		}
	}
	if ($info[0]) {
		unshift(@info, '<b>Points:</b>');
	}

	$Game->{Team1}{LigaPunkte} = $P[0];
	$Game->{Team2}{LigaPunkte} = $P[1];
	$Game->{Info} = join ("\n", @info);

	return $Game;
}
sub Ergebnisse_Formular_SearchOpponent {
		print "<table cellspacing=0 align=center><tr><td>";
		print br;
		if ($LSC{ErgebnisAdminMod}) {
## Adminmodus		
			my %Members = Members();
			print start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame");
		
			print "Team 1: ".popup_menu(-name=>'Team1', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members),' ';
			
			if ($LSC{LeagueData}{Spielplan} != 2
				&& !$LSC{LeagueData}{PlayoffDaten}) {
			
				print br."Team 2: ".popup_menu(-name=>'Team2', -values=>[sort {"\L$Members{$a}" cmp
					"\L$Members{$b}" } keys %Members], -Labels=>\%Members),' ', 
			
			}

			if ($LSC{LeagueData}{Spielplan} && $LSC{ErgebnisAdminMod}) {
				print br."Spieltag: ".$q->textfield("AdminSpieltag", $LSC{Spieltag}, 3);
			}

			print br.$q->hidden('Opponent-ID', 1),submit('submit'),end_form;
		
## /Adminmodus			
		
		} else {
			print start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame");
		
			print "Search Team: ".br.$q->textfield('Name','',30)." ".$q->hidden('search', 1);
		
			print $q->image_button(-name=>"Fordern", -src=>$LSC{imagepfad}."/lsc_search.gif", align=>"middle"),end_form;
	
			print start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame");
		
			print "Team-ID: ".br.$q->textfield('Opponent','',10)." ".$q->hidden('Opponent-ID', 1);
	
			print $q->image_button(-name=>"Fordern", -src=>$LSC{imagepfad}."/lsc_search.gif", align=>"middle"),end_form;
		}
		print "</td></tr></table>";
}
sub ErgebnisseNeuMoeglichIn {
	if ($LSC{ErgebnisAdminMod}) {
		return;
	}
	my %Leagues = LigenInDenenUserTeamRechteHat($LSC{userid}, 1); #nur offene ligen laden
	print br.br;
	if (%Leagues) {
		print "<TABLE border=1 cellspacing=0 align=center>
			<TR>
				<TD class=Std1>$LSC{TEXT}{Ergebnisse}[0]</TD>
			</TR>
			<TR>
				<TD class=Std2><br>";
		foreach my $L (sort {$Leagues{$a} cmp $Leagues{$b}} keys %Leagues) {
			print ShowLink({Script => "$LSC{user_pl}",
							Name => $Leagues{$L},
							League => $L,
							Action => "NewGame"}).br;
		}
		print "<br><br></TD>
			</TR>
			</TABLE>
			";
	} else {
		print $LSC{TEXT}{Ergebnisse}[1].br; #keine ligen vorhanden
	}
};

#### Forderungen:

sub _ForderungenDateTimeVerschiebungPruefen {
	my $OldDateTime = shift;
	my $NewDateTime = shift;
	my $TempOut = shift || 0; #wenn 1, dann alles in $LSC{TempOut} speichern
	if ($LSC{LeagueData}{Forderungen_Change_Max} == 0 && $LSC{LeagueData}{Forderungen_Change_Min} == 0) {
		print $LSC{TEXT}{Forderung}[34].br if !$TempOut;
		$LSC{TempOut} .= $LSC{TEXT}{Forderung}[34].br if $TempOut;
		return undef;
	}
	$LSC{TempOut} = "" if $TempOut;

	#gefordert: dd.mm.yyyy hh:mm
	$NewDateTime =~ /(\d?\d)\.(\d?\d)\.(\d\d\d\d) *(\d\d)\:(\d\d) */;
	if (defined $1 && 
		defined $2 && 
		defined $3 && 
		defined $4 && 
		defined $5 ) {
		my $sth = $LSC{MySQL}->prepare("SELECT Unix_Timestamp(now()), Unix_Timestamp('$3-$2-$1 $4:$5:00'), To_Days(now()), To_Days('$3-$2-$1 $4:$5:00'), To_Days('$OldDateTime')");
		$sth->execute();
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish;
		if ($ref && defined $ref->[0] && defined $ref->[1] && defined $ref->[2] && defined $ref->[3]) {
			if ($ref->[0] < $ref->[1]) {
				# Forderung liegt in der Zukunft
				# prfe ob Forderung innerhalb des aktuellen Zeitraumes verschoben wird
				my $days = $ref->[4] - $ref->[3];
				if ($days > 0 && $days > $LSC{LeagueData}{Forderungen_Change_Min} ) {
					print $LSC{TEXT}{Forderung}[11]." (min. $LSC{LeagueData}{Forderungen_Change_Min}d)".br if !$TempOut;
					$LSC{TempOut} .= $LSC{TEXT}{Forderung}[11]." (min. -$LSC{LeagueData}{Forderungen_Change_Min}d)".br if $TempOut;
					return undef;
				}
				if ($days < 0 && $days < -$LSC{LeagueData}{Forderungen_Change_Max} ) {
					print $LSC{TEXT}{Forderung}[11]." (max. +$LSC{LeagueData}{Forderungen_Change_Max}d)".br if !$TempOut;
					$LSC{TempOut} .= $LSC{TEXT}{Forderung}[11]." (max. +$LSC{LeagueData}{Forderungen_Change_Max}d)".br if $TempOut;
					return undef;
				}
				my %mins = ("0"=>1, "00"=>1, 15=>1, 30=>1, 45=>1);
				unless ($mins{$5}) {
					print $LSC{TEXT}{Forderung}[13]."dd$5"."/$mins{$5}".br if !$TempOut;
					$LSC{TempOut} .= $LSC{TEXT}{Forderung}[13]."dd$5"."/$mins{$5}".br if $TempOut;
					return undef;
				}
				return "$3-$2-$1 $4:$5:00";
			}
		}
	}
	print $LSC{TEXT}{Forderung}[12].br if !$TempOut;
	$LSC{TempOut} .= $LSC{TEXT}{Forderung}[12].br if $TempOut;
	return undef;
}


sub _MSGForderungenVonTeamsInAllenLigen {
	my $Teams = "";
	if ($LSC{ErgebnisAdminMod}) {
		my %Members= Members($LSC{League});
		$Teams = join (", ", keys %Members);	
		my $sth = $LSC{MySQL}->prepare("select ID from lsc_games_waiting_daten where League=$LSC{League} and
						(F_Team1 in ($Teams) or F_Team2 in ($Teams)) order by F_Date, Date");
		if ($sth->execute()) {
			my @Forderungen = ();
			while (my $ref = $sth->fetchrow_arrayref()) {
				push (@Forderungen, $ref->[0]) if $ref->[0];
			}
			return @Forderungen;
		}
		return undef;
	} 

	# normalmodus
	unless ($_[0]) {
		return undef;
	}
	my @Teams = @_;
	foreach  (@Teams) {
		$_ = $LSC{MySQL}->quote($_ || 0) 
	}
	$Teams = join (", ", @Teams);	
	my $sth = $LSC{MySQL}->prepare("select ID from lsc_games_waiting_daten where 
					(F_Team1 in ($Teams) or F_Team2 in ($Teams)) order by League, F_Date, Date");
	if ($sth->execute()) {
		my @Forderungen = ();
		while (my $ref = $sth->fetchrow_arrayref()) {
			push (@Forderungen, $ref->[0]) if $ref->[0];
		}
		return @Forderungen;
	}

	return undef;
}


sub ForderungZeigen {
	my $F = shift || return;

				
	my %maps = ();
	my $ChiefTeam = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || 0;
	if ($LSC{LeagueData}{Mapliste} > 0) {
		%maps = MapListe();
	}
	my $Info = "";
	if ($q->param("Confirm")) {
		if ($F->{F_Confirm1} && $F->{F_Confirm2}) {
			$Info .= $LSC{TEXT}{Forderung}[25].br; #angenommen
		
		} elsif ($ChiefTeam ne $F->{F_Team1} && $ChiefTeam ne $F->{F_Team2}) {
			$Info .= $LSC{TEXT}{Forderung}[26].br; #nicht erlaubt

		} elsif (($ChiefTeam eq $F->{F_Team1} && $F->{F_Confirm1}) || ($ChiefTeam eq $F->{F_Team2} && $F->{F_Confirm2})) {
			$Info .= $LSC{TEXT}{Forderung}[25].br; #angenommen

		} elsif ($q->param("Forderung") && $q->param("Forderung") eq $F->{ID}) {
			my $ok = 1;
			my $Team = 0;
				$Team = 1 if ($ChiefTeam eq $F->{F_Team1});
				$Team = 2 if ($ChiefTeam eq $F->{F_Team2});

			my $Message = $q->param("comment") || "";
			
			my $Map = "";
			if ($LSC{LeagueData}{AnzahlMaps} > 0) {
				$Map = $q->param("Map") || "";
				if ($LSC{LeagueData}{AnzahlMaps} == 2 && $F->{"F_Map".$Team}) {
						#ok, map nicht verndern, wenn vorher schon gesetzt
						$Map = $F->{"F_Map".$Team};

				} elsif ($LSC{LeagueData}{Mapliste} > 0) {
					if ($maps{$Map}) {
						# ok
						#$Map = $maps{$Map}; 
					
					#eine map, erste bereits gesetzt, dann ok
					} elsif($LSC{LeagueData}{AnzahlMaps} == 1 && $F->{"F_Map1"} && $maps{$F->{"F_Map1"}}) {
						$Map = $F->{"F_Map1"};
					} else {
						$Info .= $LSC{TEXT}{Forderung}[15].br;
						$ok = 0;
					}
				} else {
					if (!$Map) {
						$Info .= $LSC{TEXT}{Forderung}[14].br;
						$ok = 0;
					} elsif ($Map eq $LSC{LeagueData}{MapName}) {
						$Info .= $LSC{TEXT}{Forderung}[15].br;
						$ok = 0;
					}

				}
			}
			my $AndereMap = 0;
			if ($LSC{LeagueData}{AnzahlMaps} == 1) {
				if ($Map ne $F->{F_Map1}) {
					$AndereMap = 1;
				}
			}

			my $AnderesDatum = 0;
			Require("LSCErgebnisse2.fordern.pm");
			my $Date = _MSGForderungenDateTimePruefen($q->param("DateTime"), 1);
			if ($Date) {
				if ($Date ne $F->{F_Date_Ori}) {
					$AnderesDatum = 1;
				}
			} else {
				$Info .= $LSC{TempOut}.br;
				$LSC{TempOut} = "";
				$ok = 0;
			}
			if ($ok) {
				my $TeamZ = $Team == 1 ? 2 : 1;
	
				if ($Team) {
					my $sth = $LSC{MySQL}->prepare("update lsc_games_waiting_daten 
							set F_Date='$Date', F_Map$Team=".$LSC{MySQL}->quote($Map).", F_Msg$Team=".$LSC{MySQL}->quote($q->param("comment") || "").", F_Confirm$Team=1 ".
							($AnderesDatum || $AndereMap ? ", F_Confirm$TeamZ=0 " : "").
							($AndereMap ? ", F_Map$TeamZ=".$LSC{MySQL}->quote($Map)." " : "").
							"where ID=$F->{ID}");
					if ($sth->execute()) {
						$Info .= $LSC{TEXT}{Forderung}[17].br; #ok
						$F = ForderungLaden($F->{ID});
						
						my @user = ChiefsUndLeaderEinesTeams($F->{"F_Team".$TeamZ});

						my $Send = SendMessage(
							{	Email=>1, Intern=>1, 
								System=>1, 
								To=>[@user], From=>0, 
								ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
								DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
								Subject=>$LSC{TEXT}{Email}[3], 
								Message=>"", 
								Template=>$LSC{TEXT}{Email}[4], 
								TemplateValues=>{ 
											LINK=>$LSC{ScriptURL}."$LSC{user_pl}?League=$F->{League}&Action=NewGame&Action2=Details&special=".$F->{ID}}
							});
						if ($Send) {
							print hr.$Send.hr;
						}
					} else {
						$Info .= $LSC{TEXT}{Forderung}[18].br; #fehler
					}								
				}
			}
		}
	} elsif ($q->param("Reject")) {
		if ($F->{F_Confirm1} && $F->{F_Confirm2}) {
			$Info .= $LSC{TEXT}{Forderung}[25].br; #angenommen
		
		} elsif ($ChiefTeam ne $F->{F_Team1} && $ChiefTeam ne $F->{F_Team2}) {
			$Info .= $LSC{TEXT}{Forderung}[26].br; #nicht erlaubt

		} elsif ($q->param("Forderung") && $q->param("Forderung") eq $F->{ID}) {
			my $Team = 0;
				$Team = 1 if ($ChiefTeam eq $F->{F_Team1});
				$Team = 2 if ($ChiefTeam eq $F->{F_Team2});
			my $Team2 = $Team == 1 ? 2 : 1;
			my @user = ChiefsUndLeaderEinesTeams($F->{"F_Team".$Team2});

			#########
			## Mgliche Weitereprfungen folgen, z.b ob das ablehnen eine Forderung erlaubt ist
			#########

			#Forderung lschen
			my $sth = $LSC{MySQL}->do("delete from  lsc_games_waiting_daten where ID=$F->{ID}");

			my $Send = SendMessage(
							{	Email=>1, Intern=>1, 
								System=>1, 
								To=>[@user], From=>0, 
								ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
								DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
								Subject=>$LSC{TEXT}{Email}[9], 
								Message=>"", 
								Template=>$LSC{TEXT}{Email}[10], 
								TemplateValues=>{GEGNERNAME=>$LSC{username}, DATE=>$F->{F_Date}, TEAM1=>$F->{F_Teamname1}, TEAM2=>$F->{F_Teamname2}}
							});
			if ($Send) {
				print $Send.br.$LSC{TEXT}{Forderung}[38].br;
			}
			print $LSC{TEXT}{Forderung}[46].br; #abgelehnt zurckgezogen
			return;
			
		}
	} elsif ($q->param("AdminConfirm") && $LSC{ErgebnisAdminMod}) {
		if ($F->{F_Confirm1} && $F->{F_Confirm2}) {
			$Info .= $LSC{TEXT}{Forderung}[25].br; #angenommen
		
		} elsif ($q->param("Forderung") && $q->param("Forderung") eq $F->{ID}) {
			my $ok = 1;

			my $Message1 = $q->param("comment1") || "";
			my $Message2 = $q->param("comment2") || "";
			
			my $Map1 = "";
			my $Map2 = "";
			if ($LSC{LeagueData}{AnzahlMaps} > 0) {
				$Map1 = $q->param("Map1") || "";
				$Map2 = $q->param("Map2") || "";
				if ($LSC{LeagueData}{Mapliste} > 0) {
					if ($maps{$Map1} && $maps{$Map2}) {
						# ok
						#$Map = $maps{$Map}; 
					} else {
						$Info .= $LSC{TEXT}{Forderung}[15].br;
						$ok = 0;
					}
				} else {
					if (!$Map1 || !$Map2) {
						$Info .= $LSC{TEXT}{Forderung}[14].br;
						$ok = 0;
					} elsif ($Map1 eq $LSC{LeagueData}{MapName} || $Map2 eq $LSC{LeagueData}{MapName}) {
						$Info .= $LSC{TEXT}{Forderung}[15].br;
						$ok = 0;
					}

				}
			}

			Require("LSCErgebnisse2.fordern.pm");
			my $Date = _MSGForderungenDateTimePruefen($q->param("DateTime"), 1);

			if ($Date) {
				#ok
			} else {
				$Info .= $LSC{TempOut}.br;
				$LSC{TempOut} = "";
				$ok = 0;
			}
			if ($ok) {
				my $sth = $LSC{MySQL}->prepare("update lsc_games_waiting_daten 
						set F_Date='$Date', F_Map1=".$LSC{MySQL}->quote($Map1).",  F_Map2=".$LSC{MySQL}->quote($Map2).", F_Msg1=".$LSC{MySQL}->quote($q->param("comment1") || "").", F_Msg2=".$LSC{MySQL}->quote($q->param("comment2") || "").", F_Confirm1=1, F_Confirm2=1 ".
						"where ID=$F->{ID}");
				if ($sth->execute()) {
						$Info .= $LSC{TEXT}{Forderung}[17].br; #ok
						$F = ForderungLaden($F->{ID});
						
						my @user = (ChiefsUndLeaderEinesTeams($F->{"F_Team1"}), ChiefsUndLeaderEinesTeams($F->{"F_Team2"}));

						my $Send = SendMessage(
							{	Email=>1, Intern=>1, 
								System=>1, 
								To=>[@user], From=>0, 
								ToEmail=>"", FromEmail=>$LSC{notifyEmail}, 
								DeleteAfterXDays=>$LSC{Messages}{DeleteGameMsg}, 
								Subject=>$LSC{TEXT}{Email}[3], 
								Message=>"", 
								Template=>$LSC{TEXT}{Email}[4], 
								TemplateValues=>{ 
											LINK=>$LSC{ScriptURL}."$LSC{user_pl}?League=$F->{League}&Action=NewGame&Action2=Details&special=".$F->{ID}}
							});
						if ($Send) {
							print hr.$Send.hr;
						}
				} else {
						$Info .= $LSC{TEXT}{Forderung}[18].br; #fehler
				}								
				
			}
				
		} else {
			print $LSC{TEXT}{Forderung}[32].br;
		}
	} elsif ($q->param("DeleteAdminGame") && $LSC{ErgebnisAdminMod}) {
				my $sth = $LSC{MySQL}->do("delete from lsc_games_waiting where WaitingID=$F->{ID}");
				$sth = $LSC{MySQL}->do("delete from lsc_games_waiting_daten where ID=$F->{ID}");
				print $LSC{TEXT}{Ergebnisse}[54].br;
				return;
	} elsif ($q->param("ConfirmAdminGame") && $LSC{ErgebnisAdminMod}) {
				my $sth = $LSC{MySQL}->do("update lsc_games_waiting set Confirm=1 where WaitingID=$F->{ID}");
				my $check = ErgebnisFreischalten($F->{ID});
			
				if ($check) {
					if ($check > 0 ) {
							print $LSC{TEXT}{Ergebnisse}[8].br; #erfolgreich
					} elsif ($check == -1) {
						print $LSC{TEXT}{Ergebnisse}[22].br; #erfolgreich
					} 
					return;
				} 
				$Info .= $LSC{TEXT}{Ergebnisse}[21].br;
	} elsif ($q->param("ConfirmGame") && $q->param("Confirmed")) {
		if ($F->{GameDaten}{$ChiefTeam} && !$F->{Confirm}{$ChiefTeam}) {
			my $Vote = 0;
			if ($F->{GameDaten}{$ChiefTeam}{Vote}) {
				$Vote = $F->{GameDaten}{$ChiefTeam}{Vote};
			} elsif ($q->param("Vote")) {
				$Vote = $q->param("Vote");
			}
			if ($Vote && $Vote !~/[^1-5]/) {
				# ok
				my $sth = $LSC{MySQL}->do("update lsc_games_waiting set Confirm=1, Vote=$Vote where WaitingID=$F->{ID} and Team=$ChiefTeam");
			
				my $check = ErgebnisFreischalten($F->{ID});
			
				if ($check) {
					if ($check > 0) {
							print $LSC{TEXT}{Ergebnisse}[8].br; #erfolgreich
							return;
					} elsif ($check == -1) {
						print $LSC{TEXT}{Ergebnisse}[22].br; #erfolgreich
						$F = ForderungLaden($F->{ID});
					} else {
						$Info .= $LSC{TEXT}{Ergebnisse}[21].br;
					}
				} else {
					$Info .= $LSC{TEXT}{Ergebnisse}[21].br;
				}
			} else {
				$Info .= $LSC{TEXT}{Ergebnisse}[23].br; #kein vote
			}
		} else {
			$Info .= $LSC{TEXT}{Ergebnisse}[52].br;	#Ergebnis konnte nicht besttigt werden!
		}
	} elsif ($q->param("ConfirmGame")) {
		$Info .= $LSC{TEXT}{Ergebnisse}[19].br; # nicht checkbox ausgewhlt
	}

	if ($LSC{LeagueData}{Mapliste} > 0) {
		$F->{F_Map1Name} = $maps{$F->{F_Map1}} || "unknown";
		$F->{F_Map2Name} = "-";
		if ($LSC{LeagueData}{AnzahlMaps} == 2) {
			$F->{F_Map2Name} = $maps{$F->{F_Map2}} || "unknown";
		}
	} else {
		$F->{F_Map1Name} = $F->{F_Map1} || "unknown";
		$F->{F_Map2Name} = $F->{F_Map2} || "unknown";
	}
	

	$F->{Status} = 'unknown';
	$F->{DateShow} = ($F->{Date} || $F->{F_Date});

	$F->{F_Message1} = $F->{F_Msg1} ? RemoveHtmlFromText($F->{F_Msg1}) : "no comment";
	$F->{F_Message2} = $F->{F_Msg2} ? RemoveHtmlFromText($F->{F_Msg2}) : "no comment";

	if ($ChiefTeam ne $F->{F_Team1} && $ChiefTeam ne $F->{F_Team2}) {
		if ($LSC{UserStatus}==9) {
			$F->{F_Message1} .= "(ADMIN-MOD)";
			$F->{F_Message2} .= "(ADMIN-MOD)";
		} else {
			$F->{F_Message1} = "hidden!";
			$F->{F_Message2} = "hidden!";
		}
	} 

	my $Confirm = 0;
	my $ConfirmGame = 0;
	my $ConfirmAdmin = 0;
	my $ConfirmAdminGame = 0;
	my $Remove = 0;
	if (!$F->{F_Confirm1} || !$F->{F_Confirm2}) {
		if ($LSC{ErgebnisAdminMod}) {
			$ConfirmAdmin = 1;
		}
		# Status
		$F->{Status} = $LSC{TEXT}{Forderung}[21]; #unbesttigt
		if (($F->{F_Confirm1} && $ChiefTeam eq $F->{F_Team1}) || ($F->{F_Confirm2} && $ChiefTeam eq $F->{F_Team2})) {
			$F->{Status} = $LSC{TEXT}{Forderung}[22]; # warte auf Gegner
			$Remove = 1;
		}

		# Mapwahl des Gegners verstecken, bis beide besttigt haben
		if ($ChiefTeam ne $F->{F_Team1}) {
			$F->{F_Map1Name} = "hidden!" if $F->{F_Map1Name} ne "unknown";
			$F->{F_Map1Name} = "?" if $F->{F_Map1Name} eq "unknown";
		}
		if ($ChiefTeam ne $F->{F_Team2}) {
			if ($LSC{LeagueData}{AnzahlMaps} == 2) {
				$F->{F_Map2Name} = "hidden!" if $F->{F_Map2Name} ne "unknown";
				$F->{F_Map2Name} = "?" if $F->{F_Map2Name} eq "unknown";
			} else {
				$F->{F_Map2Name} = "-";
			}
		}
		# Mapliste/Datumswahl/Message anzeigen, wenn noch nicht besttigt
		if (!$F->{F_Confirm1} && $ChiefTeam eq $F->{F_Team1}) {
			if ($LSC{LeagueData}{Mapliste} > 0) {
				$maps{0} = "choose";
				$F->{F_Map1Name} = $q->popup_menu(-name=>'Map', -values=>[sort {$a <=> $b }(keys %maps)], -Labels=>\%maps, -default=>"0") if !$F->{F_Map1};
			} else {
				$F->{F_Map1Name} = $q->textfield('Map', "$LSC{LeagueData}{MapName}") if !$F->{F_Map1};
			}
			$F->{DateShow} = $q->textfield('DateTime', $F->{F_Date}, 16);
			$F->{F_Message1} = $q->textarea('comment','',5,35);
			$Confirm = 1;
		} elsif (!$F->{F_Confirm2} && $ChiefTeam eq $F->{F_Team2}) {
			if ($LSC{LeagueData}{Mapliste} > 0) {
				$maps{0} = "choose";
				$F->{F_Map2Name} = $q->popup_menu(-name=>'Map', -values=>[sort {$a <=> $b }(keys %maps)], -Labels=>\%maps, -default=>"0") if !$F->{F_Map2};
			} else {
				$F->{F_Map2Name} = $q->textfield('Map', "$LSC{LeagueData}{MapName}") if !$F->{F_Map2};
			}
			$F->{DateShow} = $q->textfield('DateTime', $F->{F_Date}, 16);
			$F->{F_Message2} = $q->textarea('comment','',5,35);
			$Confirm = 1;
		}
		if ($ConfirmAdmin) {
			if ($LSC{LeagueData}{Mapliste} > 0) {
				$maps{0} = "choose";
				$F->{F_Map1Name} = $q->popup_menu(-name=>'Map1', -values=>[sort {$a <=> $b }(keys %maps)], -Labels=>\%maps, -default=>$F->{F_Map1});
				$F->{F_Map2Name} = $q->popup_menu(-name=>'Map2', -values=>[sort {$a <=> $b }(keys %maps)], -Labels=>\%maps, -default=>$F->{F_Map2});
			} else {
				$F->{F_Map1Name} = $q->textfield('Map1', "$LSC{LeagueData}{MapName}");
				$F->{F_Map2Name} = $q->textfield('Map2', "$LSC{LeagueData}{MapName}");
			}
			$F->{DateShow} = $q->textfield('DateTime', $F->{F_Date}, 16);
			$F->{F_Message1} = $q->textarea('comment1',$F->{F_Msg1},5,35);
			$F->{F_Message2} = $q->textarea('comment2',$F->{F_Msg2},5,35);
		}
	} else {
		if ($LSC{ErgebnisAdminMod}) {
			foreach  (keys %{$F->{Confirm}}) {
				$ConfirmAdminGame = 1 if (defined $F->{Confirm}{$_} && !$F->{Confirm}{$_});
			}
			
		}
		$F->{Status} = $LSC{TEXT}{Forderung}[20].br; 		#besttigt
		$F->{Status} .= ShowLink({Name=>$LSC{TEXT}{Ergebnisse}[55], Script=>"$LSC{user_pl}", Action=>"NewGameF", Action2=>"", Special=>$F->{ID}, League=>$F->{League}}).br unless ($F->{Date}); #ergebnis eintragen
		$F->{Status} .= ShowLink({Name=>$LSC{TEXT}{Forderung}[33], Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Move", Special=>$F->{ID}, League=>$F->{League}}).br unless ($F->{Date}); #forderung verschieben
		$F->{Status} .= ShowLink({Name=>$LSC{TEXT}{Forderung}[47], Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"ReMove", Special=>$F->{ID}, League=>$F->{League}}).br unless ($F->{Date}); #forderung abbrechen
		$ConfirmGame = 1 if (defined $F->{Confirm}{$ChiefTeam} && !$F->{Confirm}{$ChiefTeam});
	}
	if ($ConfirmAdmin) {
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		print $q->hidden("Forderung",  $F->{ID});
		print $q->hidden("AdminConfirm",  1);
		$Confirm = 0;
	}
	if ($Confirm) {
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		print $q->hidden("Forderung",  $F->{ID});
		print $q->hidden("Confirm",  1);
	}

	print "<TABLE cellspacing=0 align=center width=100%>
		<TR>
			<TD class=Std1>&nbsp;</TD>
		</TR>
		<TR>
			<TD class=Std2>
			<TABLE cellspacing=0 align=center width=100%>
				<TR>
					<TD class=Std2 align=right>".TeamLink({Name=>TeamLogoAnzeigen($F->{F_Team1}, $F->{F_Teamname1})."<br>$F->{F_Teamname1}", ID=>$F->{F_Team1}, HideVote=>1, League=>$F->{League}}).($F->{GameDaten}{$F->{F_Team1}} ? " ($F->{GameDaten}{$F->{F_Team1}}{Points})" : "")."</TD>
					<TD class=Std2 align=center>&nbsp;vs.&nbsp;</TD>
					<TD class=Std2 align=left>".TeamLink({Name=>TeamLogoAnzeigen($F->{F_Team2}, $F->{F_Teamname2})."<br>$F->{F_Teamname2}", ID=>$F->{F_Team2}, HideVote=>1, League=>$F->{League}}).($F->{GameDaten}{$F->{F_Team2}} ? " ($F->{GameDaten}{$F->{F_Team2}}{Points})" : "")."</TD>
				</TR>
			</TABLE><br>
			</TD>
		</TR>
		<TR>
			<TD class=Std1>Game:</TD>
		</TR>
		<TR>
			<TD class=Std2>
			<TABLE cellspacing=0 align=center width=100%>
				<TR><TD class=Std2>ID: </TD><TD class=Std2>".$F->{ID}."</TD></TR>
				<TR><TD class=Std2>Date: </TD><TD class=Std2>".$F->{DateShow}."</TD></TR>
				<TR><TD class=Std2>&nbsp;</TD><TD class=Std2></TD></TR>
				".($LSC{LeagueData}{AnzahlMaps} ? 
						"<TR><TD class=Std2>$LSC{LeagueData}{MapName} 1: </TD><TD class=Std2> $F->{F_Map1Name}</TD></TR>".
						"<TR><TD class=Std2>$LSC{LeagueData}{MapName} 2: </TD><TD class=Std2> $F->{F_Map2Name}</TD></TR>".
						"<TR><TD class=Std2>&nbsp;</TD><TD class=Std2></TD></TR>"
						: 
						"")."
				<TR><TD class=Std2 valign=top>Status: </TD><TD class=Std2 valign=top>".($F->{F_Date} ? "$LSC{TEXT}{Forderung}[27]: ".$F->{Status}.br : "")."
				".($F->{Date} ? "$LSC{TEXT}{Forderung}[28]: ".$LSC{TEXT}{Forderung}[21] : "")."</TD></TR>	
				<TR><TD class=Std2>&nbsp;</TD><TD class=Std2></TD></TR>";

				if ($LSC{SupportTicketFunktion} && ($ChiefTeam eq $F->{F_Team1} || $ChiefTeam eq $F->{F_Team2})) {
					print '<TR><TD class=Std2>&nbsp;</TD><TD class=Std2>'.ShowLink({Name=>$LSC{TEXT}{Ergebnisse}[57], Script=>"$LSC{user_pl}", Action=>"SupportW", Action2=>"", Special=>$F->{ID}, League=>$F->{League}}).'</TD></TR>'; #protest
				}

				if ($F->{Date}) {
					_Ergebnisse_Formularwahl_Laden();
					my $MapWeise = $LSC{LeagueData}{NewGameForm}{"Team-Punkte-Map"} || $LSC{LeagueData}{NewGameForm}{"Team-Sieg-Unentschieden-Map"};
					print "<TR><TD class=Std2 valign=top>$LSC{TEXT}{Forderung}[29]: </TD><TD class=Std2>";
					print "<table cellspacing=0 width=100%>";
						print "<tr>";
							print "<td class=Std1>&nbsp;</td>";
							print "<td class=Std1 align=right>LP</td>";
							if ($MapWeise && $LSC{LeagueData}{AnzahlMaps} > 0) {
								if ($LSC{LeagueData}{AnzahlMaps}==1) {
									print "<td class=Std1 align=right>$LSC{LeagueData}{MapName}</td>";
								} elsif ($LSC{LeagueData}{AnzahlMaps}==2) {
									print "<td class=Std1 align=right>$LSC{LeagueData}{MapName} 1</td>";
									print "<td class=Std1 align=right>$LSC{LeagueData}{MapName} 2</td>";
								}
							} else {
								print "<td class=Std1 align=right>Total</td>";
							}

						print "<td class=Std1></td>";
						print "</tr>";
					foreach  (keys %{$F->{GameDaten}}) {
						print "<tr>";
							print "<td class=Std2>".($F->{Confirm}{$_} ? $LSC{TEXT}{Ergebnisse}[24] : $LSC{TEXT}{Ergebnisse}[25])."$F->{GameDaten}{$_}{Name}</td>";
							print "<td class=Std2 align=right>$F->{GameDaten}{$_}{LP}</td>";
							if ($MapWeise && $LSC{LeagueData}{AnzahlMaps} > 0) {
								if ($LSC{LeagueData}{AnzahlMaps}==1) {
									print "<td class=Std2 align=right>$F->{GameDaten}{$_}{Points}</td>";
								} elsif ($LSC{LeagueData}{AnzahlMaps}==2) {
									print "<td class=Std2 align=right>$F->{GameDaten}{$_}{PPoints1}</td>";
									print "<td class=Std2 align=right>$F->{GameDaten}{$_}{PPoints2}</td>";
								} 
							} else {
									print "<td class=Std2 align=right>$F->{GameDaten}{$_}{Points}</td>";
							}
							if ($F->{GameDaten}{$_}{Won}) {
								print "<td class=Std2 align=right>$LSC{TEXT}{Ergebnisse}[15]</td>";
							} elsif ($F->{GameDaten}{$_}{Lost}) {
								print "<td class=Std2 align=right>$LSC{TEXT}{Ergebnisse}[16]</td>";
							}
						print "</tr>";
					}
					print "</table>";
					print br.br;					
					if ($F->{Info}) {
						$F->{Info} =~ s/\n/\<br\>/gg;
						print "".$F->{Info}.br;
					}
					print "- $LSC{TEXT}{Forderung}[30]".br if $F->{Special}; #overtime
					print "</TD></TR>";
					print "<TR><TD class=Std2>&nbsp;</TD><TD class=Std2></TD></TR>";
				}
				print $Info ? "<TR><TD class=Std2></TD><TD class=Std2>$Info</TD></TR>" : "";
				if ($ConfirmGame) {
					print "<TR><TD class=Std2></TD><TD class=Std2>";
					print "<table><tr><td valign=bottom>";
						print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
						if ($LSC{ErgebnisAdminMod}) {
							print $q->hidden("Vote",  0);
						} else {
							print "Vote: ".$LSC{TEXT}{Votes}[7][0]." ".$q->radio_group(-name=>'Vote',
																						-values=>[5,4,3,2,1], 
																						-default=>3,
																						-labels=>{1=>"", 2=>"", 3=>"", 4=>"", 5=>""})." ".$LSC{TEXT}{Votes}[7][1].br;
						}
						print $q->hidden("Forderung",  $F->{ID});
						print $q->hidden("ConfirmGame",  1);
						print $q->checkbox(-name=>'Confirmed', -value=>1, -label=>"");
						print $q->submit($LSC{TEXT}{Ergebnisse}[18]).$q->end_form();
						print "</td><td valign=bottom>";
						print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame&Action2=&special=");
						print $q->hidden("Forderung",  $F->{ID});
					if ($LSC{LeagueData}{AnzahlMaps} <= 1) {
						print $q->hidden("Punkte1",  $F->{GameDaten}{$F->{F_Team1}}{Points}).
						$q->hidden("Punkte2",  $F->{GameDaten}{$F->{F_Team2}}{Points});
					} else {
						print $q->hidden("Punkte1",  $F->{GameDaten}{$F->{F_Team1}}{PPoints1}).
						$q->hidden("Punkte2",  $F->{GameDaten}{$F->{F_Team2}}{PPoints1}).
						$q->hidden("Punkte21", $F->{GameDaten}{$F->{F_Team1}}{PPoints2}).
						$q->hidden("Punkte22", $F->{GameDaten}{$F->{F_Team2}}{PPoints2});
					}

						print $q->submit($LSC{TEXT}{Ergebnisse}[20]).$q->end_form();
					print "</TD></TR></table>"; 		

					print "</TD></TR>"; 		
				}

				print "
			</TABLE><br>
			</TD>
		</TR>
		<TR>
			<TD class=Std2>&nbsp;</TD>
		</TR>
			<TR>
				<TD class=Std2>&nbsp;</TD>
			</TR>
			<TR>
				<TD class=Std1>$LSC{TEXT}{Forderung}[10]</TD>
			</TR>
			<TR>
				<TD class=Std1>$F->{F_Teamname1}</TD>
			</TR>
			<TR>
				<TD class=Std2>$F->{F_Message1}<br><br><br></TD>
			</TR>
			<TR>
				<TD class=Std1>$F->{F_Teamname2}</TD>
			</TR>
			<TR>
				<TD class=Std2>$F->{F_Message2}<br><br><br></TD>
			</TR>
			<TR>
				<TD class=Std2>&nbsp;</TD>
			</TR>			";		
		print "</TABLE>";

		if ($Confirm) {
			print "<TABLE>
					<TR>
						<TD>".$q->submit($LSC{TEXT}{Forderung}[23]).$q->end_form()."</TD>
						<TD>".
						$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
						$q->hidden("Forderung",  $F->{ID}).$q->hidden("Reject",  1).$q->submit($LSC{TEXT}{Forderung}[24]).$q->end_form().
						"</TD>
					</TR>
					</TABLE>";
		} 
		if ($Remove) {
			print "<TABLE>
					<TR>
						<TD>".
						$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
						$q->hidden("Forderung",  $F->{ID}).$q->hidden("Reject",  1).$q->submit($LSC{TEXT}{Forderung}[51]).$q->end_form().
						"</TD>
					</TR>
					</TABLE>";
		} 
		
		if ($ConfirmAdmin) {
			print $q->submit("Admin-".$LSC{TEXT}{Forderung}[23]).$q->end_form().br;
		}
		if ($LSC{ErgebnisAdminMod} && !$ConfirmAdmin) {
						print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=NewGame&Action2=&special=");

			print "<TABLE cellspacing=0>
					<TR>
						<TD>".
					$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=NewGame&special=$LSC{special}");
				
					if ($LSC{LeagueData}{AnzahlMaps} <= 1) {
						print $q->hidden("Punkte1",  $F->{GameDaten}{$F->{F_Team1}}{Points}).
						$q->hidden("Punkte2",  $F->{GameDaten}{$F->{F_Team2}}{Points});
					} else {
						print $q->hidden("Punkte1",  $F->{GameDaten}{$F->{F_Team1}}{PPoints1}).
						$q->hidden("Punkte2",  $F->{GameDaten}{$F->{F_Team2}}{PPoints1}).
						$q->hidden("Punkte21", $F->{GameDaten}{$F->{F_Team1}}{PPoints2}).
						$q->hidden("Punkte22", $F->{GameDaten}{$F->{F_Team2}}{PPoints2});
					}
					print $q->hidden("Forderung",  $F->{ID}).$q->submit("Admin-".$LSC{TEXT}{Ergebnisse}[20]." + ".$LSC{TEXT}{Ergebnisse}[18]).$q->end_form().
						"</TD>
					</TR>";
			if ($F->{Date}) {
				print "
					<TR>
						<TD>".
					$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
					$q->hidden("Forderung",  $F->{ID}).$q->hidden("ConfirmAdminGame",  1).$q->submit("Admin-".$LSC{TEXT}{Ergebnisse}[18]).$q->end_form().
						"</TD>
					</TR>";
			}
			print "
					<TR>
						<TD>".
					$q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}").
					$q->hidden("Forderung",  $F->{ID}).$q->hidden("DeleteAdminGame",  1).$q->submit("Admin-".$LSC{TEXT}{Ergebnisse}[53]).$q->end_form().
						"</TD>
					</TR>
					</TABLE>";
		}
}

sub ErgebnisFreischalten {
	my $ID = shift || return;
	# undef = error, > 0 freigeschaltet, -1 = noch nicht alle besttigungen vorhanden
	my $F = ForderungLaden($ID);
	unless ($F || $F->{Date}) {
		return undef;
	}

	unless ($F->{Date}) {
		return -1;
	}
	foreach  (keys %{$F->{GameDaten}}) {
		unless ($F->{Confirm}{$_}) {
			return -1;
		}
	}

	my $Spiel = $F->{GameDaten};
		
	# Playoff Modus
	if ($LSC{LeagueData}{PlayoffDaten}) {
		$Spiel = PlayoffDatenbankEinfuegenKorrekt($Spiel, $F->{League});
		unless ($Spiel) {
			return undef;
		}
	}
	# /Playoff Modus
	
	# Hauptspieldaten einfgen
	my $Datum = $Spiel->{'Date'} ? "'$F->{OriDate}'" : 'now()';
	my $do = "INSERT INTO lsc_games_daten 
	(League, Date, Special, POGName, InsertBy)
	VALUES
	('$F->{League}', $Datum, '$F->{Special}', ".$LSC{MySQL}->quote($F->{'PogName'}).", '$LSC{userid}')";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	
	my $GameID = $sth->{mysql_insertid};
	unless ($GameID) {
		print "Beim eintragen in die Datenbank konnte keine ID ermittelt werden. Bitte wende dich an einen Admin!".br;
		return undef;
	}
	$sth->finish;
	
	# Spielergebnis einfgen
	$do = "INSERT INTO lsc_games
	(Game,  Team,  Points,  PPoints1,  PPoints2,  LP,  Map,  Won,  Lost,  Draw,  Home,  Vote,  deleted)
	VALUES
	($GameID, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 0)";
	$sth = $LSC{MySQL}->prepare($do);
	foreach (keys %$Spiel) {
			if ($sth->execute($Spiel->{$_}{Team}, 
							$Spiel->{$_}{Points}, $Spiel->{$_}{PPoints1}, $Spiel->{$_}{PPoints2}, 
								$Spiel->{$_}{LP}, $Spiel->{$_}{Map},
								$Spiel->{$_}{Won}, $Spiel->{$_}{Lost}, $Spiel->{$_}{Draw}, 
								$Spiel->{$_}{Home}, $Spiel->{$_}{Vote})) {
					# ok
			} else {
				print "Das Ergebnis fr TeamID: $Spiel->{$_}{Team} konnt nicht in die Datenbank eingetragen werden. Bitte wende dich an einen Admin!".br;		
				return undef;
			}
	}	
	$sth->finish;

	#system comment eintragen wenn vorhanden:
	if ($F->{'Info'}) {
		$do = "INSERT INTO lsc_games_syscom
		(ID, Message)
		VALUES
		('$GameID', ".$LSC{MySQL}->quote($F->{'Info'}).")";
		$sth = $LSC{MySQL}->prepare($do);
		$sth->execute();
		$sth->finish;
	
	
	}
	
	my $Team1 = 0;
	my $Team2 = 0;

	my @Teams = keys %$Spiel;
	if (scalar(@Teams) != 2) {
		#print $LSC{TEXT}{Playoff}[0]; #ungltig
	} else {

		#erstes Team ermitteln
		if ($Spiel->{$Teams[0]}{Home}) {
			$Team1 = $Teams[0];
			$Team2 = $Teams[1];
		} else {
			$Team2 = $Teams[0];
			$Team1 = $Teams[1];
		}
	}


	# Playoff Modus / Runde beendet?
	if ($LSC{LeagueData}{PlayoffDaten}) {
		PlayoffNaechsteRunde($Spiel->{$Team1}{Team},
		$Spiel->{$Team2}{Team}, $Spiel->{$Team1}{Won}, $GameID);
	}
	# /Playoff Modus

	# PlayerStats
	if ($LSC{PlayerStats}) {
			SpielerInjVerletzungenErstellen($Spiel->{$Team1}{Team}, $Spiel->{$Team2}{Team});

			my $PlayerStats = PlayerStatsLigaAtAGlance($LSC{League}, 1);
			if (open(FILE, ">$LSC{uploadpfad}LigaScript-$LSC{League}-AtAGlance.html")) {
				print FILE $PlayerStats;
				close (FILE);
			}
	}

	# werte aktualisieren:
	Require("LSCPoints.pm");
	foreach (keys %$Spiel) {
		Points_TeamAktualisieren($Spiel->{$_}{Team}, $Spiel->{League});
	}


	if ($LSC{LeagueData}->{TableCreat} && $LSC{LeagueData}->{TableCreat}==2) {
		#Tabellen nach eintragen von Spielen erstellen/aktualisieren
		Require("LSCTabelle2.pm");
		Tabelle2Simpel($LSC{League}, 0, 1); #1 fr update
	}

	#Forderung lschen
	$sth = $LSC{MySQL}->do("delete from lsc_games_waiting where WaitingID=$F->{ID}");
	$sth = $LSC{MySQL}->do("delete from lsc_games_waiting_daten where ID=$F->{ID}");

	return $GameID;
}

# noch nicht genutzt:

#sub _MSGForderungenVonTeam {
#	$Team = $LSC{MySQL}->quote(shift || 0);
#	unless ($LSC{League}) {
#		return undef;
#	}
#	my $sth = $LSC{MySQL}->prepare("select ID from lsc_games_waiting_daten where League=$LSC{League} and
#						(F_Team1=$Team or F_Team2=$Team) order by F_Date, Date");
#	if ($sth->execute()) {
#		my @Forderungen = ();
#		while (my $ref = $sth->fetchrow_arrayref()) {
#			push (@Forderungen, $ref->[0]) if $ref->[0];
#		}
#		return @Forderungen;
#	}
#	return undef;
#}

Require("LSCErgebnisse2.all.pm");

1