
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




# Scripts fr KO-Systeme/Playoffs

#Mainprogs
# PlayoffRunden
# Playoffbaum
# PlayoffbaumAnzeigen

#Hilfsprogramme
# binadd
# PlayoffAnzahlTeams
# PlayoffTeamnameAndIdVonPosAndLeague
# PlayoffSpielNummer
# PlayoffNaechsteRunde
# PlayoffTeamNaechsteRunde
sub PlayoffRunden {
	if ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
		my $sth = $LSC{MySQL}->prepare("SELECT Max(Round) FROM lsc_playoffs_round WHERE
		League=$LSC{League}");
		$sth->execute();
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish;

		return $ref->[0];
	}
	my $Teams = shift;
	my $Runden = 1;
	while (2**$Runden < $Teams) {
		$Runden++;
	}
	return $Runden;
}

sub Playoffbaum {
	my $Teams = shift;
	my $out = shift || 0;
	my $kantenlayout = shift || 0;
	
	my $outtemp = '';
	my %Felder = ();
	
	my $Runden = PlayoffRunden($Teams);	
	
	my $StartSpalte = 1;
	my $EndSpalte = 2*$Runden+2;
	
	if (!$LSC{Fullscreen} && !$LSC{PlayoffNoMenu}) {
		if ($q->param('<<')) {
			$StartSpalte = $q->param('StartSpalte') -$LSC{PlayoffSingleEliminationAusgabeSchrittweite};
			$StartSpalte = 1 if $StartSpalte < 1;
		} elsif ($q->param('>>')) {
			$StartSpalte = $q->param('StartSpalte') +$LSC{PlayoffSingleEliminationAusgabeSchrittweite};
			$StartSpalte = ($EndSpalte -$LSC{PlayoffSingleEliminationAusgabeBreite}) if $StartSpalte > ($EndSpalte-$LSC{PlayoffSingleEliminationAusgabeBreite});
		} else {
			$StartSpalte = 1;
		}

		$q->delete("StartSpalte");
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}");
		print $q->hidden("StartSpalte", $StartSpalte);
		print $q->submit('<<'),$q->submit('>>'),$q->end_form(), br;

		$EndSpalte = $StartSpalte+$LSC{PlayoffSingleEliminationAusgabeBreite};
	}


	local *Zeigen = sub {
		my @z = @{(shift)};
		unless (@z) { return };
		pop(@z);
		return join('', reverse(@z));
	};
	local *ZahlToArray = sub {
		my @zahl = split(//, shift);
		return [reverse(@zahl)];
	};
	
	my @output = ();
	my $outputsize = 2*$Runden+2;

	my $Spalte = 0;
	my $AusgangsZeile = 1;
	for (my $R = $Runden; $R > 0; $R--) {
		my $Counter = '1' x $R;
		my $Z = ZahlToArray($Counter);
		
		$Spalte++;
		my $NextZeile = $AusgangsZeile*2;
		my $Zeile = $AusgangsZeile;
		
		my @kannten = ("\\", '/');
			#@kannten = ("", '');
		my $kanntencounter = 0;
		while ($Z) {
			my $z = Zeigen($Z);
			$Felder{"1".$z} = 1;
			$Felder{"2".$z} = 1;
			$output[$Spalte][$Zeile] = "#1".$z."#";
			$output[$outputsize-$Spalte][$Zeile] = "#2".$z."#";

			if ($kantenlayout ==1) {
				if ($R > 1) {
					$output[$Spalte+1][$Zeile] =  $kannten[$kanntencounter % 2];
					$output[$outputsize-$Spalte-1][$Zeile] = $kannten[($kanntencounter+1) % 2];
				}

				if (!($kanntencounter % 2) && $R > 1) {
					for (my $z = $Zeile+1; $z < $Zeile+$NextZeile; $z++) {
						$output[$Spalte+1][$z] = "|";
						$output[$outputsize-($Spalte+1)][$z] = "|";
					}
				} 
			}
			$Zeile+=$NextZeile;
			$Z = binadd($Z);
			$kanntencounter++;
		}
		$AusgangsZeile = $AusgangsZeile *2;
	}

	# ausgabe
	local *out = sub {
		if ($out) {
			$outtemp .= join('', @_);
		} else {
			print @;
		}
	};

	out('<table CELLSPACING="0" CELLPADDING="0" border=0>');
	
	my @LCounter;
	local *ZeigeGitter = sub {
		my $Zeile = shift || 0;
		my $Spalte = shift || 0;
		$LCounter[$Spalte] = 0 unless $LCounter[$Spalte];
			if ($Spalte > 1) {
				if ($Spalte < $outputsize/2) {
					if ($output[$Spalte-1][$Zeile]) {
						if (++$LCounter[$Spalte] % 2) {
							out('<td><img src="'.$LSC{imagepfad}.'/po_ld.gif"></td>');
						} else {
							out('<td><img src="'.$LSC{imagepfad}.'/po_lu.gif"></td>');
						}
					} else {
						if ($output[$Spalte][$Zeile]) {
							out('<td><img src="'.$LSC{imagepfad}.'/po_lr.gif"></td>');
						} elsif ($LCounter[$Spalte] % 2) {
#							out('<td><img src="'.$LSC{imagepfad}.'/po_l.gif"></td>');
							out('<td background="'.$LSC{imagepfad}.'/po_l.gif"></td>');

						} else {
							out('<td></td>');
						}
					}
				} elsif ($Spalte-1 > $outputsize/2) {
					if ($output[$Spalte][$Zeile]) {
						if (++$LCounter[$Spalte] % 2) {
							out('<td><img src="'.$LSC{imagepfad}.'/po_rd.gif"></td>');
						} else {
							out('<td><img src="'.$LSC{imagepfad}.'/po_ru.gif"></td>');
						}
					} else {
						if ($output[$Spalte-1][$Zeile]) {
							out('<td><img src="'.$LSC{imagepfad}.'/po_rl.gif"></td>');
						} elsif ($LCounter[$Spalte] % 2) {
#							out('<td><img src="'.$LSC{imagepfad}.'/po_r.gif"></td>');
							out('<td background="'.$LSC{imagepfad}.'/po_r.gif"></td>');
						} else {
							out('<td></td>');
						}
					}
				
				}
			}
	};
	for (my $Zeile = 1; $Zeile < $Teams; $Zeile++) {
		out("<tr>");
		for (my $Spalte = $StartSpalte; $Spalte < $EndSpalte; $Spalte++) {
			ZeigeGitter($Zeile, $Spalte);
			my $layout = $Spalte % 2;
			my $TD	= "<TD $PlayoffLayout[$layout] align=center width=15>";
		
			if ($output[$Spalte][$Zeile]) {
				out("$TD");
				out($output[$Spalte][$Zeile]); 
			} elsif ($output[$Spalte-1][$Zeile] && $output[$Spalte-1][$Zeile] eq '#1#') {
				out("<td align=center>");
				out('<img src="'.$LSC{imagepfad}.'/po_m.gif">');
			} else {
				out("<td>");
			}
			out("</td>");
		}
		if ($EndSpalte < $outputsize) {
			ZeigeGitter($Zeile, $EndSpalte);
		}
		out("</tr>");
		out("\n");
	}
	out("</table>");
	
	
	if ($out) {
		my $l = '<td><img src="images/po_ld.gif"></td>';
		#$outtemp =~s/\\/$l/gg;	
		return ($outtemp, \%Felder);
	}
}
sub PlayoffbaumAnzeigen {
	if ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
		PlayoffDoubleEliminationZeigen(@_);
		return 1;
	}
	my $Anzahl = PlayoffAnzahlTeams($LSC{League});
	unless ($Anzahl) {
		print "Keine Turnierbersicht verfgbar.";
		return;
	
	}
	
	my ($baum, $Teams) = Playoffbaum($Anzahl, 1);
	my $Runden = PlayoffRunden($Anzahl);
	
	my $s = '&nbsp;';
	foreach (keys %{$Teams}) {
		my ($name,$id) = PlayoffTeamnameAndIdVonPosAndLeague($_, $LSC{League});
		my $insert = $name;
		if ($id) {
			$name =~s/ /&nbsp;/gg;
			$insert = TeamLink($name, $id, 'Tabelle', !$LSC{Vote}{S}{Ergebnisse});
			$insert.= "&nbsp;".br."&nbsp;".PlayoffTeamRundeStanding($id, $_);
		} else {
			$insert = $s x 15;
		}
		$baum =~s/\#$_\#/$s$insert$s/;
	}
	$baum =~s/\#[0-9]*\#/\+/gg;
	print $baum;
	
	if (my $S = PlayoffSieger()) {
		my ($name,$id) = TeamnameAndUserFromTeamIDAndLeague($S, $LSC{League});
		print "<table width=100% align=center CELLPADDING=\"5\"><tr><td></td><td $PlayoffLayout[0]
		width=200 align=center> Sieger: ";
		$name=join(' ', split(//, $name));
		print TeamLink($name, $S, 'Tabelle', !$LSC{Vote}{S}{Ergebnisse});
		print "</td><td></td></tr></table>";
	}
}
sub PlayoffDoubleEliminationZeigen {
	my $Fullscreen = shift || 0;
	my $Runden = PlayoffRunden();
	my $Spiele;
	my %Plan;
	my $Runde = 1;
	my $zeile = 1;

	my $sth = $LSC{MySQL}->prepare("SELECT Spiel, Team1, Team2, GameID FROM lsc_playoffs_round WHERE
		League=$LSC{League} and Round=$Runde Order by Spiel");
		$sth->execute();
	
	local *Team = sub {
		my $T1;
		if ($_[0] > 0) {
			my ($T1Name, undef) = TeamnameAndUserFromTeamID($_[0]);
			$T1Name =~s/ /&nbsp;/gg;
			$T1 = TeamLink($T1Name, 
				$_[0], 'PDELTeam', !$LSC{Vote}{S}{Ergebnisse});
		} elsif ($_[0] == -1) {
			$T1 = 'freilos';
		} else {
			$T1 = '?';
		}
		return $T1;
	};
	local *Sieger = sub {
		my $sth = $LSC{MySQL}->prepare("SELECT Won FROM lsc_games WHERE
			Game=$_[0] and Team=$_[1]");
			$sth->execute();
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish;
		return $ref->[0] || 0;
	
	};
	local *Spiel = sub {
		#Spielnummer, Team1, Team2, GameID, Runde, Winner/looesbracket
		my $T1=Team($_[1]);
		my $T2=Team($_[2]);

		my $Game = $_[3] ? RecapLink($LSC{League}, $_[3], "&nbsp;Result&nbsp;", 'PDELSpiel') : "&nbsp;";
		if ($LSC{Admin}) {
			if (!$_[3]) {
				$T1 .= ShowLink({Name => '<FONT COLOR="#FF0000">-</FONT>', 
					Script => "admin.pl", 
					Action => "Playoff_DE_Delete_Team_Pos",
					Action2 => "$_[0]/$_[4]/$_[5]",
					Special => "$_[1]"}, 1) if $_[1] > 0 && $_[4] > 1;
				$T2 .= ShowLink({Name => '<FONT COLOR="#FF0000">-</FONT>', 
					Script => "admin.pl", 
					Action => "Playoff_DE_Delete_Team_Pos",
					Action2 => "$_[0]/$_[4]/$_[5]",
					Special => "$_[2]"}, 1) if $_[2] > 0 && $_[4] > 1;
			}
				$T1 .= ShowLink({Name => '<FONT COLOR="#339900">+</FONT>', 
					Script => "admin.pl", 
					Action => "Playoff_DE_Add_Team_Pos",
					Action2 => "$_[0]/$_[4]/$_[5]",
					Special => "1"}, 1) if $_[1] <= 0 && $_[4] > 1;
				$T2 .= ShowLink({Name => '<FONT COLOR="#339900">+</FONT>', 
					Script => "admin.pl", 
					Action => "Playoff_DE_Add_Team_Pos",
					Action2 => "$_[0]/$_[4]/$_[5]",
					Special => "2"}, 1) if $_[2] <= 0 && $_[4] > 1;
		}

		my $WL1 = 0;
		my $WL2 = 0;
		if ($_[3]) {
			$WL1 = 1 + (1 - Sieger($_[3], $_[1]));
			$WL2 = $WL1 == 1 ? 2 : 1;
		} elsif ($_[1] > 0 && $_[2] == -1) {
			$WL1 = 1;
		} elsif ($_[1] == -1 && $_[2] > 0) {
			$WL2 = 1;
		}
				
		my $Pkt1 = "10"; #noch ungenutzt
		my $Pkt2 = "-10"; #noch ungenutzt

		return { "Team1" => $T1, "Team1WL" => $WL1, "Team1Punkte" => $Pkt1, 
			"Team2" => $T2, "Team2WL" => $WL2, "Team2Punkte" => $Pkt2,
			"GameID" => ($_[5] > 0 ? "W" : "L")."$_[4]&nbsp;$_[0]", 
			"Game" => $Game};
	};
	
	
	while (my $ref = $sth->fetchrow_arrayref()) {
		$Plan{1}{0}[$zeile] = Spiel($ref->[0], $ref->[1], $ref->[2], $ref->[3], 1, 1);
		$Plan{1}{-2}[$zeile] = 1;
		$Plan{1}{2}[$zeile] = 1;
		$zeile+=2;
	}
	$sth->finish;
	
	my $maxZeile = $zeile;
	my $Zeilensprung = 0;
	my $Versetzt = 0;
	while ($Runde < $Runden) {
		$Runde++;
		if ($Runde % 2) {
			#ungerade
			$zeile=2**(($Runde-1)/2);
			
			my $sth = $LSC{MySQL}->prepare("SELECT Spiel, Team1, Team2, GameID FROM lsc_playoffs_round WHERE
				League=$LSC{League} and Round=$Runde Order by Spiel");
				$sth->execute();

		#print "Reihen u: ".($sth->rows).br;
			while (my $ref = $sth->fetchrow_arrayref()) {
				my $r = -$Runde;
				$Plan{$r}{0}[$zeile+$Versetzt] = Spiel($ref->[0], $ref->[1], $ref->[2], $ref->[3], $Runde, -1);
				
				$Plan{$r}{2}[$zeile+$Versetzt] = 1;
				$Plan{$r}{-2}[$zeile+$Versetzt] = 1;
			
				#Neuer Gegner aus dem Winner bracket:
				if (((-$Runde+1)/2) % 2) {
					#gekreuzt
					$Plan{$r}{9}[$zeile+$Versetzt+1]{Text1} = "von&nbsp;W".($Runde-1)."&nbsp;".($sth->rows+1-$ref->[0]);
				} else {
					#parallel
					$Plan{$r}{9}[$zeile+$Versetzt+1]{Text1} = "von&nbsp;W".($Runde-1)."&nbsp;".($ref->[0]);
				}
				$Plan{$r}{9}[$zeile+$Versetzt+1]{Text2} = "";
				#$Plan{$r}{2}[$zeile+$Versetzt+1] = 1;
				#$Plan{$r}{-2}[$zeile+$Versetzt+1] = 1;
				
				if ($Versetzt == 1) {
					#$Plan{$r+1}{-1}[$zeile+$Versetzt] = 1;
				
				}
				$Versetzt*=-1;
				$zeile+=$Zeilensprung;
			}
			$sth->finish;
		} else {
			#gerade
			$zeile = 2**($Runde/2);
			my $Startzeile = $zeile;
			if ($Zeilensprung && $Runde != $Runden) {
				$Zeilensprung = $Zeilensprung*2;
			} elsif ($Runde != $Runden) {
				$Zeilensprung=4;
			} else {
				$zeile = 2**($Runde/2-1);
			}
			my $Counter = 0;
			my $sth = $LSC{MySQL}->prepare("SELECT Spiel, Team1, Team2, GameID FROM lsc_playoffs_round WHERE
				League=$LSC{League} and Round=$Runde Order by Spiel");
				$sth->execute();
			
			while (my $ref = $sth->fetchrow_arrayref()) {
				$Counter++;
				my $r = $Runde;

				if ($Counter > $sth->rows/2 && $Runde < $Runden) {
					if ($Startzeile) {
						$zeile = $Startzeile;
						$Startzeile = 0;
					}
					$r=-$r;
				} else {
				}
				if ($Runde == $Runden) {
					$Plan{$r}{-2}[$zeile] = 0;
					$Plan{$r}{2}[$zeile] = 0;
					$Plan{$r-2}{2}[$zeile] = 0;
				} else {
					$Plan{$r}{-2}[$zeile] = 1;
					$Plan{$r}{2}[$zeile] = 1;
				}

				$Plan{$r}{0}[$zeile] = Spiel($ref->[0], $ref->[1], $ref->[2], $ref->[3], $Runde, $r);
				if ($r > 0 && $Runde<$Runden) {
					if (($Runde/2) % 2) {
						#gekreuzt
						$Plan{$r}{9}[$zeile+1]{Text1} = "Looser:&nbsp;";
						$Plan{$r}{9}[$zeile+1]{Text1} .= "L".($Runde+1)."&nbsp;".($sth->rows/2+1-$ref->[0]);
					} else {
						#parallel
						$Plan{$r}{9}[$zeile+1]{Text1} = "Looser:&nbsp;";
						$Plan{$r}{9}[$zeile+1]{Text1} .= "L".($Runde+1)."&nbsp;".$ref->[0];
					}
				}				
				
				$zeile+=$Zeilensprung;
			}
			$sth->finish;
		}
	}
	
	my $StartSpalte = 0;
	my @allespalten = sort {$a <=> $b} keys %Plan;

	if (defined $q->param('StartSpalte')) {
		$StartSpalte = $q->param('StartSpalte');
	} else {
		while ($allespalten[$StartSpalte] && $allespalten[$StartSpalte++] != 1) {};
		if ($StartSpalte > 2) {
			$StartSpalte -= 3;
		}
	}

	
	$StartSpalte += ($q->param('<<') && $StartSpalte>0)? -$LSC{PlayoffDoubleEliminationAusgabeSchrittweite} : $q->param('>>') ? +$LSC{PlayoffDoubleEliminationAusgabeSchrittweite} : 0;
	if ($StartSpalte < 0) {
		$StartSpalte = 0;
#		while ($allespalten[$StartSpalte] && $allespalten[$StartSpalte++] != 1) {};
#		if ($StartSpalte > 2) {
#			$StartSpalte -= 3;
#		}
	}
	if ($StartSpalte < 0) {
		$StartSpalte = 0;
	} elsif ($StartSpalte > @allespalten/1-4) {
		$StartSpalte = @allespalten/1-4;
	}
	$q->param('StartSpalte', $StartSpalte);
	if (defined($StartSpalte) && !$Fullscreen) {
		my $c=0;
		while ($allespalten[$StartSpalte] && $c++<$LSC{PlayoffDoubleEliminationAusgabeBreite}) {
			push(@spalten, $allespalten[$StartSpalte]);
			$StartSpalte++;
		}
	
	} else {
		@spalten = @allespalten;
	}
	unless ($Fullscreen) {
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}");
		print $q->hidden("StartSpalte");
		print $q->submit('<<'),$q->submit('>>'),$q->end_form(), br;
	}

	print "<table border=0 cellspacing=0 cellpadding=0>";
	print "<tr>";
		foreach my $spalte (@spalten) {
			my $Runde = $spalte;
			$Runde =~s/\-//;
			print "<td></td><td align=center>$Runde.&nbsp;Runde</td><td></td><td></td><td></td><td></td>";
		}
	print "</tr>\n";


	my $RahmenMalenEnde = -$allespalten[1];
		foreach my $spalte (@allespalten) {
			my $Runde = $spalte;
			$Runde =~s/\-//;
			
			my $malen = 0;
			my $first = 0;
			if ($RahmenMalenEnde > $Runde) {
				for (my $zeile=1; $zeile < $maxZeile-1; $zeile++) {
					if ($Plan{$spalte}{0}[$zeile] && !$Plan{$spalte}{0}[$zeile-1]) {
					$malen = 1- ($malen % 2);
					$first = 1;
					}
					if ($malen && ($spalte % 2)) {
						$Plan{$spalte}{-1}[$zeile] = 1 - $first;
						$Plan{$spalte}{-2}[$zeile] = 1;
						$Plan{$spalte}{-3}[$zeile] = 1;
					}
					if ($malen && ($spalte > 0)) {
						$Plan{$spalte}{1}[$zeile] = 1 - $first;
						$Plan{$spalte}{2}[$zeile] = 1;
						$Plan{$spalte}{3}[$zeile] = 1;
					}
					if (!$malen && $first && ($spalte % 2)) {
						$Plan{$spalte}{-1}[$zeile] = 1 ;
						$Plan{$spalte}{-2}[$zeile] = 1;
						#$Plan{$spalte}{-3}[$zeile] = 1;
					}
					if (!$malen && $first && ($spalte > 0)) {
						$Plan{$spalte}{1}[$zeile] = 1;
						$Plan{$spalte}{2}[$zeile] = 1;
						#$Plan{$spalte}{3}[$zeile] = 1;
					}
					$first = 0;
				}
			}
			
		}

	my $Rahmen = '<td class=PDEliRahmen><img src="/images/null.gif"></td>';
	my $RahmenL = '<td style="BACKGROUND-COLOR: #FFFF00; color: #c0c0c0;FONT-SIZE: 1px;"></td>';
	local *WinLost = sub {
		if ($_[0] == 1) {
			return "<td align=center style=\"BACKGROUND-COLOR: #009200; color: #f0f0f0; FONT-SIZE: 9px;\">W</td>";
		}
		if ($_[0] == 2) {
			return "<td align=center style=\"BACKGROUND-COLOR: #FF0000; color: #c0c0c0; FONT-SIZE: 9px;\">L</td>";
		}
		return "<td class=PDEliTeams></td>";
	
	};

	for (my $zeile=1; $zeile < $maxZeile-1; $zeile++) {
		print "<tr>";
		foreach my $spalte (@spalten) {
	print $Plan{$spalte}{-1}[$zeile] ? $Rahmen : "<td></td>";
			if ($Plan{$spalte}{0}[$zeile]{Game}) {
				print "<td class=PDEliTeams>&nbsp;$Plan{$spalte}{0}[$zeile]{Team1}</td>".
					WinLost($Plan{$spalte}{0}[$zeile]{Team1WL}).
					$Rahmen.
					"<td class=PDEliText>$Plan{$spalte}{0}[$zeile]{Game}</td>";
			} elsif ($Plan{$spalte}{9}[$zeile]{Text1}) {
				print "<td class=PDEliText>$Plan{$spalte}{9}[$zeile]{Text1}</td>";
				print "<td></td>" x3;
			} else {
				print "<td></td>" x 4;
			}
	print $Plan{$spalte}{1}[$zeile] ? $Rahmen : "<td></td>";
		}
		print "</tr>\n";
		print "<tr>";
		foreach my $spalte (@spalten) {
			if ($Plan{$spalte}{0}[$zeile]{Game}) {
				print $Plan{$spalte}{-2}[$zeile] && !($spalte < 0 && !($spalte%2))? $Rahmen : "<td></td>";
				print $Rahmen x 4;
				print $Plan{$spalte}{2}[$zeile] ? $Rahmen : "<td></td>";
			} else {
				print $Plan{$spalte}{-2}[$zeile] ? $Rahmen : "<td></td>";
				print "<td></td>" x 4;
				print $Plan{$spalte}{2}[$zeile] ? $Rahmen : "<td></td>";
			}
		}
		print "</tr>\n";
		print "<tr>";
		foreach my $spalte (@spalten) {
	print $Plan{$spalte}{-3}[$zeile] ? $Rahmen : 
			($spalte < 0 && !($spalte%2) && $Plan{$spalte}{0}[$zeile]{Game}) 
					? "<td>&nbsp;&nbsp;&nbsp;</td>" : "<td></td>";
			if ($Plan{$spalte}{0}[$zeile]{Game}) {
				print "<td class=PDEliTeams>&nbsp;$Plan{$spalte}{0}[$zeile]{Team2}</td>".
					WinLost($Plan{$spalte}{0}[$zeile]{Team2WL}).
					$Rahmen.
					"<td class=PDEliText>&nbsp;&nbsp;$Plan{$spalte}{0}[$zeile]{GameID}</td>";
			} elsif ($Plan{$spalte}{9}[$zeile]{Text2}) {
				print "<td class=PDEliText>$Plan{$spalte}{9}[$zeile]{Text2}</td>";
				print "<td></td>" x3;
			} else {
				print "<td></td>" x 4;
			}
	print $Plan{$spalte}{3}[$zeile] ? $Rahmen : "<td></td>";
		}
		print "</tr>\n";
	
	}
	print "</table>";
	

}
# Hilfsprogs
sub binadd {
	my $z = shift;
	my $l = scalar(@{$z}) -1;
	my $uebertrag = 1;
	
	my $i=0;
	my $ori = $z->[$l];
	while ($uebertrag == 1 && $z->[$i]) {
		if ($z->[$i] == 1 && $uebertrag == 1) {
			$z->[$i] = 2;
			$uebertrag = 0;

		} elsif ($z->[$i] == 2 && $uebertrag == 1) {
			$z->[$i] = 1;
			$uebertrag = 1;

		} else {
			$uebertrag = 0;
		}
		$i++;
	}
	if ($ori != $z->[$l]) {
		return;
	}	
	return $z;
}
sub PlayoffAnzahlTeams {
	my $League = shift;
	my ($select,$from,$where,$group,$order);

	$select	= "Max(Pos)";
	$from	= "lsc_playoffs";
	$where	= "League=$League";
	$group	= "";
	$order	= "";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	return $ref->[0] ? 2**length($ref->[0]) : 0;
}
sub PlayoffTeamnameAndIdVonPosAndLeague {
	my $Pos = shift;
	my $League = shift;
	my ($select,$from,$where,$group,$order);

	$select	= "T.Name, T.ID";
	$from	= "lsc_playoffs p, lsc_teams T";
	$where	= "p.League=$League and p.Pos=$Pos and p.Team=T.ID";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	my $name = $ref->[0] || '';
	my $id = $ref->[1];
	return ($name,$id);
}
sub PlayoffSpielNummer {
	my $Team1 = shift || 0;
	my $Team2 = shift || 0;

	my ($select,$from,$where,$group,$order);
	$select	= "count(*)";
	$from	= "$Select{Game}{From}";
	$from .= " ".$Select{Game}{JoinG2};
	$where	= "D.League=$LSC{League} and D.No=G1.Game and G1.Team=$Team1 and
	G2.Team=$Team2";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	return ($ref->[0] || 0)+1;
}
sub PlayoffNaechsteRunde {
	my $Team1 = shift;
	my $Team2 = shift;
	my $Team1Gewonnen = shift;
	my $GameID = shift || 0;
	my $Test = shift || 0;
	
	my $Spielnummer = PlayoffSpielNummer($Team1, $Team2);
	local *NaechsteRunde = sub {
		unless ($Test) {
			PlayoffTeamNaechsteRunde($_[0]);
			while (PlayoffTeamNaechsteRundeFreilos($_[0])) {
				PlayoffTeamNaechsteRunde($_[0]);
			}
		}
	};
	
	# Playoffrunde beendet?			
	if ($LSC{LeagueData}{PlayoffDaten}{'2Games_Draw'}) {
			
		if ($Spielnummer >= 3) {
			# Runde beendet
			# Sieger ermitteln
			if (PlayoffTeamPosition($Team1, $LSC{League})
				>
				PlayoffTeamPosition($Team2, $LSC{League})) {
				my $x = $Team1;
				$Team1 = $Team2;
				$Team2 = $x;
			}


			my ($select,$from,$where,$group,$order);
			$select	= "G1.Won, G1.Lost, G1.Draw, G1.Points,
				G2.Won, G2.Lost, G2.Draw, G2.Points, G1.Team, G2.Team";
			$from	= "$Select{Game}{From}";
			$from .= " ".$Select{Game}{JoinG2};
			$where	= "D.League=$LSC{League} and D.No=G1.Game and G1.Team=$Team1
			and G2.Team=$Team2";	
			$order = "Group by D.No order by D.No";
			my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
			$sth->execute();
			my @Spiel1 = $sth->fetchrow_array();
			my @Spiel2 = $sth->fetchrow_array();
			my @Spiel3 = $sth->fetchrow_array() || ();
			$sth->finish;

			# mehr siege
			if (($Spiel1[0]+$Spiel2[0])
					>
				($Spiel1[4]+$Spiel2[4])) {
					NaechsteRunde($Team1);

			} elsif (($Spiel1[0]+$Spiel2[0])
					<
				($Spiel1[4]+$Spiel2[4])) {
					NaechsteRunde($Team2);
			
			# mehr auswrtstore/-punkte
			} elsif (($Spiel1[3]+($Spiel2[3]*2))
					>
				(($Spiel1[7]*2)+$Spiel2[7])) {
					NaechsteRunde($Team1);

			} elsif (($Spiel1[3]+($Spiel2[3]*2))
					<
				(($Spiel1[7]*2)+$Spiel2[7])) {
					NaechsteRunde($Team2);
			
			# ergebnisse gleich
			} else {
				if ($Spiel3) {
					if ($Spiel3[0]) {
						NaechsteRunde($Team1);
					} else {
						NaechsteRunde($Team1);
					}					
				} else { 
					return;
				}
							
			}
			return 1;



		} 
	} # /2Games_Draw
	elsif ($LSC{LeagueData}{PlayoffDaten}{'BestOf'}) {
			my $Spielnummer = PlayoffSpielNummer($Team1, $Team2);
			my $GamesToWin = (PlayoffBestofLaenge(PlayoffAktuelleRunde($LSC{League}, $Team1))+1)/2;

			my ($select,$from,$where,$group,$order);
			$select	= "G1.Team, Sum(G1.Won) as W";
			$from	= "$Select{Game}{From}";
			$from .= " ".$Select{Game}{JoinG2};
			$where	= "D.League=$LSC{League} and D.No=G1.Game and G1.Team in ($Team1, $Team2) and G2.Team
			 in ($Team1, $Team2)";	
			$order = "Group by G1.Team order by W desc";

			my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
			$sth->execute();
			my @Spiel1 = $sth->fetchrow_array();

			if ($Spiel1[1] >= $GamesToWin) {
				NaechsteRunde($Spiel1[0]);
			}
	} elsif ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
		my ($from,$where);
		$from	= "lsc_playoffs_round";
		$where	= "League=$LSC{League} and 
				((Team1=$Team1 and Team2 = $Team2) 
					or
				(Team1=$Team2 and Team2=$Team1))
				and GameID=0";

		my $sth = $LSC{MySQL}->do("update $from set GameID=$GameID WHERE $where");
	
	} elsif ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
		# Spielid speichern:
		my ($from,$where);
		$from	= "lsc_playoffs_round";
		$where	= "League=$LSC{League} and 
				((Team1=$Team1 and Team2 = $Team2) 
					or
				(Team1=$Team2 and Team2=$Team1))
				and GameID=0";
		my $sth = $LSC{MySQL}->do("update $from set GameID=$GameID WHERE $where");
		$sth = $LSC{MySQL}->prepare("Select Round, Spiel from $from where GameID=$GameID");
		$sth->execute();
		my ($Runde, $Spiel) = $sth->fetchrow_array();
		
		my $Runden = PlayoffRunden();
		if ($Runden == $Runde) {
			return;
			#Turnier beendet
		}
		
		$sth = $LSC{MySQL}->prepare("Select Max(Spiel) from $from where Round=$Runde and League=$LSC{League}");
		$sth->execute();
		my ($Spiele) = $sth->fetchrow_array();
		
		if ($Runde==1) {
		
			#sieger:
			my $UpdateTeam = ($Spiel % 2) ? 'Team1' : 'Team2';
			my $UpdateTeamNr = $Team1Gewonnen ? $Team1 : $Team2;
				
			my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and Spiel=".( ($Spiel+ ($Spiel%2)) / 2)." and League=$LSC{League}");
			
			#verlierer:
			$UpdateTeamNr = $Team1Gewonnen ? $Team2 : $Team1;
			$sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and Spiel=".( ($Spiel+ ($Spiel%2)) / 2 + $Spiele/2)." and League=$LSC{League}");
			
		} elsif ($Runde % 2) {
			#ungerade
			
			#nur sieger kommt weiter
			my $UpdateTeam = ($Spiel % 2) ? 'Team1' : 'Team2';
			my $UpdateTeamNr = $Team1Gewonnen ? $Team1 : $Team2;
			
			if ($Runde+1 == $Runden) {	
				my $sth = $LSC{MySQL}->do("update $from set Team2=$UpdateTeamNr WHERE Round=".($Runde+1)." and Spiel=1 and League=$LSC{League}");
			} else {
				my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and Spiel=".( ($Spiel+ ($Spiel%2)) / 2 + $Spiele/2)." and League=$LSC{League}");
			}
		} else {
			#gerade
			
			if ($Spiel <= $Spiele/2) {
				#winner bracket

				#sieger
				my $UpdateTeam = ($Spiel % 2) ? 'Team1' : 'Team2';
				my $UpdateTeamNr = $Team1Gewonnen ? $Team1 : $Team2;
				my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+2)." and Spiel=".( ($Spiel+ ($Spiel%2)) / 2)." and League=$LSC{League}");
				
				#verlierer
				$UpdateTeamNr = $Team1Gewonnen ? $Team2 : $Team1;
				$UpdateTeam = 'Team2';
				my $neuesSpiel;
				if ((($Runde+1)/2) % 2) {
					#gekre
					$neuesSpiel= ($Spiele/2 +1 -$Spiel);
				} else {
						#parallel
					$neuesSpiel= $Spiel;
				}
				$sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and Spiel=".$neuesSpiel." and League=$LSC{League}");
			} else {
				#looeser bracket
				
				#nur sieger
				my $UpdateTeam = 'Team1';
				my $UpdateTeamNr = $Team1Gewonnen ? $Team1 : $Team2;
				
				my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and Spiel=".($Spiel - $Spiele/2)." and League=$LSC{League}");
			}
		}
		
		
		#auf freilose berprfen:
		pTest();		
		
	}
	
	
}
sub pTest {
	my %Members = Members();
	my @Test = keys %Members;
	my @NeuTest = ();
	my %MinRounds;
	while($Test[0]) {
		foreach my $Team (@Test) {
			my (undef, $Gegner) = PlayoffTeamRundenGegner($Team,1, $MinRounds{$Team}||0);	
			if ($Gegner && $Gegner==-1) {
				my $from	= "lsc_playoffs_round";
				my $where	= "League=$LSC{League} and 
						((Team1=$Team and Team2 = -1) 
							or
						(Team1=-1 and Team2=$Team))
						order by Round desc";
				my $sth = $LSC{MySQL}->prepare("Select Round, Spiel from $from where $where");
				$sth->execute();
				my ($Runde, $Spiel) = $sth->fetchrow_array();
			
				my $Runden = PlayoffRunden();
				if ($Runden == $Runde) {
					return;
					#Turnier beendet
				}
				$sth = $LSC{MySQL}->prepare("Select Max(Spiel) from $from where Round=$Runde and League=$LSC{League}");
				$sth->execute();
				my ($Spiele) = $sth->fetchrow_array();
			
				if ($Runde==1) {
					#sieger:
					my $UpdateTeam = ($Spiel % 2) ? 'Team1' : 'Team2';
					my $UpdateTeamNr = $Team;
					
					my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and League=$LSC{League} and Spiel=".( ($Spiel+ ($Spiel%2)) / 2));
					
				} elsif ($Runde % 2) {
					#ungerade
				
					#nur sieger kommt weiter
					my $UpdateTeam = ($Spiel % 2) ? 'Team1' : 'Team2';
					my $UpdateTeamNr = $Team;
					my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and League=$LSC{League} and Spiel=".( ($Spiel+ ($Spiel%2)) / 2 + $Spiele/2));
						
				} else {
					#gerade
					
					if ($Spiel <= $Spiele/2) {
						#winner bracket		
		
						#sieger
						my $UpdateTeam = ($Spiel % 2) ? 'Team1' : 'Team2';
						my $UpdateTeamNr = $Team;
						my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+2)." and League=$LSC{League} and Spiel=".( ($Spiel+ ($Spiel%2)) / 2));
						
					} else {
						#looeser bracket
					
					#nur sieger
						my $UpdateTeam = 'Team1';
						my $UpdateTeamNr = $Team;
					
						my $sth = $LSC{MySQL}->do("update $from set $UpdateTeam=$UpdateTeamNr WHERE Round=".($Runde+1)." and League=$LSC{League} and Spiel=".($Spiel - $Spiele/2));
					}
				}
				
				$sth = $LSC{MySQL}->prepare("Select Max(Round) from $from where League=$LSC{League} and 
						(Team1=$Team or Team2=$Team)");
				$sth->execute();
				my ($MaxRound) = $sth->fetchrow_array();
				$MinRounds{$Team} = $MaxRound;
				push (@NeuTest, $Team);

					
			}
		}
		@Test = @NeuTest;
		@NeuTest = ();
		
	
	
	}



}
sub PlayoffTeamPosition {
	my $Team = shift;
	my $League = shift;
	unless ($Team) {
		return 0;
	}
	my ($select,$from,$where,$group,$order);

	$select	= "min(Pos)";
	$from	= "lsc_playoffs";
	$where	= "League=$League and Team=$Team";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	return $ref->[0] || 0;
}
sub PlayoffSieger {
	my $League = shift || $LSC{League};
	my ($select,$from,$where,$group,$order);

	$select	= "Team";
	$from	= "lsc_playoffs";
	$where	= "League=$League and Pos=0";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	return $ref->[0] || 0;
}
sub PlayoffTeamNaechsteRunde {
	my $Team = shift;
	my $pos = PlayoffTeamPosition($Team, $LSC{League});
	
	if ($pos == 0) {
		print "Es konnte kein Team fr die nchste Runde freigeschaltet
		werden, bitte wende dich an einen Admin. Danke".br;
		return;
	}
	if ($pos == 1 || $pos == 2) {
		# turnier beendet
		print "Das Turnier ist beendet".br;
		$pos = 0;
	} else {
		my @pos = split(//, $pos);
		my $last = pop(@pos);
		$pos = join('', @pos);
		
	}
	
	my $sth = $LSC{MySQL}->do("insert into lsc_playoffs 
			(League, Pos, Team) Values 
			($LSC{League}, $pos, $Team)");
}
sub PlayoffTeamNaechsteRundeFreilos {
	my $Team = shift;
	my $pos = PlayoffTeamPosition($Team, , $LSC{League});

	my @pos = split(//, $pos);
	my $last = pop(@pos);
	my $new = join('', @pos).($last==1 ? 2:1);

	my ($select,$from,$where);
	$select	= "count(Team)";
	$from	= "lsc_playoffs";
	$where	= "League=$LSC{League} and Pos=$new and Team=0";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	return $ref->[0];
}
sub PlayoffTeamAktiv {
	my $Team = shift;

	if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
		my (undef, $Gegner) = PlayoffTeamRundenGegner($Team);	
		my (undef, $TeamNew) = PlayoffTeamRundenGegner($Gegner);
		return ($Team eq $TeamNew);

		if ($Team eq $TeamNew) {
			my $Spielnummer = PlayoffSpielNummer($Gegner, $Team);
			if ($Spielnummer == 1) {
				return 1;
			}
		}
		return 0;

	} elsif ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
		my (undef, $Gegner) = PlayoffTeamRundenGegner($Team);	
		my (undef, $TeamNew) = PlayoffTeamRundenGegner($Gegner);	
		return ($Team eq $TeamNew);
	} elsif ($LSC{LeagueData}{PlayoffDaten}) {
		my (undef, $Gegner) = PlayoffTeamRundenGegner($Team);	
		my (undef, $TeamNew) = PlayoffTeamRundenGegner($Gegner);	
		return ($Team eq $TeamNew);
	}
	return;
}
sub PlayoffTeamRundeStanding {
	my $Team1 = shift;
	my $pos = shift;

	my @pos = split(//, $pos);
	my $last = pop(@pos);
	my $new = join('', @pos).($last==1 ? 2:1);

	my ($name, $Team2)=  PlayoffTeamnameAndIdVonPosAndLeague($new, $LSC{League});
	unless ($Team2) {
		return '';
	}
	my ($select,$from,$where,$group,$order);
		$select	= "Sum(G1.Won), sum(G1.Lost), sum(G1.Draw)";
		$from	= "$Select{Game}{From}";
		$from .= " ".$Select{Game}{JoinG2};
		$where	= "D.League=$LSC{League} and D.No=G1.Game and G1.Team=$Team1
			and G2.Team=$Team2";	
		$order = "group by G1.Team order by D.No";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
		$sth->execute();
		my $Spiel = $sth->fetchrow_arrayref();
		$sth->finish;
		
	return ($Spiel->[0]||0)."W:".($Spiel->[2] ? $Spiel->[2]."-D:" : '').($Spiel->[1]||0)."L";

}
sub PlayoffTeamRundenGegner {
	my $Team = shift;
	my $DirekteNummer = shift || 0;
	my $MinimumRunde = shift || 0;
	unless ($Team) {
		return;
	}
	if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
		my $runde = PlayoffAktuelleRunde($LSC{League});
		my ($select,$from,$where);
		$select	= "Team1, Team2";
		$from	= "lsc_playoffs_round";
		$where	= "League=$LSC{League} and Round=$runde and (Team1=$Team or Team2=$Team) and GameID=0 order by Round desc";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
		$sth->execute();
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish;
		if ($ref->[0]) {
			my $id = $Team==$ref->[0] ? $ref->[1] : $ref->[0];
			my ($name, undef) = TeamnameAndUserFromTeamIDAndLeague($id, $LSC{League});
			return ($name, $id);
		}
		return;
	} elsif ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
		my ($select,$from,$where);
		$select	= "Team1, Team2";
		$from	= "lsc_playoffs_round";
		$where	= "League=$LSC{League} and 
				(Team1=$Team or Team2=$Team)
				and GameID=0 ";
		if ($MinimumRunde) {
			$where .= "and Round > $MinimumRunde ";
		}	
		$where .= "order by Round desc limit 1";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
		$sth->execute();
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish;
		if ($ref->[0]) {
			my $id = $Team==$ref->[0] ? $ref->[1] : $ref->[0];
			if ($id <= 0) {
				if ($DirekteNummer) {
					return ('', $id);
				}
				return;
			}
			my ($name, undef) = TeamnameAndUserFromTeamIDAndLeague($id, $LSC{League});
			return ($name, $id);
		}
		return;

		
		
	} elsif ($LSC{LeagueData}{PlayoffDaten}) {
		my $pos = PlayoffTeamPosition($Team, $LSC{League});
	
		if ($pos == 0) {
			print "Es konnte kein Gegner ermittelt werden".br;
			return;
		}
	
		my @pos = split(//, $pos);
		my $last = pop(@pos);
		my $new = join('', @pos).($last==1 ? 2:1);

		return PlayoffTeamnameAndIdVonPosAndLeague($new, $LSC{League});
	}
}
sub PlayoffAktuelleRunde {
	my $League = shift || $LSC{League};
	unless ($League) {
		print "Playoffrunde konnte nicht ermittelt werden.";
		return 0;
	}
	if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
		my ($select,$from,$where);
		$select	= "Max(Round)";
		$from	= "lsc_playoffs_round";
		$where	= "League=$League";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
		$sth->execute();
		my $ref = $sth->fetchrow_arrayref();
		$sth->finish;
		return $ref->[0] || 0;
	}
	my $Team = shift;
	unless ($Team) {
		print "Kein Team zum ermitteln der Playoffrunde bergeben.";
		return 0;
	}
		

	if ($LSC{LeagueData}{PlayoffDaten}) {
		my $pos = PlayoffTeamPosition($Team, $League);
		unless($pos) {
			return 0;
		}	
		
		my $Anzahl = PlayoffAnzahlTeams($LSC{League});
		unless ($Anzahl) {
			return 0;
		}

		my $Runden = PlayoffRunden($Anzahl);
	
		return $Runden-length($pos)+1;
	}
	return;
}
sub PlayoffBestofLaenge {
	my $Round= shift;
	my ($select,$from,$where);
	$select	= "Games";
	$from	= "lsc_playoffs_bestof";
	$where	= "League=$LSC{League} and Round=$Round";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;
	
	return $ref->[0] || 0;
}
sub PlayoffPokalErgebnisse {
	my $AktuelleRunde = PlayoffAktuelleRunde($LSC{League});
	my $Runde = $_[0] || $AktuelleRunde;
	local *Anzeigen = sub {			
		my %Members = Members();


		my ($select,$from,$where);
		$select	= "Team1, Team2, GameID";
		$from	= "lsc_playoffs_round";
		$where	= "League=$LSC{League} and Round=$Runde";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
		$sth->execute();

		print '<TABLE BORDER="0" width=100% CELLSPACING="0" CELLPADDING="2" align=center>';
		my $TD1	= "<TD class=Headline algin=left>";
		my $td	= "<TD align=center class=Headline>";
		my $td_ = "</td>";

		print "<tr>$TD1#$td_$td$Runde. Runde$td_$td&nbsp;$td_$td&nbsp;$td_</tr>";
		
		my $Spiel=0;
		while (my $ref = $sth->fetchrow_arrayref()) {
			#ausgabe:
			my $Team1 = $Members{$ref->[0]};
			my $Team2 = $Members{$ref->[1]};
			$Team1=~s/ /&nbsp;/gg;
			$Team2=~s/ /&nbsp;/gg;
			
			my $T1out = $ref->[0] ? TeamLink($Team1, $ref->[0],
			'Tabelle',!$LSC{Vote}{S}{Ergebnisse}) : 'spielfrei';
			my $T2out = $ref->[1] ? TeamLink($Team2, $ref->[1],
			'Tabelle',!$LSC{Vote}{S}{Ergebnisse}) : 'spielfrei';
		
			my $layout = $Spiel++ % 2;
			$TD1	= "<TD $TableLayout[$layout] algin=left>";
			$td	= "<TD align=center $TableLayout[$layout]>";
			$td_ = "</td>";
	
			my $recap = "";
			if ($ref->[0] && $ref->[1] && (my $Game = PlayoffErgebnisVonGameID($ref->[2]))) {
			
			
				my($m,$d,$y) = (1,1,1);
				($m,undef,$d,$y,undef) = ($Game->[3] =~ /(\w{3})(\w*) (\d+) (\w{3})(\w+)/);
				
				my $RecapLink = "";
				if ($ref->[0] == $Game->[7]) {
					$RecapLink = $RecapLink = RecapLink($LSC{League}, $Game->[0], "$Game->[1]:$Game->[2]");
				} else {
					$RecapLink = $RecapLink = RecapLink($LSC{League}, $Game->[0], "$Game->[2]:$Game->[1]");
				}
			
				$recap = "($Game->[0]) $RecapLink";

			} else {
				$recap = "-";
			}
		
			print "<tr>$TD1$Spiel.$td_$td$T1out$td_$td$T2out$td_$td$recap$td_</tr>";
		}
		$sth->finish;
		print "</table>";
	};
	print "<table align=center><tr><td width=70>";
		for (my $s=1;$s<=$AktuelleRunde;$s++) {
			print "<a class=MenueLink href=$scriptname?".
			"League=$LSC{League}&Action=Results&Action2=$s><b>$s. Runde</b></a>";
			print br;
		}
		print "</td><td width=350>";
		if ($Runde > $AktuelleRunde) {
			print "Die Paarungen stehen nur bis zur $AktuelleRunde. Runde zur Verfgung!".br;
		} else {
			Anzeigen();
		}
	print "</td></tr></table>";

}
sub PlayoffErgebnisFuerAB {
	my $Team1 = shift;
	my $Team2 = shift;

	my ($select,$from,$where,$group,$order);
		$select	= "G1.Game, G1.Points, G2.Points,
			DATE_FORMAT(D.Date,'%M %e %W'), 
			G1.Won, G1.Lost, G1.Draw";
		$from	= "$Select{Game}{From}";
		$from .= " ".$Select{Game}{JoinG2};
		$where = $Select{Game}{Where}." and G1.Team=$Team1 and G2.Team=$Team2";
				$where =~s/\#LEAGUE/$LSC{League}/gg;		
		$group	= "";
		$order	= "";
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
		$sth->execute();
		my $Spiel = $sth->fetchrow_arrayref();
		$sth->finish;
		
	return $Spiel;
}
sub PlayoffErgebnisVonGameID {
	my $GameID = shift || 0;
	unless ($GameID) {return;}
	

	my ($select,$from,$where,$group,$order);
		$select	= "G1.Game, G1.Points, G2.Points,
			DATE_FORMAT(D.Date,'%M %e %W'), 
			G1.Won, G1.Lost, G1.Draw, G1.Team";
		$from	= "$Select{Game}{From}";
		$from .= " ".$Select{Game}{JoinG2};
		$where = $Select{Game}{WhereHome}." and D.No=$GameID";
				$where =~s/\#LEAGUE/$LSC{League}/gg;		
		$group	= "";
		$order	= "";
#	if ($LSC{userid} == 1) {
#print "SELECT $select FROM $from WHERE $where $order".br;
#	}
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $order");
		$sth->execute();
		my $Spiel = $sth->fetchrow_arrayref();
		$sth->finish;
		
	return $Spiel;
}
### datenbankfunktionen

sub PlayoffDatenbankEinfuegenKorrekt {
	my $Spiel = shift;
	my $League = shift;

	my $Team1 = 0;
	my $Team2 = 0;

	my @Teams = keys %$Spiel;
	if (scalar(@Teams) != 2) {
		print $LSC{TEXT}{Playoff}[0]; #ungltig
	}

	#erstes Team ermitteln
	if ($Spiel->{$Teams[0]}{Home}) {
		$Team1 = $Teams[0];
		$Team2 = $Teams[1];
	} else {
		$Team2 = $Teams[0];
		$Team1 = $Teams[1];
	}

	if ($LSC{LeagueData}{PlayoffDaten}{'2Games_Draw'}) {
			
			# fr wen Heimspiel?
			my $Spielnummer = PlayoffSpielNummer($Team1, $Team2);
			my $vrgl = PlayoffTeamPosition($Team1, $LSC{League})
					<
					PlayoffTeamPosition($Team2, $LSC{League});
			if (	($Spielnummer == 1 && !$vrgl) ||
				($Spielnummer == 2 && $vrgl)) {
				# zweites Spiel ist Heimspiel fr 2. Team
				
				#heim auswrtspiel vertauschen
				$Spiel->{$Team1}{Home} = 0 if $Spiel->{$Team1}{Home};
				$Spiel->{$Team1}{Home} = 1 unless $Spiel->{$Team1}{Home};

				$Spiel->{$Team2}{Home} = 0 if $Spiel->{$Team2}{Home};
				$Spiel->{$Team2}{Home} = 1 unless $Spiel->{$Team2}{Home};
				return $spiel;
			} elsif ($Spielnummer == 3 
				&& !PlayoffNaechsteRunde($FirstTeamID,	$q->param('Opponent'), 1)) {
				print "In diesem Turnier werden nur 2 Partien pro Runde ausgetragen,
				deshalb kann dieses Spiel nicht freigeschaltet werden!".br;
				return;
			}
			
	} elsif ($LSC{LeagueData}{PlayoffDaten}{'BestOf'}) {
			my $Spielnummer = PlayoffSpielNummer($Team1, $Team2);

			my $GamesToWin = PlayoffBestofLaenge(PlayoffAktuelleRunde($League, $Team1));
			if ($Spielnummer > $GamesToWin) {
				print "In dieser Turnierunde werden Maximal $GamesToWin Partien ausgetragen,
				deshalb kann dieses Spiel nicht freigeschaltet werden!".br;
				return;
			}
			
	} elsif ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
			unless (PlayoffTeamAktiv($Team1) &&
					PlayoffTeamAktiv($Team2)) {
				print "In dieser Turnierunde werden Maximal eine Partie ausgetragen,
				deshalb kann dieses Spiel nicht freigeschaltet werden!".br;
				return;
			}
			
	} elsif ($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
	
			# existiert ein leeres spiel?
			my ($select,$from,$where);
			$select	= "count(*)";
			$from	= "lsc_playoffs_round";
			$where	= "League=$LSC{League} and 
					((Team1=$Team1 and Team2 =$Team2) 
						or
					(Team1=$Team2 and Team2=$Team1))
					and GameID=0";
			my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
			$sth->execute();
			my $ref = $sth->fetchrow_arrayref();
			$sth->finish;
			unless ($ref->[0]) {
				print "Es wurden bereits alle Spiele eingetragen.".br;
				return;
			}


	}
	
	return $Spiel;
}


### AdminExtra
sub AdminPlayoffs_DoubleElimination_Delete_Team_Pos {
	my ($Spiel_Round_Bracket, $Team) = @_;
	my ($Spiel, $Round, $Bracket) = split(/\//, $Spiel_Round_Bracket || "");

	print "Hier kannst du das gewhlte Team aus dem DoubleElimination Baum lschen.".br.br;
	
	print "ACHTUNG: Damit ein eingetragenes Ergebnis komplett Rckgngig gemacht werden kann, muss folgendes gemacht werden:".br;
	print "1. Ergebnis lschen".br;
	print "2. Beide beteiligten Teams bis zum Punkt lschen, an dem das Ergebnis gelscht wurde".br;
	print "Sollte der Spielplan nicht aktualisiert worden sein, bitte einmal die Seite \"Reloaden (F5)\"!".br.hr.br;

	unless ($Spiel || $Round || $Bracket) {
		print "Es konnten nicht alle bentigten Daten ermittelt werden";
		return;
	}
	my ($Teamname, undef) = TeamnameAndUserFromTeamID($Team);
	unless ($Teamname) {
		print "Es konnte kein Teamname von den bergebenen Daten ermittelt werden";
		return;
	}

	if ($q->param('delete')) {
		my $sth = $LSC{MySQL}->do("update lsc_playoffs_round set Team1=0 where League=$LSC{League} and Round=$Round and Spiel=$Spiel and Team1=$Team and GameID=0");
		$sth = $LSC{MySQL}->do("update lsc_playoffs_round set Team2=0 where League=$LSC{League} and Round=$Round and Spiel=$Spiel and Team2=$Team and GameID=0");
		print "Eintrag gelscht!".br; 
	} else {
		print "Gewhltes Team($Teamname) in der Runde $Round aus dem ".($Bracket > 0?"Winner":"Looser")."bracket lschen ";
		print $q->start_form('post',"admin.pl?League=$LSC{League}&Action=Playoff_DE_Delete_Team_Pos&Action2=$Spiel_Round_Bracket&special=$Team");	
		print $q->submit('delete');
		print $q->end_form();
	}

	print br.ShowFullScreenLink({Name => "zur FullScreen Uebersicht", Script => $LSC{show_pl}, Action => "StandingsB"}, 1);
}
sub AdminPlayoffs_DoubleElimination_Add_Team_Pos {
	my ($Spiel_Round_Bracket, $pos) = @_;
	my ($Spiel, $Round, $Bracket) = split(/\//, $Spiel_Round_Bracket || "");

	print "Hier kannst du ein Team in den DoubleElimination Baum einfgen.".br.br;
	
	unless ($Spiel || $Round || $Bracket) {
		print "Es konnten nicht alle bentigten Daten ermittelt werden";
		return;
	}

	my %Members = Members();
	if ($q->param('add')) {
		if ($pos && $Members{$q->param('Team')||""}) {
			if ($pos eq "1") {
				my $sth = $LSC{MySQL}->do("update lsc_playoffs_round set Team1=".$LSC{MySQL}->quote($q->param('Team'))." where League=$LSC{League} and Round=$Round and Spiel=$Spiel and Team1<=0 and GameID=0");
				print "Team hinzugefgt".br;
			} elsif ($pos eq "2") {
				my $sth = $LSC{MySQL}->do("update lsc_playoffs_round set Team2=".$LSC{MySQL}->quote($q->param('Team'))." where League=$LSC{League} and Round=$Round and Spiel=$Spiel and Team2<=0 and GameID=0");
				print "Team hinzugefgt".br;
			} else {
				print "konnte Team nicht hizufgen1";
			}
		} else {
			print "konnte Team nicht hizufgen2 $pos";
		}
	} else {
		print "Gewhltes Team($Teamname) in der Runde $Round aus dem ".($Bracket > 0?"Winner":"Looser")."bracket lschen ";
		print $q->start_form('post',"admin.pl?League=$LSC{League}&Action=Playoff_DE_Add_Team_Pos&Action2=$Spiel_Round_Bracket&special=$pos");	
		print $q->popup_menu(-name=>'Team',-values=>[keys %Members],-labels=>\%Members).$q->submit('add');
		print $q->end_form();
	}

	print br.ShowFullScreenLink({Name => "zur FullScreen Uebersicht", Script => $LSC{show_pl}, Action => "StandingsB"}, 1);
}

1
