
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################





### Require:
## StatistikenTeam:

sub StatistikenTeam {
	print '<table cellspacing=0 cellpadding=0 width="100%" height="100" Style="border-style:solid; border-width:1px; border-color:#8596B0"><tr><td>';
	my ($Action, $TeamID) = @_;
	my $special = "";
	if ($LSC{special2}) {
		$special = $TeamID;
		$TeamID = $LSC{special2};
	}
	my $TeamDaten = TeamDatenLaden($TeamID);
	if (!$TeamDaten || !$TeamDaten->{Name}) {
		print "unbekanntes Team!";
print '</td></tr></table>';
		return;
	}
	$Action = "" unless $Action;

	my $values = $TeamID;
	my $TeamStatus = 0;
	$values->{"LSC-TeamID"} = $TeamID;
	$values->{"LSC-TeamIDStats"} = $TeamID;
	$values->{"LSC-TeamStatus"} = TeamStatus($TeamID);

	# User/Team - Daten
	($values->{"LSC-Teamname"}, $UserID, $TeamStatus) = 	TeamnameAndUserFromTeamID($TeamID);
	$values->{"LSC-Username"} = NameFromUserID($UserID);

	# Team Status Info
	$values->{"LSC-TeamStatusInfo"} = "ok";
	$values->{"LSC-TeamStatusInfo"} =  $LSC{TEXT}{Team}[1] if ($TeamStatus ==1); # gesperrt

	$values->{"LSC-TeamStatusInfo2"} = "";
	my $TeamSpieltInLiga = $LSC{League} ? TeamSpieltInLiga($TeamID, $LSC{League}) : 0;
	$values->{"LSC-TeamStatusInfo2"} .= $LSC{TEXT}{Team}[0] if ($LSC{League} && !$TeamSpieltInLiga && $TeamStatus!=1); # ausgeschieden (inaktiv)
	my $TeamLigaStatus = $LSC{League} ? TeamLigaStatus($TeamID, $LSC{League}) : 0;
	$values->{"LSC-TeamStatusInfo2"} .= $LSC{TEXT}{Team}[2] if ($LSC{League} && $TeamLigaStatus==1); # (inaktiv)

	# weitere TeamInformationen
	$values->{"LSC-OwnerLink"}		= $values->{"LSC-Username"} ? UserLink($values->{"LSC-Username"}, $UserID) : 'not available';

	$values->{"LSC-TeamInfo"}		= RemoveHtmlFromText($TeamDaten->{Info});
	$values->{"LSC-TeamHomepage"}	= $TeamDaten->{Homepage};		
	$values->{"LSC-TeamHomepage"} =~s/\</&lt/gg;
	$values->{"LSC-TeamHomepage"} =~s/\>/&gt/gg;

	$values->{"LSC-TeamHomepage"}	= '<a target="_blank" href="http://'.$values->{"LSC-TeamHomepage"}.'">'.$values->{"LSC-TeamHomepage"}.'</a>' if $values->{"LSC-TeamHomepage"};
	$values->{"LSC-TeamIRC"}		= $TeamDaten->{IRC};
	$values->{"LSC-TeamTag"}		= $TeamDaten->{TAG};
	my ($Image, $Logo) = ($TeamDaten->{Image1}, $TeamDaten->{Image2});

	$Logo = $LSC{DefaultTeamImage} unless $Logo;
	$values->{"LSC-TeamImage"}		= $Image ? '<img src="'.$Image.'"  BORDER=0 Title="'.$values->{"LSC-Teamname"}.'">' : "";
	$values->{"LSC-TeamLogo"}		= $Logo ? '<img src="'.$Logo.'" WIDTH="100" HEIGHT="100" BORDER=0 Title="'.$values->{"LSC-Teamname"}.'">' : "";

	my $TeamMembers = TeamMembers($TeamID);
	$values->{"LSC-TeamMembersSmall"} = '';
		foreach my $M (sort {$TeamMembers->{$b}{Status} <=> $TeamMembers->{$a}{Status}}keys %{$TeamMembers}) {
			$values->{"LSC-TeamMembersSmall"} .= UserLink($TeamMembers->{$M}{Name}, $M)." ";
		}
	$values->{"LSC-TeamMembersHeadline"} = "";
	$values->{"LSC-TeamMembersHeadline"} = $LSC{TEXT}{Stats}{Team}[0]." ".$values->{"LSC-TeamMembersSmall"} if $values->{"LSC-TeamMembersSmall"};
			 
	$values->{"LSC-TeamVote"} = Vote_TeamIndikator($TeamID);


	
	$values->{"LSC-TeamVerwarnung"} = TeamVerwarnt($TeamID);
	$values->{"LSC-TeamVerwarnung"} = $LSC{TEXT}{Stats}{Team}[1]." ".$values->{"LSC-TeamVerwarnung"} if $values->{"LSC-TeamVerwarnung"};
	# men
	$values->{"LSC-MenueStats"} = ShowLink({Name=>$LSC{TEXT}{Stats}{Team}[3], Script=>$scriptname, Action=>"TeamStatistics", Action2=>"Statistic", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	$values->{"LSC-MenueRoster"} = ShowLink({Name=>"Roster", Script=>$scriptname, Action=>"TeamStatistics", Action2=>"", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	$values->{"LSC-MenueMembers"} = ShowLink({Name=>$LSC{TEXT}{Stats}{Team}[2], Script=>$scriptname, Action=>"TeamStatistics", Action2=>"Members", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	$values->{"LSC-MenueResults"} = ShowLink({Name=>$LSC{TEXT}{Stats}{Team}[4], Script=>$scriptname, Action=>"TeamStatistics", Action2=>"Results", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	$values->{"LSC-MenueLeagues"} = ShowLink({Name=>$LSC{TEXT}{Stats}{Team}[5], Script=>$scriptname, Action=>"TeamStatistics", Action2=>"Leagues", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	$values->{"LSC-MenuePunish"} = ShowLink({Name=>$LSC{TEXT}{Stats}{Team}[6], Script=>$scriptname, Action=>"TeamStatistics", Action2=>"Punish", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	$values->{"LSC-MenueNews"} = "";
	if ($LSC{Team_News}) {
		$values->{"LSC-MenueNews"} = ShowLink({Name=>"Team-News", Script=>$scriptname, Action=>"TeamStatistics", Action2=>"News", Special=>$TeamID, League=>$LSC{League}, Class=>"TeamP"});
	}

	$values->{"LSC-CoachDiary"} = "";
	if ($LSC{PlayerStats} && $LSC{PlayerCoachHP}) {
		$values->{"LSC-CoachDiary"} = ShowLink({Name=>"Coach", Script=>$scriptname, Action=>"CoachDiary", Action2=>$TeamID, Special=>"", League=>$LSC{League}, Class=>"TeamP"});
	}
	# fordern
		$values->{"LSC-Fordern"} = "";
		if ($LSC{League}) {
			my $ChiefTeam = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || LeaderFuerEinTeamInLiga($LSC{userid}, $LSC{League});
			if ($TeamSpieltInLiga && $TeamStatus ==0 && $TeamLigaStatus==0 &&  $LSC{Forderungen}{S} && 
				$LSC{League} && $ChiefTeam && ($ChiefTeam != $TeamID)) {
					$values->{"LSC-Fordern"} = $q->start_form(-method=>'post', -action=>"$LSC{user_pl}?League=$LSC{League}&Action=TeamFordern", -target=>($LSC{ForderungNeuesFenster} ? "_blank" : "")).
						$q->hidden('Team1', $ChiefTeam).
						$q->hidden('Team2', $TeamID).
						$q->hidden('neu', 1).
						$q->image_button(-name=>"Fordern", -src=>$LSC{imagepfad}."/lsc_fordern.gif", align=>"middle").
						$q->end_form();
			}
		}
		#beim nchsten Update: Forderungen anzeigen
	# /fordern
	$values->{"LSC-Message"} = MessageLink({To=>"/Game:".$values->{"LSC-Teamname"}});
	if (!TeamSpieltInLiga($TeamID)) {
		$values->{"LSC-TeamIDStats"} = "";
	}
	print TemplateShow($LSC{Templates}{'TeamHauptseite'}, $values);
	
	if ($LSC{PlayerStats} && $Action eq "") {
		PlayerStarting5Anzeigen($TeamID);
		print "<br>";
		$LSC{special2} = $TeamID;
		PlayerStatsLiga($Action,$special,1);
		#PlayerEinesTeamsZeigen($TeamID, 2);
		$LSC{lsc_news_table} = 'lsc_team_news';
		$LSC{lsc_news_comments_table} = 'lsc_team_news_comments';
		if ($LSC{AllowAction} && $LSC{userteamid}==$TeamID) {
			$LSC{NewsAdmin} = 1;
		}

		$LSC{special} = $TeamID;
		print '<br><div class=Headline>Team-News</div>';
		NewsAnzeigen($TeamID,3);

	} elsif ($Action eq "Spielplan") {
		if ($LSC{LeagueData}{Spielplan}) {
			SpielplanAnzeigenTeam($TeamID);
		} else {
			print "Fr diese Liga steht kein Spielplan zur Verfgung".br;
		}
	} elsif ($Action eq "Leagues") {
		my $Template = TemplateLoad1($LSC{Templates}{'TeamLigen'});
		unless ($Template) {
			print "Konnte Template nicht laden! ($!)".br;
print '</td></tr></table>';
			return;
		}

		my %Leagues = AlleLigenInDenenTeamSpielt($TeamID, 1); #Ligen mit Status laden

		my @images = ("lsc_tendenz_dummy.gif", "lsc_tendenz_up.gif", "lsc_tendenz_down.gif", "lsc_tendenz_no.gif");
 
		print TemplateMaker($Template->{'OffeneLigen'}, {});
		foreach (keys %Leagues) {
			if ($Leagues{$_}->{Status} == 1) {
				my $values = "TeamLeagues-".$_;
				$values->{"LSC-TeamLink"} = TeamLink({Name=>$Leagues{$_}->{Name}, ID=>$TeamID, HideVote=>1, League=>$_});
				$values->{"LSC-TeamRank"}				= $Leagues{$_}->{Rank};
				$values->{"LSC-TeamLigaPunkte"}			= $Leagues{$_}->{LP};
				$values->{"LSC-TeamSiege"}				= $Leagues{$_}->{Won};
				$values->{"LSC-TeamUnentschieden"}		= $Leagues{$_}->{Draw};
				$values->{"LSC-TeamNiederlagen"}		= $Leagues{$_}->{Lost};
				$values->{"LSC-TeamLigaPunkte"}			= $Leagues{$_}->{LP};
				$values->{"LSC-TeamTendenz"}			= $images[$Leagues{$_}->{CurrentStreak} || 0];
				$values->{"LSC-TeamTendenz"}			= '<IMG SRC="'.$LSC{imagepfad}.'/'.$values->{"LSC-TeamTendenz"}.'" WIDTH="10" HEIGHT="14" BORDER=0 ALT="">' if $values->{"LSC-TeamTendenz"}; 
				print TemplateMaker($Template->{'Liga'}, $values);
			}
		}
		print TemplateMaker($Template->{'Bottom'}, {});

		print TemplateMaker($Template->{'GeschlosseneLigen'}, {});
		foreach (keys %Leagues) {
			if ($Leagues{$_}->{Status} == 2) {
				my $values = "TeamLeagues-".$_;
				$values->{"LSC-TeamLink"} = TeamLink({Name=>$Leagues{$_}->{Name}, ID=>$TeamID, HideVote=>1, League=>$_});
				$values->{"LSC-TeamRank"}				= $Leagues{$_}->{Rank};
				$values->{"LSC-TeamLigaPunkte"}			= $Leagues{$_}->{LP};
				$values->{"LSC-TeamSiege"}				= $Leagues{$_}->{Won};
				$values->{"LSC-TeamUnentschieden"}		= $Leagues{$_}->{Draw};
				$values->{"LSC-TeamNiederlagen"}		= $Leagues{$_}->{Lost};
				$values->{"LSC-TeamLigaPunkte"}			= $Leagues{$_}->{LP};
				$values->{"LSC-TeamTendenz"}			= "";
				print TemplateMaker($Template->{'Liga'}, $values);
			}
		}
		print TemplateMaker($Template->{'Bottom'}, {});

	} elsif ($Action eq "Results") {
		Require("LSCErgebnisse.out.pm");
	
		if ($LSC{LeagueData}{Spielplan}) {
			SpielplanAnzeigenTeam($TeamID);
			print br.br;
			GamesOverview(1,$TeamID,5, 'Last 5');
		} else {
			GamesOverview(1,$TeamID,30, 'Last 30');
		}
	} elsif ($Action eq "Punish") {
		Require("LSCStrafpunkte.pm");
		StrafpunkteTeamZeigen($TeamID);

	} elsif ($Action eq "Members") {
		my $Template = TemplateLoad1($LSC{Templates}{'TeamMembers'});
		unless ($Template) {
			print "Konnte Template nicht laden! ($!)".br;
print '</td></tr></table>';
			return;
		}

		my $TeamMembers = TeamMembers($TeamID);
		if ($TeamMembers) {
			print $Template->{Head};
			my $i=0;
			my $v = "Member";
			$v->{"LSC-TeamTag"} = $values->{"LSC-TeamTag"};
			foreach my $M (sort {$TeamMembers->{$b}{Status} <=> $TeamMembers->{$a}{Status}}keys %{$TeamMembers}) {
				my $layout = $i++ % 2;

				my $User = UserDatenFromUserID($M);
			
				$v->{"LSC-MemberLink"}	= UserLink($TeamMembers->{$M}{Name}, $M).MessageLink({To=>$TeamMembers->{$M}{Name}});
				$v->{"LSC-WonID"}		= $User->{WonID};
				$v->{"LSC-WonIDText"}	= "";
				if ($v->{"LSC-WonID"}) {
					$v->{"LSC-WonID"} = RemoveHtmlFromText($v->{"LSC-WonID"});
					$v->{"LSC-WonIDText"} = "WonID: ".$v->{"LSC-WonID"};
				}
				$v->{"LSC-JoinDate"}	= $TeamMembers->{$M}{Date};
				$v->{"LSC-Status"} = "";
				if (defined($TeamMembers->{$M}{Status})) {
					$v->{"LSC-Status"} = $LSC{MemberStatus}{$TeamMembers->{$M}{Status}};
				}
				print TemplateMaker($Template->{"MembersZeile".($layout+1)}, $v);
			}
			print $Template->{Bottom};
		} else {
			
			print $Template->{NoMembers};
		}

	} elsif ($Action eq "News" && $LSC{Team_News}) {
		$LSC{lsc_news_table} = 'lsc_team_news';
		$LSC{lsc_news_comments_table} = 'lsc_team_news_comments';
		if ($LSC{AllowAction} && $LSC{userteamid}==$TeamID) {
			$LSC{NewsAdmin} = 1;
		}
		print '<div class=Headline>Team-News</div>';
		NewsAnzeigen($TeamID,3);
	} elsif (!$Action || $Action eq "Statistic") {
		Require("LSCPoints.pm");
		my $D = Points_PunkteLaden($TeamID, $LSC{League});
		unless ($D) {
			print "keine Statistiken Verfgbar.".br;
print '</td></tr></table>';
			return;
		}

		# Werte fr Template aufbereiten:
		my $Stats = "Stats";
		foreach  (keys %{$D}) {
			$Stats->{"LSC-".$_} = $D->{$_};
		}
		
		my @wld = ("-", $LSC{TEXT}{Ergebnisse}[15], $LSC{TEXT}{Ergebnisse}[16], $LSC{TEXT}{Ergebnisse}[17]);
		$Stats->{"LSC-CurrentStreak"} = $wld[$Stats->{"LSC-CurrentStreak"}];
		$Stats->{"LSC-CurrentStreakC"} = "" unless $Stats->{"LSC-CurrentStreakC"};
		
		Require("LSCErgebnisse2.get.pm");

		#Ergebnis links erstellen
		if ($Stats->{"LSC-HighPointsGame"}) {
			my $Game = Ergebnisladen($Stats->{"LSC-HighPointsGame"});
			if ($Game) {
				my @Team1 = ();
				my @Team2 = ();
				my $team1 = "";
				my $team2 = "";
				foreach my $t1 (keys %{$Game->{home}}) {
					push @Team1, TeamLink($Game->{home}{$t1}{Name}, $t1, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team1 = $t1 unless $team1;
				}

				foreach my $t2 (keys %{$Game->{away}}) {
					push @Team2, TeamLink($Game->{away}{$t2}{Name}, $t2, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team2 = $t2 unless $team2;
				}
				
				$Stats->{"LSC-HighPointsGameTeam1"} = join("<br>", @Team1);
				$Stats->{"LSC-HighPointsGameTeam2"} = join("<br>", @Team2);
				$Stats->{"LSC-HighPointsGameRecap1"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{home}{$team1}{Points}.":".$Game->{away}{$team2}{Points});
				$Stats->{"LSC-HighPointsGameRecap2"} = RecapLink($LSC{League},$Game->{Game}{No}, $Game->{away}{$team2}{Points}.":".$Game->{home}{$team1}{Points});
			} else {
				$Stats->{"LSC-HighPointsGame"} = "-";
			}
		} else {
			$Stats->{"LSC-HighPointsGame"} = "-";
		}
		if ($Stats->{"LSC-LowPointsGame"}) {
			my $Game = Ergebnisladen($Stats->{"LSC-LowPointsGame"});
			if ($Game) {
				my @Team1 = ();
				my @Team2 = ();
				my $team1 = "";
				my $team2 = "";
				foreach my $t1 (keys %{$Game->{home}}) {
					push @Team1, TeamLink($Game->{home}{$t1}{Name}, $t1, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team1 = $t1 unless $team1;
				}

				foreach my $t2 (keys %{$Game->{away}}) {
					push @Team2, TeamLink($Game->{away}{$t2}{Name}, $t2, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team2 = $t2 unless $team2;
				}
				
				$Stats->{"LSC-LowPointsGameTeam1"} = join("<br>", @Team1);
				$Stats->{"LSC-LowPointsGameTeam2"} = join("<br>", @Team2);
				$Stats->{"LSC-LowPointsGameRecap1"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{home}{$team1}{Points}.":".$Game->{away}{$team2}{Points});
				$Stats->{"LSC-LowPointsGameRecap2"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{away}{$team2}{Points}.":".$Game->{home}{$team1}{Points});
			} else {
				$Stats->{"LSC-LowPointsGame"} = "-";
			}
		} else {
			$Stats->{"LSC-LowPointsGame"} = "-";
		}
		if ($Stats->{"LSC-HighWin"}) {
			my $Game = Ergebnisladen($Stats->{"LSC-HighWin"});
			if ($Game) {
				my @Team1 = ();
				my @Team2 = ();
				my $team1 = "";
				my $team2 = "";
				foreach my $t1 (keys %{$Game->{home}}) {
					push @Team1, TeamLink($Game->{home}{$t1}{Name}, $t1, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team1 = $t1 unless $team1;
				}

				foreach my $t2 (keys %{$Game->{away}}) {
					push @Team2, TeamLink($Game->{away}{$t2}{Name}, $t2, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team2 = $t2 unless $team2;
				}
				
				$Stats->{"LSC-HighWinTeam1"} = join("<br>", @Team1);
				$Stats->{"LSC-HighWinTeam2"} = join("<br>", @Team2);
				$Stats->{"LSC-HighWinRecap1"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{home}{$team1}{Points}.":".$Game->{away}{$team2}{Points});
				$Stats->{"LSC-HighWinRecap2"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{away}{$team2}{Points}.":".$Game->{home}{$team1}{Points});
			} else {
				$Stats->{"LSC-HighWin"} = "-";
			}
		} else {
			$Stats->{"LSC-HighWin"} = "-";
		}
		if ($Stats->{"LSC-HighLost"}) {
			my $Game = Ergebnisladen($Stats->{"LSC-HighLost"});
			if ($Game) {
				my @Team1 = ();
				my @Team2 = ();
				my $team1 = "";
				my $team2 = "";
				foreach my $t1 (keys %{$Game->{home}}) {
					push @Team1, TeamLink($Game->{home}{$t1}{Name}, $t1, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team1 = $t1 unless $team1;
				}

				foreach my $t2 (keys %{$Game->{away}}) {
					push @Team2, TeamLink($Game->{away}{$t2}{Name}, $t2, 'E',!$LSC{Vote}{S}{Ergebnisse});
					$team2 = $t2 unless $team2;
				}
				
				$Stats->{"LSC-HighLostTeam1"} = join("<br>", @Team1);
				$Stats->{"LSC-HighLostTeam2"} = join("<br>", @Team2);
				$Stats->{"LSC-HighLostRecap1"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{home}{$team1}{Points}.":".$Game->{away}{$team2}{Points});
				$Stats->{"LSC-HighLostRecap2"} = RecapLink($LSC{League}, $Game->{Game}{No}, $Game->{away}{$team2}{Points}.":".$Game->{home}{$team1}{Points});
			} else {
				$Stats->{"LSC-HighLost"} = "-";
			}
		} else {
			$Stats->{"LSC-HighLost"} = "-";
		}
		print TemplateShow($LSC{Templates}{'TeamStatistik'}, $Stats);

	}
print '</td></tr></table>';

	
	#return;

}



sub StatistikenUser {
	my $action = shift;
	my $user = shift;
	my $userid=$user;
	if (!defined($user) || $user=~/[^0-9]/ || !($user=UserDatenFromUserID($user))) {
		print $LSC{TEXT}{User}[30]; #Dieser User wurde gelscht oder existiert nicht.
		return;
	}
	my(undef, $g) = UserVerwarnt($userid);
	if ($g) {
		print $LSC{TEXT}{User}[31]; #gesperrt 
	}

	my $UserTeam = FirstUserTeamID($userid);
	my $values = "StatsUser-".$userid;
	$values->{"LSC-Username"} = $user->{Login};
	$values->{"LSC-ICQ"} = $user->{ICQ} || " - ";
	$values->{"LSC-ICQ-Online"} = $user->{ICQ} ? AddICQOnlineStatus($user->{ICQ}) : "";
	$values->{"LSC-Age"} = $user->{Age} || " - ";
	$values->{"LSC-WonID"} = $user->{WonID} || " - ";
	$values->{"LSC-WonIDLog"} = $user->{WonIDText} || " - ";

	$values->{"LSC-UserID"} = $userid;

	$values->{"LSC-Message"} = MessageLink({To=>$values->{"LSC-Username"}});

	my %Teams = AlleTeamsInDenenUserMemberIst($userid);
	$values->{"LSC-Member"} = "";
	foreach (keys %Teams) {
		$values->{"LSC-Member"} .= TeamLink("$Teams{$_}", $_, "", 1).br;
	}
	$values->{"LSC-Member"} = " - " unless 	$values->{"LSC-Member"};

	$values->{"LSC-Verwarnungen"} = "";

	my %Leagues = AlleLigenInDenenUserSpielt($userid);
	my %Ligen = ();
	
	my $verwarnungen = 0;
		foreach my $L (sort keys %Leagues) {
			my ($w) = UserVerwarnt($userid, $Leagues{$L});
			$Ligen{$Leagues{$L}} = 1;
			if ($w) {
				$verwarnungen = 1;
				$values->{"LSC-Verwarnungen"} .= "<b>$L:</b><br>$w<br><br>\n";
			}
		}
	foreach my $Team (keys %Teams) {
		%Leagues=AlleLigenInDenenTeamSpielt($Team);
		foreach my $L (sort keys %Leagues) {
			my ($w) = UserVerwarnt($userid, $Leagues{$L});
			if ($w && !$Ligen{$Leagues{$L}}) {
				$verwarnungen = 1;
				$values->{"LSC-Verwarnungen"} .= "<b>$L:</b><br>$w<br><br>\n";
			}
			$Ligen{$Leagues{$L}} = 1;
		}
	}
			

	unless($verwarnungen) {
		$values->{"LSC-Verwarnungen"} = " - ";
	}


	print TemplateShow($LSC{Templates}{'User'}, $values);

	StatistikenTeam("", $UserTeam);
}


sub StatistikenGegner {
	#TeamID
	my ($Teamname, $UserID) = TeamnameAndUserFromTeamIDAndLeague($_[0], $LSC{League});
	unless ($Teamname) {
		print "Keine Stats vorhanden";
		return;
	}
	print "Opponent Statistics for $Teamname".hr;
	my ($select,$from,$where,$group,$order);




	$select	= "T.Name as Gegner, G2.Team";
	$select.= ", SUM(G1.Points), SUM(G2.Points), SUM(G1.Won), SUM(G1.Lost), SUM(G1.Draw)";

	$from	= $Select{Game}{From};
	$from .= " $Select{Game}{JoinG2}";
	$from .= " $Select{Game}{JoinTeam2}";

	$where	= "G1.Team=$_[0] and $Select{Game}{Where}";
	$where =~s/\#LEAGUE/$LSC{League}/gg;

	$group	= "Group by G2.Team";
	$order	= "Order by Gegner ";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();

	my @Opponents;
	while (my $ref = $sth->fetchrow_arrayref()) {
		push(@Opponents, $ref->[1]);
		my $TeamLink = TeamLink($ref->[0], $ref->[1], '');
		print "<b>".$TeamLink.":</b>".br;
		print "&nbsp;Total-Points: $ref->[2]:$ref->[3]";
		if ($ref->[4]) {
			print "<br>&nbsp; $ref->[4] Victories";
		}
		if ($ref->[5]) {
			print "<br>&nbsp; $ref->[5] Defeats";
		}
		if ($ref->[6]) {
			print "<br>&nbsp; $ref->[6] Draws";
		}
		print br.br;
	}
	$sth->finish;
	if ($LSC{LeagueData}{MJoin} == 1) {
		$Gegnerliste = join(',',@Opponents);
		$select	= "T.Name, T.ID";
		$from	= "lsc_teams T, lsc_teams_league L";
		$where	= "L.League=$LSC{League} and T.ID=L.Team and T.ID NOT IN ($Gegnerliste, $_[0])";
		$group	= "";
		$order	= "Order by Name";
#print "SELECT $select FROM $from WHERE $where $group $order".br;
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
		$sth->execute();
		print "Not played against:".br;
		while (my $ref = $sth->fetchrow_arrayref()) {
			print $ref->[0].br;
		}
		$sth->finish;
	}
	
	print br.br;
	
}

1;
