
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################


if ($LSC{Funktionen} && $LSC{Funktionen} eq "user") {
	$funktionen{'JoinLeagueWaitlist'} = \&JoinLeagueWaitlist;
	$funktionen{'ShowWaitlist'} = \&ShowWaitlist;
}

sub JoinLeagueWaitlist {
	if ($LSC{LeagueData}{Status} == 1 && !$LSC{userteamid} && $LSC{LeagueData}{MJoin} == 1 && $LSC{LeagueData}{WaitlistID}) {
		if ($q->param("delete")) {
			my ($anzahl, $teams) = AnzahlTeamsUndNamenID($LSC{userid});
			if ($anzahl > 0) {
				my @teams = ();
				foreach my $t (@{$teams}) {
					push (@teams, $t->[0]);
				}
				my $sthg = $LSC{MySQL}->do("delete lsc_leagues_waitlist_entries where WaitlistID=$LSC{LeagueData}{WaitlistID} and Team in \"".join(",", @teams)."\"");
			}
			print $LSC{TEXT}{show}[13].br;
			return;
		}
		if (!$q->param('Team') ||  $q->param('Team')=~/[^0-9]/) {
			print "Es ist ein Fehler beim ermitteln deiner TeamID aufgetrehten. Bitte wende Dich an einen
			Admin.".br;
			return;
		}
		my $Team = TeamDatenLaden($q->param('Team'));
		unless ($Team) {
			print "Es konnten keine Daten fr dieses Team geladen werden.".br;
			return;
		}
		if ($Team->{User} ne $LSC{userid} and !IstLeaderVonTeam($LSC{userid}, $q->param('Team'))) {
			print $LSC{TEXT}{ERROR}[4].br; #Dieses Team gehrt Dir nicht
			return;
		}
		if ($Team->{PrivateTeam} eq "1") {
			print $LSC{TEXT}{ERROR}[5].br; #privateteam
			return;
		}

		my $sthg = $LSC{MySQL}->do("insert into lsc_leagues_waitlist_entries (WaitlistID, TeamID, Date) Values ($LSC{LeagueData}{WaitlistID}, ".$LSC{MySQL}->quote($q->param('Team')).", now())");

		print $LSC{TEXT}{show}[10].br;
		return;
	} 
	
	print $LSC{TEXT}{ERROR}[7].br;
	 
}
sub AufWarteLIste {
	my $TeamID = shift;
	my $Waitlist = shift;

	my $sthg = $LSC{MySQL}->prepare("select count(TeamID) from lsc_leagues_waitlist_entries where WaitlistID=$Waitlist and TeamID=".$LSC{MySQL}->quote($TeamID));
	$sthg->execute();
	my $gr = $sthg->fetchrow_arrayref();
	$sthg->finish;

	return $gr && $gr->[0] > 0 ? 1 : 0;
}

sub ShowWaitlist {

		my $s = $LSC{MySQL}->prepare("select Name, Comment, Public from lsc_leagues_waitlist where ID=$LSC{LeagueData}{WaitlistID}");
		$s->execute();
		my $wl = $s->fetchrow_arrayref();
		$s->finish;
		unless ($wl || $wl->[0]) {
			print "unknown wailtist";
			return;
		}

		print "<div class=Headline>$wl->[0]</div>";
		print "<table><tr><td></td><td>$wl->[1]</td></tr></table>".br;

		if ($wl->[2] || $LSC{UserStatus}==9) {
			print "<table cellspacing=0 width=450>";
			print "<tr><td class=Std1>$LSC{TEXT}{waitlist}[0]</td><td class=Std1>&nbsp;&nbsp;$LSC{TEXT}{waitlist}[1]&nbsp;&nbsp;</td><td class=Std1>&nbsp;$LSC{TEXT}{waitlist}[4]</td><td class=Std1>&nbsp;$LSC{TEXT}{waitlist}[2]</td></tr>";

			my $index=0;
			my $sthg = $LSC{MySQL}->prepare("select Name, TeamID, Date from lsc_leagues_waitlist_entries w, lsc_teams t where	 w.WaitlistID=$LSC{LeagueData}{WaitlistID} and w.TeamID=t.ID order by Date");
			$sthg->execute();
			while (my $gr = $sthg->fetchrow_arrayref()) {
				$index++;
				print "<tr><td class=Std2>$index.</td><td class=Std2>".TeamLink($gr->[0], $gr->[1], "", 1)."</td><td class=Std2>".TeamMemberCount($gr->[1])."</td><td class=Std2>$gr->[2]</td></tr>";
			}
			$sthg->finish;
			unless ($index) {
				print "<tr><td class=Std2></td><td class=Std2>no entries</td><td class=Std2></td></tr>";

			}
			print "</table>";
			return;
		}
	

		print $LSC{TEXT}{waitlist}[3];
}
1