#!/usr/bin/perl -w


###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw(%LSC %Select $LSCPackagePfad $q $scriptname);
require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 1;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();

require $LSCPackagePfad."LSCInit.pm";
$LSC{TeamSeitenKeinPopUp}	= 0;
$LSC{ErgebnisseImPopUp}		= 1;
$LSC{UserSeitenImPopUp}		= 1;
$LSC{ForderungNeuesFenster}	= 1;

# Main #
&LayoutPopupEins;

if ($q->cgi_error) {
	print $LSC{TEXT}{ERROR}[10].br;
} else {
	r_main();
}
&LayoutPopupZwei;
MySQLDisconnect($LSC{MySQL}); #in Init initialisiert
# /Main #
exit(0);
sub r_main {
	if ($LSC{ligavorhanden}) {
		if ($LSC{Action} eq 'Statistic' && $LSC{special} && !($LSC{special}=~/[^0-9]/)) {
			Require("LSCstatistik.pm");
			StatistikenTeam($LSC{Action2}, $LSC{special});
			return;
		} elsif ($LSC{Action} eq 'Opponent' && $LSC{Action2} && !($LSC{Action2}=~/[^0-9]/)) {
			Require("LSCstatistik.pm");
			StatistikenGegner($LSC{Action2}, $LSC{special});
			return;
		} elsif ($LSC{Action} eq 'TeamFordern') {
			MSGFordern($LSC{Action2} || 'new', $LSC{special} || $q->param('GefordertesTeam'));
			return;
		}
		print "Diese Funktion wird im FensterModus nicht untersttzt!";
		return;
	} elsif ($LSC{special} && !($LSC{special}=~/[^0-9]/)) {
		Require("LSCstatistik.pm");
		StatistikenTeam($LSC{Action2}, $LSC{special});
		return;
	}

	
	print "unbekanntes Team!";
}
sub x {	print $scriptname; print $q;}
