#!/usr/bin/perl -w


###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw(%LSC %Select $LSCPackagePfad $q $scriptname);

require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 1;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();


require $LSCPackagePfad."LSCInit.pm";
# Main #
&LayoutEins;
if ($q->cgi_error) {
	print $LSC{TEXT}{ERROR}[10].br;
} else {
	
	print <<"ende";
<table width=100%>
<tr>
<td class=Headline><b>LigaScript - lost password:</b>
</td>
</tr>
<tr>
<td class=Headline>Passwort vergessen?<br>
Kein Problem! Einfach folgendes Formular ausfllen und Du bekommst per Email einen Link zugeschickt, mit dem Du dein neues Passwort freischalten kannst
</td>
</tr>
</table>
ende
	if ($LSC{Action} eq 'unlock') {
		unlock();
	} elsif ($LSC{Action} eq 'save') {
		save();
	} else {
		Form();
	}
}
&LayoutZwei;

MySQLDisconnect($LSC{MySQL}); #in Init initialisiert

# /Main #
sub unlock {
	if ($q->param('User') && $q->param('Key')) {
		my $newpw;
		if ($q->param('User')=~/[^0-9]/) {
			print "Unbekannte User-ID".br;
		} elsif (!($newpw = UserKeyOK($q->param('User'), $q->param('Key')))) {
			print "Dieser Key ist nicht mehr aktuell!".br;
		} else {
			$newpw = $LSC{MySQL}->quote($newpw);
			my $do = "update lsc_user set Password=$newpw where UserID=".$q->param('User');
			my $sth = $LSC{MySQL}->prepare($do);
			$sth->execute();
			$sth->finish;

			$do = "delete from lsc_user_newpw where UserID=".$q->param('User');
			$sth = $LSC{MySQL}->prepare($do);
			$sth->execute();
			$sth->finish;			
			print "Das Passwort wurde gendert.".br;
			print "Einloggen kannst du dich unter <a
				href=$LSC{HomepageURL}>$LSC{HomepageURL}</a>.".br;
		}
	} else {
		print "Es konnten nicht alle bentigten Daten gefunden werden. Bitte wende dich an eine Admin.".br;
	}
}
sub UserKeyOK {
	my $user = shift;
	my $key = $LSC{MySQL}->quote(shift);
	
	my ($select,$from,$where,$group,$order);
	$select	= "NewPassword";
	$from	= "lsc_user_newpw";
	$where	= "UserID='$user' and AKey=$key";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where");
	$sth->execute();
	my $ref = $sth->fetchrow_arrayref();
	$sth->finish;	
	
	return $ref->[0] ? $ref->[0] : '';
}

sub save {
	my $ok = 1;
	foreach my $F (qw(Loginname Passwort1 Passwort2)) {
		unless ($q->param($F)) {
			$ok = 0;
			print "Das Feld $F muss ausgefllt werden".br;
		}
	}
	if ($q->param('Passwort1') ne $q->param('Passwort2')) {
		$ok = 0;
		print "Passwrter stimmern nicht berein.".br;
	}
	if (length($q->param('Passwort1')) > 10) {
		$ok = 0;
		print "Passwort ist zu lang (max. 10).".br;
	}
	my ($userid, $status) = UserIdundStatusVonName($q->param('Loginname'));
	unless ($userid) {
		$ok = 0;
		print "Unbekannter Loginname.".br;
	}
	unless ($ok) {
			return Form();
	}
	
	#Speichern
	my $SessionID = $ENV{UNIQUE_ID} || crypt(time(), $LSC{cryptpass})."abc";
	$SessionID =~tr/\//x/;
	my $passwort = crypt($q->param('Passwort1'), $LSC{cryptpass});
	my $do = "replace into lsc_user_newpw
		(UserID, AKey, NewPassword) Values
		('$userid', '$SessionID', '$passwort')";
	my $sth = $LSC{MySQL}->prepare($do);
	$sth->execute();
	$sth->finish;
	my $Text = <<"ende";
Hallo,
fr deinen Account wurde gerade ein neues Passwort eingetragen.
Wenn Du es nun aktivieren mchtest, dann klicke auf folgenden Link:
$LSC{ScriptURL}user.lostpassword.pl?User=$userid&Key=$SessionID&Action=unlock

Solltest Du kein neues Passwort eingetragen haben, dann ignoriere
diese Email einfach.

Solltest du hufiger diese Email erhalten, obwohl du kein neues
Passwort eingetragen hast, dann schicke eine Nachricht an einen 
Admin.


ende
	my $user = UserKontaktDatenFromUserID($userid);
	email ($LSC{lostpasswordEmail}, $user->{Email}, 'LigaScript LostPassword', 
					$LSC{Email}, $Text);
	print "In wenigen Sekunden erhlst Du eine Email mit weiteren Informationen.".br;		
}




sub Form {
my $l = $q->textfield('Loginname', '', 20);
my $p1 =$q->password_field('Passwort1','',10);
my $p2 =$q->password_field('Passwort2','',10);

print <<"ende";
<table>
<tr>
<td><div>
<form ACTION="user.lostpassword.pl?Action=save" METHOD="post">
Nick- Loginname:<br>
$l
<br>
Neues Passwort:<br>
$p1<br>
Neues Passwort wiederholen:<br>
$p2<br>
<br>
<input TYPE="submit" NAME="submit" VALUE="submit">
</div>
</form>
</td>
</tr>
</table>

ende
}
