#!/usr/bin/perl -w


###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw(%LSC %Select $LSCPackagePfad $q $scriptname);

require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 1;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();


require $LSCPackagePfad."LSCInit.pm";
# Main #
&LayoutEins;
if ($q->cgi_error) {
	print $LSC{TEXT}{ERROR}[10].br;
} else {
	print <<"ende";
<table width=100%>
<tr>
<td class=Headline><b>LigaScript Registrierung:</b><br>
Hier kannst Du Dich fr den Userbereich des LigaScripts registrieren.<br>
</td>
</tr>
</table>
ende
	if ($q->param('submit')) {
		my $ok = 1;
		foreach my $F (qw(Loginname Vorname Nachname Email Passwort1 Passwort2)) {
			unless ($q->param($F)) {
				$ok = 0;
				print "Das Feld $F muss ausgefllt werden".br;
			}
		}
		unless (UsernameOK($q->param('Loginname'))) {
			$ok = 0;
		}
		if ($q->param('Email')=~/[^a-zA-Z0-9\@\.\-_]/) {
			$ok = 0;
			print "Ungltige Zeichen in der Emailadresse".br;
		}
		if ($ok && $q->param('Email') && UserVonEmailAdresse($q->param('Email'))) {
			$ok = 0;
			print "Unter dieser Emailadresse wurde bereits ein Account angelegt.".br;
		}
		if ($q->param('Passwort1') ne $q->param('Passwort2')) {
			$ok = 0;
			print "Passwrter stimmern nicht berein.".br;
		}
		if (length($q->param('Passwort1')) > 10) {
			$ok = 0;
			print "Passwort ist zu lang (max. 10).".br;
		}
		if ($q->param('Vorname')=~/[^\w ]/ || $q->param('Nachname')=~/[^\w ]/) {
			$ok = 0;
			print "Vor- und Nachname drfen nur Buchstaben enthalten.".br;
		}
		if ($LSC{Registrierung}{ICQ} && !$q->param('ICQ')) {
			$ok = 0;
			print "Bitte gebe eine Richtige ICQ Nummer an.".br;
		}			
		if ($q->param('ICQ') && ($q->param('ICQ')=~/[^0-9]/ || $q->param('ICQ') < 100)) {
			$ok = 0;
			print "Bitte gebe eine Richtige ICQ Nummer an.".br;
		}
		if ($LSC{Registrierung}{WonID} && !$q->param('WonID')) {
			$ok = 0;
			print "Eine $LSC{TEXT}{default}[3] muss angegeben werden.".br;
		}
		if ($q->param('WonID') && $q->param('WonID')=~/[^0-9\:]/) {
			$ok = 0;
			print "Die $LSC{TEXT}{default}[3] darf nur aus Zahlen bestehen.".br;
		}
		if ($ok) {
			#Speichern
			my $SessionID = $ENV{UNIQUE_ID} || crypt(time(), $LSC{cryptpass})."abc";
			$SessionID =~tr/\//x/;
			my $passwort = crypt($q->param('Passwort1'), $LSC{cryptpass});
			my $do = "";
			my $sth = $LSC{MySQL}->prepare("insert into lsc_user 
				(Login, Firstname, Lastname, Email, ICQ, Registered, Password, Status, WonID) Values
				(?, ?, ?, ?, ?, now(), ?, 0, ?)");
			$sth->execute($q->param('Loginname'), $q->param('Vorname'), $q->param('Nachname'), $q->param('Email'), ($q->param('ICQ') || ""), $passwort, ($q->param('WonID') || ""));
			my $UserID = $sth->{mysql_insertid};
			$sth->finish;
			$do = "replace into lsc_user_key
				(UserID, AKey) Values
				('$UserID', '$SessionID')";
			$sth = $LSC{MySQL}->prepare($do);
			$sth->execute();
			$sth->finish;
			my $name = $q->param('Vorname');
			my $Text = <<"ende";
Hallo $name,
Du hast Dich gerade auf $LSC{HomepageURL} fr den
Userbereich des LigaScripts registriert.

Damit dein Account freigeschaltet werden kann, klicke
auf folgenden Link:
$LSC{ScriptURL}$LSC{user_unlock_pl}?User=$UserID&Key=$SessionID

ende
			email ($LSC{regEmail}, $q->param('Email'), 'LigaScript Registrierung', 
					$LSC{Email}, $Text);
			email ($LSC{regEmail}, $LSC{regEmail}, 'LigaScript Registrierung', 
					$LSC{Email}, "Information vom LigaScript:\nFolgende Email wurde gerade
					verschickt:\n\n".
					$Text."\nEmail:".$q->param('Email'));
			print "In wenigen Sekunden erhlst Du eine Email mit weiteren Informationen.".br;		
		} else {
			Form();
		}
	
	} else {
		Form();
	}
}
&LayoutZwei;

MySQLDisconnect($LSC{MySQL}); #in Init initialisiert

# /Main #



sub Form {
my $l = $q->textfield('Loginname', '', 20);
my $v = $q->textfield('Vorname', '', 20);
my $n = $q->textfield('Nachname', '', 30);
my $e = $q->textfield('Email', '', 30);
my $i = $LSC{Registrierung}{ICQ} ? "ICQ UIN:<br>".$q->textfield('ICQ', '', 15)."<br>Die ICQ UIN wird auf der Homepage fr die Kontaktaufnahme angezeigt.<br>" : "";
my $wonid = $LSC{Registrierung}{WonID} ? "$LSC{TEXT}{default}[3]:<br>".$q->textfield('WonID', '', 10).br.br : "";
my $p1 =$q->password_field('Passwort1','',10);
my $p2 =$q->password_field('Passwort2','',10);

my $script = $LSC{user_new_pl};
print <<"ende";
<table>
<tr>
<td><div>
<form ACTION="$script" METHOD="post">
Nick- Loginname:<br>
$l
<br>
Vorname/Name:<br>
$v
<br>
Nachname/Surname:<br>
$n
<br><br>
Email:<br>
$e<br>
Die Emailadresse wird bei deinen Statistiken angezeigt.<br>
<br>
$i
<br>
$wonid
Passwort:<br>
$p1<br>
Passwort wiederholen:<br>
$p2<br>
<br>
$LSC{TEXT}{Registrierung}
<br>
<br>
<input TYPE="submit" NAME="submit" VALUE="registrieren">
</div>
</form>
</td>
</tr>
</table>

ende
}
sub x {	print $scriptname;}

